/* Generated automatically by the program `genopinit'
   from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "tree.h"
#include "rtl.h"
#include "alias.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "memmodel.h"
#include "tm_p.h"
#include "flags.h"
#include "insn-config.h"
#include "expmed.h"
#include "dojump.h"
#include "explow.h"
#include "emit-rtl.h"
#include "stmt.h"
#include "expr.h"
#include "insn-codes.h"
#include "optabs.h"

struct optab_pat {
  unsigned scode;
  enum insn_code icode;
};

static const struct optab_pat pats[NUM_OPTAB_PATTERNS] = {
  { 0x010405, CODE_FOR_extendqihi2 },
  { 0x010406, CODE_FOR_extendqisi2 },
  { 0x010407, CODE_FOR_extendqidi2 },
  { 0x010506, CODE_FOR_extendhisi2 },
  { 0x010507, CODE_FOR_extendhidi2 },
  { 0x010607, CODE_FOR_extendsidi2 },
  { 0x011b1c, CODE_FOR_extendsfdf2 },
  { 0x011b1d, CODE_FOR_extendsftf2 },
  { 0x011c1d, CODE_FOR_extenddftf2 },
  { 0x021c1b, CODE_FOR_truncdfsf2 },
  { 0x021d1b, CODE_FOR_trunctfsf2 },
  { 0x021d1c, CODE_FOR_trunctfdf2 },
  { 0x030405, CODE_FOR_zero_extendqihi2 },
  { 0x030406, CODE_FOR_zero_extendqisi2 },
  { 0x030407, CODE_FOR_zero_extendqidi2 },
  { 0x030506, CODE_FOR_zero_extendhisi2 },
  { 0x030507, CODE_FOR_zero_extendhidi2 },
  { 0x030607, CODE_FOR_zero_extendsidi2 },
  { 0x06071b, CODE_FOR_floatdisf2 },
  { 0x06071c, CODE_FOR_floatdidf2 },
  { 0x06071d, CODE_FOR_floatditf2 },
  { 0x07071b, CODE_FOR_floatunsdisf2 },
  { 0x07071c, CODE_FOR_floatunsdidf2 },
  { 0x07071d, CODE_FOR_floatunsditf2 },
  { 0x101b07, CODE_FOR_fix_truncsfdi2 },
  { 0x101c07, CODE_FOR_fix_truncdfdi2 },
  { 0x101d07, CODE_FOR_fix_trunctfdi2 },
  { 0x111b07, CODE_FOR_fixuns_truncsfdi2 },
  { 0x111c07, CODE_FOR_fixuns_truncdfdi2 },
  { 0x111d07, CODE_FOR_fixuns_trunctfdi2 },
  { 0x130708, CODE_FOR_umulditi3 },
  { 0x2d0006, CODE_FOR_addsi3 },
  { 0x2d0007, CODE_FOR_adddi3 },
  { 0x2d001b, CODE_FOR_addsf3 },
  { 0x2d001c, CODE_FOR_adddf3 },
  { 0x2d001d, CODE_FOR_addtf3 },
  { 0x2e0006, CODE_FOR_addvsi3 },
  { 0x2e0007, CODE_FOR_addvdi3 },
  { 0x310006, CODE_FOR_subsi3 },
  { 0x310007, CODE_FOR_subdi3 },
  { 0x31001b, CODE_FOR_subsf3 },
  { 0x31001c, CODE_FOR_subdf3 },
  { 0x31001d, CODE_FOR_subtf3 },
  { 0x320006, CODE_FOR_subvsi3 },
  { 0x320007, CODE_FOR_subvdi3 },
  { 0x350006, CODE_FOR_mulsi3 },
  { 0x350007, CODE_FOR_muldi3 },
  { 0x35001b, CODE_FOR_mulsf3 },
  { 0x35001c, CODE_FOR_muldf3 },
  { 0x35001d, CODE_FOR_multf3 },
  { 0x360006, CODE_FOR_mulvsi3 },
  { 0x360007, CODE_FOR_mulvdi3 },
  { 0x390006, CODE_FOR_divsi3 },
  { 0x390007, CODE_FOR_divdi3 },
  { 0x39001b, CODE_FOR_divsf3 },
  { 0x39001c, CODE_FOR_divdf3 },
  { 0x39001d, CODE_FOR_divtf3 },
  { 0x3c0006, CODE_FOR_udivsi3 },
  { 0x3c0007, CODE_FOR_udivdi3 },
  { 0x400006, CODE_FOR_modsi3 },
  { 0x400007, CODE_FOR_moddi3 },
  { 0x410006, CODE_FOR_umodsi3 },
  { 0x410007, CODE_FOR_umoddi3 },
  { 0x430007, CODE_FOR_anddi3 },
  { 0x43002b, CODE_FOR_andv8qi3 },
  { 0x43002c, CODE_FOR_andv4hi3 },
  { 0x43002d, CODE_FOR_andv2si3 },
  { 0x440007, CODE_FOR_iordi3 },
  { 0x44002b, CODE_FOR_iorv8qi3 },
  { 0x44002c, CODE_FOR_iorv4hi3 },
  { 0x44002d, CODE_FOR_iorv2si3 },
  { 0x450007, CODE_FOR_xordi3 },
  { 0x45002b, CODE_FOR_xorv8qi3 },
  { 0x45002c, CODE_FOR_xorv4hi3 },
  { 0x45002d, CODE_FOR_xorv2si3 },
  { 0x460007, CODE_FOR_ashldi3 },
  { 0x490007, CODE_FOR_ashrdi3 },
  { 0x4a0007, CODE_FOR_lshrdi3 },
  { 0x520004, CODE_FOR_sminqi3 },
  { 0x520005, CODE_FOR_sminhi3 },
  { 0x520007, CODE_FOR_smindi3 },
  { 0x52001b, CODE_FOR_sminsf3 },
  { 0x52001c, CODE_FOR_smindf3 },
  { 0x52002b, CODE_FOR_sminv8qi3 },
  { 0x52002c, CODE_FOR_sminv4hi3 },
  { 0x530004, CODE_FOR_smaxqi3 },
  { 0x530005, CODE_FOR_smaxhi3 },
  { 0x530007, CODE_FOR_smaxdi3 },
  { 0x53001b, CODE_FOR_smaxsf3 },
  { 0x53001c, CODE_FOR_smaxdf3 },
  { 0x53002b, CODE_FOR_smaxv8qi3 },
  { 0x53002c, CODE_FOR_smaxv4hi3 },
  { 0x540004, CODE_FOR_uminqi3 },
  { 0x540005, CODE_FOR_uminhi3 },
  { 0x540007, CODE_FOR_umindi3 },
  { 0x54002b, CODE_FOR_uminv8qi3 },
  { 0x54002c, CODE_FOR_uminv4hi3 },
  { 0x550004, CODE_FOR_umaxqi3 },
  { 0x550005, CODE_FOR_umaxhi3 },
  { 0x550007, CODE_FOR_umaxdi3 },
  { 0x55002b, CODE_FOR_umaxv8qi3 },
  { 0x55002c, CODE_FOR_umaxv4hi3 },
  { 0x560006, CODE_FOR_negsi2 },
  { 0x560007, CODE_FOR_negdi2 },
  { 0x56001b, CODE_FOR_negsf2 },
  { 0x56001c, CODE_FOR_negdf2 },
  { 0x56001d, CODE_FOR_negtf2 },
  { 0x570006, CODE_FOR_negvsi2 },
  { 0x570007, CODE_FOR_negvdi2 },
  { 0x5a0007, CODE_FOR_absdi2 },
  { 0x5a001b, CODE_FOR_abssf2 },
  { 0x5a001c, CODE_FOR_absdf2 },
  { 0x5a001d, CODE_FOR_abstf2 },
  { 0x5c0007, CODE_FOR_one_cmpldi2 },
  { 0x5c002b, CODE_FOR_one_cmplv8qi2 },
  { 0x5c002c, CODE_FOR_one_cmplv4hi2 },
  { 0x5c002d, CODE_FOR_one_cmplv2si2 },
  { 0x5d0006, CODE_FOR_bswapsi2 },
  { 0x5d0007, CODE_FOR_bswapdi2 },
  { 0x5e0007, CODE_FOR_ffsdi2 },
  { 0x5f0007, CODE_FOR_clzdi2 },
  { 0x600007, CODE_FOR_ctzdi2 },
  { 0x620007, CODE_FOR_popcountdi2 },
  { 0x6e001b, CODE_FOR_sqrtsf2 },
  { 0x6e001c, CODE_FOR_sqrtdf2 },
  { 0x7d0004, CODE_FOR_movqi },
  { 0x7d0005, CODE_FOR_movhi },
  { 0x7d0006, CODE_FOR_movsi },
  { 0x7d0007, CODE_FOR_movdi },
  { 0x7d0008, CODE_FOR_movti },
  { 0x7d001b, CODE_FOR_movsf },
  { 0x7d001c, CODE_FOR_movdf },
  { 0x7d001d, CODE_FOR_movtf },
  { 0x7d0021, CODE_FOR_movcqi },
  { 0x7d002b, CODE_FOR_movv8qi },
  { 0x7d002c, CODE_FOR_movv4hi },
  { 0x7d002d, CODE_FOR_movv2si },
  { 0x7f002b, CODE_FOR_movmisalignv8qi },
  { 0x7f002c, CODE_FOR_movmisalignv4hi },
  { 0x7f002d, CODE_FOR_movmisalignv2si },
  { 0x830007, CODE_FOR_extzvdi },
  { 0x840007, CODE_FOR_insvmisaligndi },
  { 0x850007, CODE_FOR_extvmisaligndi },
  { 0x860007, CODE_FOR_extzvmisaligndi },
  { 0x880004, CODE_FOR_reload_inqi },
  { 0x880005, CODE_FOR_reload_inhi },
  { 0x880021, CODE_FOR_reload_incqi },
  { 0x890004, CODE_FOR_reload_outqi },
  { 0x890005, CODE_FOR_reload_outhi },
  { 0x890021, CODE_FOR_reload_outcqi },
  { 0x8a0007, CODE_FOR_cbranchdi4 },
  { 0x8a001c, CODE_FOR_cbranchdf4 },
  { 0x8a001d, CODE_FOR_cbranchtf4 },
  { 0x8e0006, CODE_FOR_movsicc },
  { 0x8e0007, CODE_FOR_movdicc },
  { 0x8e001b, CODE_FOR_movsfcc },
  { 0x8e001c, CODE_FOR_movdfcc },
  { 0x990007, CODE_FOR_cstoredi4 },
  { 0x99001c, CODE_FOR_cstoredf4 },
  { 0x99001d, CODE_FOR_cstoretf4 },
  { 0xa40007, CODE_FOR_umuldi3_highpart },
  { 0xa80004, CODE_FOR_movmemqi },
  { 0xa90004, CODE_FOR_setmemqi },
  { 0xb9001b, CODE_FOR_copysignsf3 },
  { 0xb9001c, CODE_FOR_copysigndf3 },
  { 0xed002b, CODE_FOR_vec_shr_v8qi },
  { 0xed002c, CODE_FOR_vec_shr_v4hi },
  { 0xed002d, CODE_FOR_vec_shr_v2si },
  { 0x1090006, CODE_FOR_atomic_add_fetchsi },
  { 0x1090007, CODE_FOR_atomic_add_fetchdi },
  { 0x10a0006, CODE_FOR_atomic_addsi },
  { 0x10a0007, CODE_FOR_atomic_adddi },
  { 0x10b0006, CODE_FOR_atomic_and_fetchsi },
  { 0x10b0007, CODE_FOR_atomic_and_fetchdi },
  { 0x10c0006, CODE_FOR_atomic_andsi },
  { 0x10c0007, CODE_FOR_atomic_anddi },
  { 0x1100004, CODE_FOR_atomic_compare_and_swapqi },
  { 0x1100005, CODE_FOR_atomic_compare_and_swaphi },
  { 0x1100006, CODE_FOR_atomic_compare_and_swapsi },
  { 0x1100007, CODE_FOR_atomic_compare_and_swapdi },
  { 0x1110004, CODE_FOR_atomic_exchangeqi },
  { 0x1110005, CODE_FOR_atomic_exchangehi },
  { 0x1110006, CODE_FOR_atomic_exchangesi },
  { 0x1110007, CODE_FOR_atomic_exchangedi },
  { 0x1120006, CODE_FOR_atomic_fetch_addsi },
  { 0x1120007, CODE_FOR_atomic_fetch_adddi },
  { 0x1130006, CODE_FOR_atomic_fetch_andsi },
  { 0x1130007, CODE_FOR_atomic_fetch_anddi },
  { 0x1140006, CODE_FOR_atomic_fetch_nandsi },
  { 0x1140007, CODE_FOR_atomic_fetch_nanddi },
  { 0x1150006, CODE_FOR_atomic_fetch_orsi },
  { 0x1150007, CODE_FOR_atomic_fetch_ordi },
  { 0x1160006, CODE_FOR_atomic_fetch_subsi },
  { 0x1160007, CODE_FOR_atomic_fetch_subdi },
  { 0x1170006, CODE_FOR_atomic_fetch_xorsi },
  { 0x1170007, CODE_FOR_atomic_fetch_xordi },
  { 0x1190006, CODE_FOR_atomic_nand_fetchsi },
  { 0x1190007, CODE_FOR_atomic_nand_fetchdi },
  { 0x11a0006, CODE_FOR_atomic_nandsi },
  { 0x11a0007, CODE_FOR_atomic_nanddi },
  { 0x11b0006, CODE_FOR_atomic_or_fetchsi },
  { 0x11b0007, CODE_FOR_atomic_or_fetchdi },
  { 0x11c0006, CODE_FOR_atomic_orsi },
  { 0x11c0007, CODE_FOR_atomic_ordi },
  { 0x11e0006, CODE_FOR_atomic_sub_fetchsi },
  { 0x11e0007, CODE_FOR_atomic_sub_fetchdi },
  { 0x11f0006, CODE_FOR_atomic_subsi },
  { 0x11f0007, CODE_FOR_atomic_subdi },
  { 0x1200006, CODE_FOR_atomic_xor_fetchsi },
  { 0x1200007, CODE_FOR_atomic_xor_fetchdi },
  { 0x1210006, CODE_FOR_atomic_xorsi },
  { 0x1210007, CODE_FOR_atomic_xordi },
  { 0x1220007, CODE_FOR_get_thread_pointerdi },
  { 0x1230007, CODE_FOR_set_thread_pointerdi },
};

void
init_all_optabs (struct target_optabs *optabs)
{
  bool *ena = optabs->pat_enable;
  ena[0] = HAVE_extendqihi2;
  ena[1] = HAVE_extendqisi2;
  ena[2] = HAVE_extendqidi2;
  ena[3] = HAVE_extendhisi2;
  ena[4] = HAVE_extendhidi2;
  ena[5] = HAVE_extendsidi2;
  ena[6] = HAVE_extendsfdf2;
  ena[7] = HAVE_extendsftf2;
  ena[8] = HAVE_extenddftf2;
  ena[9] = HAVE_truncdfsf2;
  ena[10] = HAVE_trunctfsf2;
  ena[11] = HAVE_trunctfdf2;
  ena[12] = HAVE_zero_extendqihi2;
  ena[13] = HAVE_zero_extendqisi2;
  ena[14] = HAVE_zero_extendqidi2;
  ena[15] = HAVE_zero_extendhisi2;
  ena[16] = HAVE_zero_extendhidi2;
  ena[17] = HAVE_zero_extendsidi2;
  ena[18] = HAVE_floatdisf2;
  ena[19] = HAVE_floatdidf2;
  ena[20] = HAVE_floatditf2;
  ena[21] = HAVE_floatunsdisf2;
  ena[22] = HAVE_floatunsdidf2;
  ena[23] = HAVE_floatunsditf2;
  ena[24] = HAVE_fix_truncsfdi2;
  ena[25] = HAVE_fix_truncdfdi2;
  ena[26] = HAVE_fix_trunctfdi2;
  ena[27] = HAVE_fixuns_truncsfdi2;
  ena[28] = HAVE_fixuns_truncdfdi2;
  ena[29] = HAVE_fixuns_trunctfdi2;
  ena[30] = HAVE_umulditi3;
  ena[31] = HAVE_addsi3;
  ena[32] = HAVE_adddi3;
  ena[33] = HAVE_addsf3;
  ena[34] = HAVE_adddf3;
  ena[35] = HAVE_addtf3;
  ena[36] = HAVE_addvsi3;
  ena[37] = HAVE_addvdi3;
  ena[38] = HAVE_subsi3;
  ena[39] = HAVE_subdi3;
  ena[40] = HAVE_subsf3;
  ena[41] = HAVE_subdf3;
  ena[42] = HAVE_subtf3;
  ena[43] = HAVE_subvsi3;
  ena[44] = HAVE_subvdi3;
  ena[45] = HAVE_mulsi3;
  ena[46] = HAVE_muldi3;
  ena[47] = HAVE_mulsf3;
  ena[48] = HAVE_muldf3;
  ena[49] = HAVE_multf3;
  ena[50] = HAVE_mulvsi3;
  ena[51] = HAVE_mulvdi3;
  ena[52] = HAVE_divsi3;
  ena[53] = HAVE_divdi3;
  ena[54] = HAVE_divsf3;
  ena[55] = HAVE_divdf3;
  ena[56] = HAVE_divtf3;
  ena[57] = HAVE_udivsi3;
  ena[58] = HAVE_udivdi3;
  ena[59] = HAVE_modsi3;
  ena[60] = HAVE_moddi3;
  ena[61] = HAVE_umodsi3;
  ena[62] = HAVE_umoddi3;
  ena[63] = HAVE_anddi3;
  ena[64] = HAVE_andv8qi3;
  ena[65] = HAVE_andv4hi3;
  ena[66] = HAVE_andv2si3;
  ena[67] = HAVE_iordi3;
  ena[68] = HAVE_iorv8qi3;
  ena[69] = HAVE_iorv4hi3;
  ena[70] = HAVE_iorv2si3;
  ena[71] = HAVE_xordi3;
  ena[72] = HAVE_xorv8qi3;
  ena[73] = HAVE_xorv4hi3;
  ena[74] = HAVE_xorv2si3;
  ena[75] = HAVE_ashldi3;
  ena[76] = HAVE_ashrdi3;
  ena[77] = HAVE_lshrdi3;
  ena[78] = HAVE_sminqi3;
  ena[79] = HAVE_sminhi3;
  ena[80] = HAVE_smindi3;
  ena[81] = HAVE_sminsf3;
  ena[82] = HAVE_smindf3;
  ena[83] = HAVE_sminv8qi3;
  ena[84] = HAVE_sminv4hi3;
  ena[85] = HAVE_smaxqi3;
  ena[86] = HAVE_smaxhi3;
  ena[87] = HAVE_smaxdi3;
  ena[88] = HAVE_smaxsf3;
  ena[89] = HAVE_smaxdf3;
  ena[90] = HAVE_smaxv8qi3;
  ena[91] = HAVE_smaxv4hi3;
  ena[92] = HAVE_uminqi3;
  ena[93] = HAVE_uminhi3;
  ena[94] = HAVE_umindi3;
  ena[95] = HAVE_uminv8qi3;
  ena[96] = HAVE_uminv4hi3;
  ena[97] = HAVE_umaxqi3;
  ena[98] = HAVE_umaxhi3;
  ena[99] = HAVE_umaxdi3;
  ena[100] = HAVE_umaxv8qi3;
  ena[101] = HAVE_umaxv4hi3;
  ena[102] = HAVE_negsi2;
  ena[103] = HAVE_negdi2;
  ena[104] = HAVE_negsf2;
  ena[105] = HAVE_negdf2;
  ena[106] = HAVE_negtf2;
  ena[107] = HAVE_negvsi2;
  ena[108] = HAVE_negvdi2;
  ena[109] = HAVE_absdi2;
  ena[110] = HAVE_abssf2;
  ena[111] = HAVE_absdf2;
  ena[112] = HAVE_abstf2;
  ena[113] = HAVE_one_cmpldi2;
  ena[114] = HAVE_one_cmplv8qi2;
  ena[115] = HAVE_one_cmplv4hi2;
  ena[116] = HAVE_one_cmplv2si2;
  ena[117] = HAVE_bswapsi2;
  ena[118] = HAVE_bswapdi2;
  ena[119] = HAVE_ffsdi2;
  ena[120] = HAVE_clzdi2;
  ena[121] = HAVE_ctzdi2;
  ena[122] = HAVE_popcountdi2;
  ena[123] = HAVE_sqrtsf2;
  ena[124] = HAVE_sqrtdf2;
  ena[125] = HAVE_movqi;
  ena[126] = HAVE_movhi;
  ena[127] = HAVE_movsi;
  ena[128] = HAVE_movdi;
  ena[129] = HAVE_movti;
  ena[130] = HAVE_movsf;
  ena[131] = HAVE_movdf;
  ena[132] = HAVE_movtf;
  ena[133] = HAVE_movcqi;
  ena[134] = HAVE_movv8qi;
  ena[135] = HAVE_movv4hi;
  ena[136] = HAVE_movv2si;
  ena[137] = HAVE_movmisalignv8qi;
  ena[138] = HAVE_movmisalignv4hi;
  ena[139] = HAVE_movmisalignv2si;
  ena[140] = HAVE_extzvdi;
  ena[141] = HAVE_insvmisaligndi;
  ena[142] = HAVE_extvmisaligndi;
  ena[143] = HAVE_extzvmisaligndi;
  ena[144] = HAVE_reload_inqi;
  ena[145] = HAVE_reload_inhi;
  ena[146] = HAVE_reload_incqi;
  ena[147] = HAVE_reload_outqi;
  ena[148] = HAVE_reload_outhi;
  ena[149] = HAVE_reload_outcqi;
  ena[150] = HAVE_cbranchdi4;
  ena[151] = HAVE_cbranchdf4;
  ena[152] = HAVE_cbranchtf4;
  ena[153] = HAVE_movsicc;
  ena[154] = HAVE_movdicc;
  ena[155] = HAVE_movsfcc;
  ena[156] = HAVE_movdfcc;
  ena[157] = HAVE_cstoredi4;
  ena[158] = HAVE_cstoredf4;
  ena[159] = HAVE_cstoretf4;
  ena[160] = HAVE_umuldi3_highpart;
  ena[161] = HAVE_movmemqi;
  ena[162] = HAVE_setmemqi;
  ena[163] = HAVE_copysignsf3;
  ena[164] = HAVE_copysigndf3;
  ena[165] = HAVE_vec_shr_v8qi;
  ena[166] = HAVE_vec_shr_v4hi;
  ena[167] = HAVE_vec_shr_v2si;
  ena[168] = HAVE_atomic_add_fetchsi;
  ena[169] = HAVE_atomic_add_fetchdi;
  ena[170] = HAVE_atomic_addsi;
  ena[171] = HAVE_atomic_adddi;
  ena[172] = HAVE_atomic_and_fetchsi;
  ena[173] = HAVE_atomic_and_fetchdi;
  ena[174] = HAVE_atomic_andsi;
  ena[175] = HAVE_atomic_anddi;
  ena[176] = HAVE_atomic_compare_and_swapqi;
  ena[177] = HAVE_atomic_compare_and_swaphi;
  ena[178] = HAVE_atomic_compare_and_swapsi;
  ena[179] = HAVE_atomic_compare_and_swapdi;
  ena[180] = HAVE_atomic_exchangeqi;
  ena[181] = HAVE_atomic_exchangehi;
  ena[182] = HAVE_atomic_exchangesi;
  ena[183] = HAVE_atomic_exchangedi;
  ena[184] = HAVE_atomic_fetch_addsi;
  ena[185] = HAVE_atomic_fetch_adddi;
  ena[186] = HAVE_atomic_fetch_andsi;
  ena[187] = HAVE_atomic_fetch_anddi;
  ena[188] = HAVE_atomic_fetch_nandsi;
  ena[189] = HAVE_atomic_fetch_nanddi;
  ena[190] = HAVE_atomic_fetch_orsi;
  ena[191] = HAVE_atomic_fetch_ordi;
  ena[192] = HAVE_atomic_fetch_subsi;
  ena[193] = HAVE_atomic_fetch_subdi;
  ena[194] = HAVE_atomic_fetch_xorsi;
  ena[195] = HAVE_atomic_fetch_xordi;
  ena[196] = HAVE_atomic_nand_fetchsi;
  ena[197] = HAVE_atomic_nand_fetchdi;
  ena[198] = HAVE_atomic_nandsi;
  ena[199] = HAVE_atomic_nanddi;
  ena[200] = HAVE_atomic_or_fetchsi;
  ena[201] = HAVE_atomic_or_fetchdi;
  ena[202] = HAVE_atomic_orsi;
  ena[203] = HAVE_atomic_ordi;
  ena[204] = HAVE_atomic_sub_fetchsi;
  ena[205] = HAVE_atomic_sub_fetchdi;
  ena[206] = HAVE_atomic_subsi;
  ena[207] = HAVE_atomic_subdi;
  ena[208] = HAVE_atomic_xor_fetchsi;
  ena[209] = HAVE_atomic_xor_fetchdi;
  ena[210] = HAVE_atomic_xorsi;
  ena[211] = HAVE_atomic_xordi;
  ena[212] = HAVE_get_thread_pointerdi;
  ena[213] = HAVE_set_thread_pointerdi;
}

static int
lookup_handler (unsigned scode)
{
  int l = 0, h = ARRAY_SIZE (pats), m;
  while (h > l)
    {
      m = (h + l) / 2;
      if (scode == pats[m].scode)
        return m;
      else if (scode < pats[m].scode)
        h = m;
      else
        l = m + 1;
    }
  return -1;
}

enum insn_code
raw_optab_handler (unsigned scode)
{
  int i = lookup_handler (scode);
  return (i >= 0 && this_fn_optabs->pat_enable[i]
          ? pats[i].icode : CODE_FOR_nothing);
}

bool
swap_optab_enable (optab op, machine_mode m, bool set)
{
  unsigned scode = (op << 16) | m;
  int i = lookup_handler (scode);
  if (i >= 0)
    {
      bool ret = this_fn_optabs->pat_enable[i];
      this_fn_optabs->pat_enable[i] = set;
      return ret;
    }
  else
    {
      gcc_assert (!set);
      return false;
    }
}

const struct convert_optab_libcall_d convlib_def[NUM_CONVLIB_OPTABS] = {
  { "extend", gen_extend_conv_libfunc },
  { "trunc", gen_trunc_conv_libfunc },
  { NULL, NULL },
  { "fix", gen_fp_to_int_conv_libfunc },
  { "fixuns", gen_fp_to_int_conv_libfunc },
  { "float", gen_int_to_fp_conv_libfunc },
  { NULL, gen_ufloat_conv_libfunc },
  { "lrint", gen_int_to_fp_nondecimal_conv_libfunc },
  { "lround", gen_int_to_fp_nondecimal_conv_libfunc },
  { "lfloor", gen_int_to_fp_nondecimal_conv_libfunc },
  { "lceil", gen_int_to_fp_nondecimal_conv_libfunc },
  { "fract", gen_fract_conv_libfunc },
  { "fractuns", gen_fractuns_conv_libfunc },
  { "satfract", gen_satfract_conv_libfunc },
  { "satfractuns", gen_satfractuns_conv_libfunc },
};

const struct optab_libcall_d normlib_def[NUM_NORMLIB_OPTABS] = {
  { '3', "add", gen_int_fp_fixed_libfunc },
  { '3', "add", gen_intv_fp_libfunc },
  { '3', "ssadd", gen_signed_fixed_libfunc },
  { '3', "usadd", gen_unsigned_fixed_libfunc },
  { '3', "sub", gen_int_fp_fixed_libfunc },
  { '3', "sub", gen_intv_fp_libfunc },
  { '3', "sssub", gen_signed_fixed_libfunc },
  { '3', "ussub", gen_unsigned_fixed_libfunc },
  { '3', "mul", gen_int_fp_fixed_libfunc },
  { '3', "mul", gen_intv_fp_libfunc },
  { '3', "ssmul", gen_signed_fixed_libfunc },
  { '3', "usmul", gen_unsigned_fixed_libfunc },
  { '3', "div", gen_int_fp_signed_fixed_libfunc },
  { '3', "divv", gen_int_libfunc },
  { '3', "ssdiv", gen_signed_fixed_libfunc },
  { '3', "udiv", gen_int_unsigned_fixed_libfunc },
  { '3', "usdiv", gen_unsigned_fixed_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '3', "mod", gen_int_libfunc },
  { '3', "umod", gen_int_libfunc },
  { '2', "ftrunc", gen_fp_libfunc },
  { '3', "and", gen_int_libfunc },
  { '3', "ior", gen_int_libfunc },
  { '3', "xor", gen_int_libfunc },
  { '3', "ashl", gen_int_fixed_libfunc },
  { '3', "ssashl", gen_signed_fixed_libfunc },
  { '3', "usashl", gen_unsigned_fixed_libfunc },
  { '3', "ashr", gen_int_signed_fixed_libfunc },
  { '3', "lshr", gen_int_unsigned_fixed_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '3', "min", gen_int_fp_libfunc },
  { '3', "max", gen_int_fp_libfunc },
  { '3', "umin", gen_int_libfunc },
  { '3', "umax", gen_int_libfunc },
  { '2', "neg", gen_int_fp_fixed_libfunc },
  { '2', "neg", gen_intv_fp_libfunc },
  { '2', "ssneg", gen_signed_fixed_libfunc },
  { '2', "usneg", gen_unsigned_fixed_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '2', "one_cmpl", gen_int_libfunc },
  { '\0', NULL, NULL },
  { '2', "ffs", gen_int_libfunc },
  { '2', "clz", gen_int_libfunc },
  { '2', "ctz", gen_int_libfunc },
  { '2', "clrsb", gen_int_libfunc },
  { '2', "popcount", gen_int_libfunc },
  { '2', "parity", gen_int_libfunc },
  { '2', "cmp", gen_int_fp_fixed_libfunc },
  { '2', "ucmp", gen_int_libfunc },
  { '2', "eq", gen_fp_libfunc },
  { '2', "ne", gen_fp_libfunc },
  { '2', "gt", gen_fp_libfunc },
  { '2', "ge", gen_fp_libfunc },
  { '2', "lt", gen_fp_libfunc },
  { '2', "le", gen_fp_libfunc },
  { '2', "unord", gen_fp_libfunc },
  { '2', "powi", gen_fp_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
};

enum rtx_code const optab_to_code_[NUM_OPTABS] = {
  UNKNOWN,
  SIGN_EXTEND,
  TRUNCATE,
  ZERO_EXTEND,
  FIX,
  UNSIGNED_FIX,
  FLOAT,
  UNSIGNED_FLOAT,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  FRACT_CONVERT,
  UNSIGNED_FRACT_CONVERT,
  SAT_FRACT,
  UNSIGNED_SAT_FRACT,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  PLUS,
  PLUS,
  SS_PLUS,
  US_PLUS,
  MINUS,
  MINUS,
  SS_MINUS,
  US_MINUS,
  MULT,
  MULT,
  SS_MULT,
  US_MULT,
  DIV,
  DIV,
  SS_DIV,
  UDIV,
  US_DIV,
  UNKNOWN,
  UNKNOWN,
  MOD,
  UMOD,
  UNKNOWN,
  AND,
  IOR,
  XOR,
  ASHIFT,
  SS_ASHIFT,
  US_ASHIFT,
  ASHIFTRT,
  LSHIFTRT,
  ROTATE,
  ROTATERT,
  ASHIFT,
  ASHIFTRT,
  LSHIFTRT,
  ROTATE,
  ROTATERT,
  SMIN,
  SMAX,
  UMIN,
  UMAX,
  NEG,
  NEG,
  SS_NEG,
  US_NEG,
  ABS,
  ABS,
  NOT,
  BSWAP,
  FFS,
  CLZ,
  CTZ,
  CLRSB,
  POPCOUNT,
  PARITY,
  UNKNOWN,
  UNKNOWN,
  EQ,
  NE,
  GT,
  GE,
  LT,
  LE,
  UNORDERED,
  UNKNOWN,
  SQRT,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  SET,
  STRICT_LOW_PART,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  COMPARE,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  FMA,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  VEC_DUPLICATE,
  VEC_SERIES,
  UNKNOWN,
};

const optab code_to_optab_[NUM_RTX_CODE] = {
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  mov_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  movstrict_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  cbranch_optab,
  add_optab,
  sub_optab,
  neg_optab,
  smul_optab,
  ssmul_optab,
  usmul_optab,
  sdiv_optab,
  ssdiv_optab,
  usdiv_optab,
  smod_optab,
  udiv_optab,
  umod_optab,
  and_optab,
  ior_optab,
  xor_optab,
  one_cmpl_optab,
  ashl_optab,
  rotl_optab,
  ashr_optab,
  lshr_optab,
  rotr_optab,
  smin_optab,
  smax_optab,
  umin_optab,
  umax_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  ne_optab,
  eq_optab,
  ge_optab,
  gt_optab,
  le_optab,
  lt_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unord_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  abs_optab,
  sqrt_optab,
  bswap_optab,
  ffs_optab,
  clrsb_optab,
  clz_optab,
  ctz_optab,
  popcount_optab,
  parity_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  vec_duplicate_optab,
  vec_series_optab,
  ssadd_optab,
  usadd_optab,
  sssub_optab,
  ssneg_optab,
  usneg_optab,
  unknown_optab,
  ssashl_optab,
  usashl_optab,
  ussub_optab,
  unknown_optab,
  unknown_optab,
  fma_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
};

