/* Generated automatically by the program 'build/genpreds'
   from the machine description file '../../gcc-8.1.1-20180626/gcc/config/bfin/bfin.md'.  */

#ifndef GCC_TM_CONSTRS_H
#define GCC_TM_CONSTRS_H

static inline bool
satisfies_constraint_m (rtx op)
{
  return (GET_CODE (op) == MEM) && (
#line 26 "../../gcc-8.1.1-20180626/gcc/common.md"
(memory_address_addr_space_p (GET_MODE (op), XEXP (op, 0),
						 MEM_ADDR_SPACE (op))));
}
static inline bool
satisfies_constraint_o (rtx op)
{
  return (GET_CODE (op) == MEM) && (
#line 32 "../../gcc-8.1.1-20180626/gcc/common.md"
(offsettable_nonstrict_memref_p (op)));
}
static inline bool
satisfies_constraint_V (rtx op)
{
  return (GET_CODE (op) == MEM) && ((
#line 41 "../../gcc-8.1.1-20180626/gcc/common.md"
(memory_address_addr_space_p (GET_MODE (op), XEXP (op, 0),
						 MEM_ADDR_SPACE (op)))) && (!(
#line 43 "../../gcc-8.1.1-20180626/gcc/common.md"
(offsettable_nonstrict_memref_p (op)))));
}
static inline bool
satisfies_constraint__l (rtx op)
{
  return (GET_CODE (op) == MEM) && ((
#line 50 "../../gcc-8.1.1-20180626/gcc/common.md"
(GET_CODE (XEXP (op, 0)) == PRE_DEC)) || (
#line 51 "../../gcc-8.1.1-20180626/gcc/common.md"
(GET_CODE (XEXP (op, 0)) == POST_DEC)));
}
static inline bool
satisfies_constraint__g (rtx op)
{
  return (GET_CODE (op) == MEM) && ((
#line 57 "../../gcc-8.1.1-20180626/gcc/common.md"
(GET_CODE (XEXP (op, 0)) == PRE_INC)) || (
#line 58 "../../gcc-8.1.1-20180626/gcc/common.md"
(GET_CODE (XEXP (op, 0)) == POST_INC)));
}
static inline bool
satisfies_constraint_p (rtx ARG_UNUSED (op))
{
  return 
#line 62 "../../gcc-8.1.1-20180626/gcc/common.md"
(address_operand (op, VOIDmode));
}
static inline bool
satisfies_constraint_i (rtx op)
{
  return (
#line 66 "../../gcc-8.1.1-20180626/gcc/common.md"
(CONSTANT_P (op))) && (
#line 67 "../../gcc-8.1.1-20180626/gcc/common.md"
(!flag_pic || LEGITIMATE_PIC_OPERAND_P (op)));
}
static inline bool
satisfies_constraint_s (rtx op)
{
  return (
#line 71 "../../gcc-8.1.1-20180626/gcc/common.md"
(CONSTANT_P (op))) && ((
#line 72 "../../gcc-8.1.1-20180626/gcc/common.md"
(!CONST_SCALAR_INT_P (op))) && (
#line 73 "../../gcc-8.1.1-20180626/gcc/common.md"
(!flag_pic || LEGITIMATE_PIC_OPERAND_P (op))));
}
static inline bool
satisfies_constraint_n (rtx op)
{
  return (
#line 77 "../../gcc-8.1.1-20180626/gcc/common.md"
(CONST_SCALAR_INT_P (op))) && (
#line 78 "../../gcc-8.1.1-20180626/gcc/common.md"
(!flag_pic || LEGITIMATE_PIC_OPERAND_P (op)));
}
static inline bool
satisfies_constraint_E (rtx op)
{
  return (
#line 82 "../../gcc-8.1.1-20180626/gcc/common.md"
(CONST_DOUBLE_AS_FLOAT_P (op))) || (
#line 83 "../../gcc-8.1.1-20180626/gcc/common.md"
(GET_CODE (op) == CONST_VECTOR
		    && GET_MODE_CLASS (GET_MODE (op)) == MODE_VECTOR_FLOAT));
}
static inline bool
satisfies_constraint_F (rtx op)
{
  return (
#line 89 "../../gcc-8.1.1-20180626/gcc/common.md"
(CONST_DOUBLE_AS_FLOAT_P (op))) || (
#line 90 "../../gcc-8.1.1-20180626/gcc/common.md"
(GET_CODE (op) == CONST_VECTOR
		    && GET_MODE_CLASS (GET_MODE (op)) == MODE_VECTOR_FLOAT));
}
static inline bool
satisfies_constraint_X (rtx ARG_UNUSED (op))
{
  return 
#line 95 "../../gcc-8.1.1-20180626/gcc/common.md"
(true);
}
static inline bool
satisfies_constraint_J (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 117 "../../gcc-8.1.1-20180626/gcc/config/bfin/constraints.md"
(log2constp (ival)));
}
static inline bool
satisfies_constraint_Ks3 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 122 "../../gcc-8.1.1-20180626/gcc/config/bfin/constraints.md"
(ival >= -4 && ival <= 3));
}
static inline bool
satisfies_constraint_Ku3 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 127 "../../gcc-8.1.1-20180626/gcc/config/bfin/constraints.md"
(ival >= 0 && ival <= 7));
}
static inline bool
satisfies_constraint_Ks4 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 132 "../../gcc-8.1.1-20180626/gcc/config/bfin/constraints.md"
(ival >= -8 && ival <= 7));
}
static inline bool
satisfies_constraint_Ku4 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 137 "../../gcc-8.1.1-20180626/gcc/config/bfin/constraints.md"
(ival >= 0 && ival <= 15));
}
static inline bool
satisfies_constraint_Ks5 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 142 "../../gcc-8.1.1-20180626/gcc/config/bfin/constraints.md"
(ival >= -16 && ival <= 15));
}
static inline bool
satisfies_constraint_Ku5 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 147 "../../gcc-8.1.1-20180626/gcc/config/bfin/constraints.md"
(ival >= 0 && ival <= 31));
}
static inline bool
satisfies_constraint_Ks7 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 152 "../../gcc-8.1.1-20180626/gcc/config/bfin/constraints.md"
(ival >= -64 && ival <= 63));
}
static inline bool
satisfies_constraint_KN7 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 157 "../../gcc-8.1.1-20180626/gcc/config/bfin/constraints.md"
(ival >= -63 && ival <= 64));
}
static inline bool
satisfies_constraint_Ksh (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 162 "../../gcc-8.1.1-20180626/gcc/config/bfin/constraints.md"
(ival >= -32768 && ival <= 32767));
}
static inline bool
satisfies_constraint_Kuh (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 167 "../../gcc-8.1.1-20180626/gcc/config/bfin/constraints.md"
(ival >= 0 && ival <= 65535));
}
static inline bool
satisfies_constraint_L (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 172 "../../gcc-8.1.1-20180626/gcc/config/bfin/constraints.md"
(log2constp (~ival)));
}
static inline bool
satisfies_constraint_M1 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 177 "../../gcc-8.1.1-20180626/gcc/config/bfin/constraints.md"
(ival == 255));
}
static inline bool
satisfies_constraint_M2 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 182 "../../gcc-8.1.1-20180626/gcc/config/bfin/constraints.md"
(ival == 65535));
}
static inline bool
satisfies_constraint_P0 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 187 "../../gcc-8.1.1-20180626/gcc/config/bfin/constraints.md"
(ival == 0));
}
static inline bool
satisfies_constraint_P1 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 192 "../../gcc-8.1.1-20180626/gcc/config/bfin/constraints.md"
(ival == 1));
}
static inline bool
satisfies_constraint_P2 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 197 "../../gcc-8.1.1-20180626/gcc/config/bfin/constraints.md"
(ival == 2));
}
static inline bool
satisfies_constraint_P3 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 202 "../../gcc-8.1.1-20180626/gcc/config/bfin/constraints.md"
(ival == 3));
}
static inline bool
satisfies_constraint_P4 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 207 "../../gcc-8.1.1-20180626/gcc/config/bfin/constraints.md"
(ival == 4));
}
static inline bool
satisfies_constraint_PA (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 212 "../../gcc-8.1.1-20180626/gcc/config/bfin/constraints.md"
(ival != MACFLAG_M && ival != MACFLAG_IS_M));
}
static inline bool
satisfies_constraint_PB (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 217 "../../gcc-8.1.1-20180626/gcc/config/bfin/constraints.md"
(ival == MACFLAG_M || ival == MACFLAG_IS_M));
}
static inline bool
satisfies_constraint_Q (rtx op)
{
  return GET_CODE (op) == SYMBOL_REF;
}
#endif /* tm-constrs.h */
