/* Generated automatically by the program `genattrtab'
   from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "tree.h"
#include "rtl.h"
#include "alias.h"
#include "options.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "insn-attr.h"
#include "memmodel.h"
#include "tm_p.h"
#include "insn-config.h"
#include "recog.h"
#include "regs.h"
#include "real.h"
#include "output.h"
#include "toplev.h"
#include "flags.h"
#include "emit-rtl.h"

#define operands recog_data.operand

int
bypass_p (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return 0;

    }
}

int
num_delay_slots (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return 0;

    }
}

enum attr_addr_regfile
get_attr_addr_regfile (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case 384:  /* *p sign_extendhisi2 */
    case 383:  /* *p zero_extendhisi2 */
    case 382:  /* *p sign_extendqisi2 */
    case 381:  /* *p zero_extendqisi2 */
    case 45:  /* sign_extendhisi2 */
    case 44:  /* zero_extendhisi2 */
    case 43:  /* sign_extendqisi2 */
    case 42:  /* zero_extendqisi2 */
      extract_constrain_insn_cached (insn);
      if (((1 << which_alternative) & 0x3))
        {
	  return ADDR_REGFILE_UNKNOWN;
        }
      else if (which_alternative == 2)
        {
	  return ADDR_REGFILE_A;
        }
      else if (((1 << which_alternative) & 0x18))
        {
	  return ADDR_REGFILE_B;
        }
      else
        {
	  return ADDR_REGFILE_A;
        }

    case 390:  /* *p real_sign_extendhi */
    case 389:  /* *p real_zero_extendhi */
    case 388:  /* *p real_sign_extendqi */
    case 387:  /* *p real_zero_extendqi */
    case 370:  /* *p real_loadv8qi */
    case 369:  /* *p real_loadv4hi */
    case 368:  /* *p real_loadv2si */
    case 367:  /* *p real_loaddf */
    case 366:  /* *p real_loaddi */
    case 365:  /* *p real_loadv4qi */
    case 364:  /* *p real_loadv2hi */
    case 363:  /* *p real_loadsf */
    case 362:  /* *p real_loadsi */
    case 361:  /* *p real_loadhi */
    case 360:  /* *p real_loadqi */
    case 51:  /* real_sign_extendhi */
    case 50:  /* real_zero_extendhi */
    case 49:  /* real_sign_extendqi */
    case 48:  /* real_zero_extendqi */
    case 31:  /* real_loadv8qi */
    case 30:  /* real_loadv4hi */
    case 29:  /* real_loadv2si */
    case 28:  /* real_loaddf */
    case 27:  /* real_loaddi */
    case 26:  /* real_loadv4qi */
    case 25:  /* real_loadv2hi */
    case 24:  /* real_loadsf */
    case 23:  /* real_loadsi */
    case 22:  /* real_loadhi */
    case 21:  /* real_loadqi */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return ADDR_REGFILE_A;
        }
      else if (((1 << which_alternative) & 0x6))
        {
	  return ADDR_REGFILE_B;
        }
      else
        {
	  return ADDR_REGFILE_A;
        }

    case 359:  /* *p *movv8qi_insn */
    case 358:  /* *p *movv4hi_insn */
    case 357:  /* *p *movv2si_insn */
    case 356:  /* *p *movdf_insn */
    case 355:  /* *p *movdi_insn */
    case 20:  /* *movv8qi_insn */
    case 19:  /* *movv4hi_insn */
    case 18:  /* *movv2si_insn */
    case 17:  /* *movdf_insn */
    case 16:  /* *movdi_insn */
      extract_constrain_insn_cached (insn);
      if (((1 << which_alternative) & 0x1f))
        {
	  return ADDR_REGFILE_UNKNOWN;
        }
      else if (which_alternative == 5)
        {
	  return ADDR_REGFILE_A;
        }
      else if (((1 << which_alternative) & 0xc0))
        {
	  return ADDR_REGFILE_B;
        }
      else if (((1 << which_alternative) & 0x300))
        {
	  return ADDR_REGFILE_A;
        }
      else if (((1 << which_alternative) & 0xc00))
        {
	  return ADDR_REGFILE_B;
        }
      else
        {
	  return ADDR_REGFILE_A;
        }

    case 354:  /* *p movv4qi_insn */
    case 353:  /* *p movv2hi_insn */
    case 352:  /* *p movsf_insn */
    case 351:  /* *p movsi_insn */
    case 15:  /* movv4qi_insn */
    case 14:  /* movv2hi_insn */
    case 13:  /* movsf_insn */
    case 12:  /* movsi_insn */
      extract_constrain_insn_cached (insn);
      if (((1 << which_alternative) & 0x1ff))
        {
	  return ADDR_REGFILE_UNKNOWN;
        }
      else if (which_alternative == 9)
        {
	  return ADDR_REGFILE_A;
        }
      else if (((1 << which_alternative) & 0xc00))
        {
	  return ADDR_REGFILE_B;
        }
      else if (((1 << which_alternative) & 0x3000))
        {
	  return ADDR_REGFILE_A;
        }
      else if (((1 << which_alternative) & 0xc000))
        {
	  return ADDR_REGFILE_B;
        }
      else
        {
	  return ADDR_REGFILE_A;
        }

    case 350:  /* *p movhi_insn */
    case 349:  /* *p movqi_insn */
    case 11:  /* movhi_insn */
    case 10:  /* movqi_insn */
      extract_constrain_insn_cached (insn);
      if (((1 << which_alternative) & 0x3f))
        {
	  return ADDR_REGFILE_UNKNOWN;
        }
      else if (which_alternative == 6)
        {
	  return ADDR_REGFILE_A;
        }
      else if (((1 << which_alternative) & 0x180))
        {
	  return ADDR_REGFILE_B;
        }
      else if (((1 << which_alternative) & 0x600))
        {
	  return ADDR_REGFILE_A;
        }
      else if (((1 << which_alternative) & 0x1800))
        {
	  return ADDR_REGFILE_B;
        }
      else
        {
	  return ADDR_REGFILE_A;
        }

    case 34:  /* movmisalignsi_store */
    case 35:  /* movmisaligndi_store */
    case 36:  /* movmisalignv2hi_store */
    case 37:  /* movmisalignv4qi_store */
    case 38:  /* movmisalignsi_load */
    case 39:  /* movmisaligndi_load */
    case 40:  /* movmisalignv2hi_load */
    case 41:  /* movmisalignv4qi_load */
    case 373:  /* *p movmisalignsi_store */
    case 374:  /* *p movmisaligndi_store */
    case 375:  /* *p movmisalignv2hi_store */
    case 376:  /* *p movmisalignv4qi_store */
    case 377:  /* *p movmisalignsi_load */
    case 378:  /* *p movmisaligndi_load */
    case 379:  /* *p movmisalignv2hi_load */
    case 380:  /* *p movmisalignv4qi_load */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return ADDR_REGFILE_UNKNOWN;
        }
      else if (which_alternative == 1)
        {
	  return ADDR_REGFILE_A;
        }
      else if (which_alternative == 2)
        {
	  return ADDR_REGFILE_B;
        }
      else if (which_alternative == 3)
        {
	  return ADDR_REGFILE_A;
        }
      else
        {
	  return ADDR_REGFILE_B;
        }

    case 7:  /* load_got_gotoff */
    case 159:  /* setup_dsbt */
    case 347:  /* *p load_got_gotoff */
    case 475:  /* *p setup_dsbt */
      return ADDR_REGFILE_B;

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return ADDR_REGFILE_UNKNOWN;

    }
}

int
get_attr_cycles (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  enum attr_type cached_type ATTRIBUTE_UNUSED;

  switch (recog_memoized (insn))
    {
    case 467:  /* *p muldf3 */
    case 151:  /* muldf3 */
      return 10 /* 0xa */;

    case 468:  /* *p *muldf_ext1 */
    case 423:  /* *p subdf3 */
    case 421:  /* *p adddf3 */
    case 152:  /* *muldf_ext1 */
    case 102:  /* subdf3 */
    case 100:  /* adddf3 */
      return 7;

    case 562:  /* *p mulv2hqv2sq3_real */
    case 561:  /* *p dotv2hi_real */
    case 560:  /* *p usmulv4qiv4hi3_real */
    case 559:  /* *p umulv4qiv4hi3_real */
    case 558:  /* *p mulv2hiv2si3_real */
    case 557:  /* *p usmulsidi3_real */
    case 556:  /* *p mulsidi3_real */
    case 555:  /* *p umulsidi3_real */
    case 554:  /* *p mulsi3_insn_real */
    case 530:  /* *p mulv2hqv2sq3 */
    case 529:  /* *p dotv2hi */
    case 528:  /* *p usmulv4qiv4hi3 */
    case 527:  /* *p umulv4qiv4hi3 */
    case 526:  /* *p mulv2hiv2si3 */
    case 525:  /* *p usmulsidi3 */
    case 524:  /* *p mulsidi3 */
    case 523:  /* *p umulsidi3 */
    case 522:  /* *p mulsi3_insn */
    case 466:  /* *p mulsf3 */
    case 434:  /* *p fix_truncdfsi2 */
    case 433:  /* *p fix_truncsfsi2 */
    case 430:  /* *p floatunssisf2 */
    case 429:  /* *p floatsisf2 */
    case 428:  /* *p truncdfsf2 */
    case 422:  /* *p subsf3 */
    case 420:  /* *p addsf3 */
    case 246:  /* mulv2hqv2sq3_real */
    case 245:  /* dotv2hi_real */
    case 244:  /* usmulv4qiv4hi3_real */
    case 243:  /* umulv4qiv4hi3_real */
    case 242:  /* mulv2hiv2si3_real */
    case 241:  /* usmulsidi3_real */
    case 240:  /* mulsidi3_real */
    case 239:  /* umulsidi3_real */
    case 238:  /* mulsi3_insn_real */
    case 214:  /* mulv2hqv2sq3 */
    case 213:  /* dotv2hi */
    case 212:  /* usmulv4qiv4hi3 */
    case 211:  /* umulv4qiv4hi3 */
    case 210:  /* mulv2hiv2si3 */
    case 209:  /* usmulsidi3 */
    case 208:  /* mulsidi3 */
    case 207:  /* umulsidi3 */
    case 206:  /* mulsi3_insn */
    case 150:  /* mulsf3 */
    case 113:  /* fix_truncdfsi2 */
    case 112:  /* fix_truncsfsi2 */
    case 109:  /* floatunssisf2 */
    case 108:  /* floatsisf2 */
    case 107:  /* truncdfsf2 */
    case 101:  /* subsf3 */
    case 99:  /* addsf3 */
    case 77:  /* mvilc */
      return 4;

    case 463:  /* *p udivmodsi4_insn_indcall */
    case 462:  /* *p udivmodsi4_insn */
    case 461:  /* *p umodsi3_insn_indcall */
    case 460:  /* *p umodsi3_insn */
    case 459:  /* *p divmodsi4_insn_indcall */
    case 458:  /* *p divmodsi4_insn */
    case 457:  /* *p modsi3_insn_indcall */
    case 456:  /* *p modsi3_insn */
    case 455:  /* *p udivsi3_insn_indcall */
    case 454:  /* *p udivsi3_insn */
    case 453:  /* *p divsi3_insn_indcall */
    case 452:  /* *p divsi3_insn */
    case 438:  /* *p return_internal */
    case 404:  /* *p real_ret */
    case 403:  /* *p real_jump */
    case 400:  /* *p jump */
    case 399:  /* *p indirect_jump */
    case 147:  /* udivmodsi4_insn_indcall */
    case 146:  /* udivmodsi4_insn */
    case 145:  /* umodsi3_insn_indcall */
    case 144:  /* umodsi3_insn */
    case 143:  /* divmodsi4_insn_indcall */
    case 142:  /* divmodsi4_insn */
    case 141:  /* modsi3_insn_indcall */
    case 140:  /* modsi3_insn */
    case 139:  /* udivsi3_insn_indcall */
    case 138:  /* udivsi3_insn */
    case 137:  /* divsi3_insn_indcall */
    case 136:  /* divsi3_insn */
    case 122:  /* return_internal */
    case 119:  /* sibcall_internal */
    case 118:  /* call_value_internal */
    case 117:  /* call_internal */
    case 83:  /* real_ret */
    case 82:  /* real_call */
    case 81:  /* real_jump */
    case 75:  /* br_false */
    case 74:  /* br_true */
    case 73:  /* casesi_internal */
    case 72:  /* *tablejump_internal */
    case 71:  /* jump */
    case 70:  /* indirect_jump */
      return 6;

    case 566:  /* *p mulhqsq3_hh_real */
    case 565:  /* *p mulhqsq3_hl_real */
    case 564:  /* *p mulhqsq3_lh_real */
    case 563:  /* *p mulhqsq3_real */
    case 553:  /* *p usmulhisi3_hh_real */
    case 552:  /* *p usmulhisi3_hl_real */
    case 551:  /* *p usmulhisi3_lh_real */
    case 550:  /* *p *usmulhisi3_insn_real */
    case 549:  /* *p usmulhisi3_const_real */
    case 548:  /* *p umulhisi3_hh_real */
    case 547:  /* *p umulhisi3_hl_real */
    case 546:  /* *p umulhisi3_lh_real */
    case 545:  /* *p umulhisi3_real */
    case 544:  /* *p mulhisi3_hh_real */
    case 543:  /* *p mulhisi3_hl_real */
    case 542:  /* *p mulhisi3_lh_real */
    case 541:  /* *p *mulhisi3_insn_real */
    case 540:  /* *p mulhisi3_const_real */
    case 539:  /* *p mulhi3_real */
    case 538:  /* *p uavgv4qi3_real */
    case 537:  /* *p avgv2hi3_real */
    case 536:  /* *p bitrevsi2_real */
    case 535:  /* *p rotlsi3_real */
    case 534:  /* *p mulhqsq3_hh */
    case 533:  /* *p mulhqsq3_hl */
    case 532:  /* *p mulhqsq3_lh */
    case 531:  /* *p mulhqsq3 */
    case 521:  /* *p usmulhisi3_hh */
    case 520:  /* *p usmulhisi3_hl */
    case 519:  /* *p usmulhisi3_lh */
    case 518:  /* *p *usmulhisi3_insn */
    case 517:  /* *p usmulhisi3_const */
    case 516:  /* *p umulhisi3_hh */
    case 515:  /* *p umulhisi3_hl */
    case 514:  /* *p umulhisi3_lh */
    case 513:  /* *p umulhisi3 */
    case 512:  /* *p mulhisi3_hh */
    case 511:  /* *p mulhisi3_hl */
    case 510:  /* *p mulhisi3_lh */
    case 509:  /* *p *mulhisi3_insn */
    case 508:  /* *p mulhisi3_const */
    case 507:  /* *p mulhi3 */
    case 506:  /* *p uavgv4qi3 */
    case 505:  /* *p avgv2hi3 */
    case 504:  /* *p bitrevsi2 */
    case 503:  /* *p rotlsi3 */
    case 471:  /* *p rcpdf2 */
    case 427:  /* *p extendsfdf2 */
    case 398:  /* *p *cmpdf_insn */
    case 250:  /* mulhqsq3_hh_real */
    case 249:  /* mulhqsq3_hl_real */
    case 248:  /* mulhqsq3_lh_real */
    case 247:  /* mulhqsq3_real */
    case 237:  /* usmulhisi3_hh_real */
    case 236:  /* usmulhisi3_hl_real */
    case 235:  /* usmulhisi3_lh_real */
    case 234:  /* *usmulhisi3_insn_real */
    case 233:  /* usmulhisi3_const_real */
    case 232:  /* umulhisi3_hh_real */
    case 231:  /* umulhisi3_hl_real */
    case 230:  /* umulhisi3_lh_real */
    case 229:  /* umulhisi3_real */
    case 228:  /* mulhisi3_hh_real */
    case 227:  /* mulhisi3_hl_real */
    case 226:  /* mulhisi3_lh_real */
    case 225:  /* *mulhisi3_insn_real */
    case 224:  /* mulhisi3_const_real */
    case 223:  /* mulhi3_real */
    case 222:  /* uavgv4qi3_real */
    case 221:  /* avgv2hi3_real */
    case 220:  /* bitrevsi2_real */
    case 219:  /* rotlsi3_real */
    case 218:  /* mulhqsq3_hh */
    case 217:  /* mulhqsq3_hl */
    case 216:  /* mulhqsq3_lh */
    case 215:  /* mulhqsq3 */
    case 205:  /* usmulhisi3_hh */
    case 204:  /* usmulhisi3_hl */
    case 203:  /* usmulhisi3_lh */
    case 202:  /* *usmulhisi3_insn */
    case 201:  /* usmulhisi3_const */
    case 200:  /* umulhisi3_hh */
    case 199:  /* umulhisi3_hl */
    case 198:  /* umulhisi3_lh */
    case 197:  /* umulhisi3 */
    case 196:  /* mulhisi3_hh */
    case 195:  /* mulhisi3_hl */
    case 194:  /* mulhisi3_lh */
    case 193:  /* *mulhisi3_insn */
    case 192:  /* mulhisi3_const */
    case 191:  /* mulhi3 */
    case 190:  /* uavgv4qi3 */
    case 189:  /* avgv2hi3 */
    case 188:  /* bitrevsi2 */
    case 187:  /* rotlsi3 */
    case 155:  /* rcpdf2 */
    case 106:  /* extendsfdf2 */
    case 69:  /* *cmpdf_ior_insn */
    case 68:  /* *cmpdf_and_insn */
    case 65:  /* *cmpdf_insn */
      return 2;

    case 384:  /* *p sign_extendhisi2 */
    case 383:  /* *p zero_extendhisi2 */
    case 382:  /* *p sign_extendqisi2 */
    case 381:  /* *p zero_extendqisi2 */
    case 45:  /* sign_extendhisi2 */
    case 44:  /* zero_extendhisi2 */
    case 43:  /* sign_extendqisi2 */
    case 42:  /* zero_extendqisi2 */
      extract_constrain_insn_cached (insn);
      if (!((1 << which_alternative) & 0x3))
        {
	  return 5;
        }
      else
        {
	  return 1;
        }

    case 359:  /* *p *movv8qi_insn */
    case 358:  /* *p *movv4hi_insn */
    case 357:  /* *p *movv2si_insn */
    case 356:  /* *p *movdf_insn */
    case 355:  /* *p *movdi_insn */
    case 20:  /* *movv8qi_insn */
    case 19:  /* *movv4hi_insn */
    case 18:  /* *movv2si_insn */
    case 17:  /* *movdf_insn */
    case 16:  /* *movdi_insn */
      extract_constrain_insn_cached (insn);
      if (((1 << which_alternative) & 0x1e0))
        {
	  return 5;
        }
      else
        {
	  return 1;
        }

    case 354:  /* *p movv4qi_insn */
    case 353:  /* *p movv2hi_insn */
    case 352:  /* *p movsf_insn */
    case 351:  /* *p movsi_insn */
    case 15:  /* movv4qi_insn */
    case 14:  /* movv2hi_insn */
    case 13:  /* movsf_insn */
    case 12:  /* movsi_insn */
      extract_constrain_insn_cached (insn);
      if (((1 << which_alternative) & 0x1e00))
        {
	  return 5;
        }
      else
        {
	  return 1;
        }

    case 350:  /* *p movhi_insn */
    case 349:  /* *p movqi_insn */
    case 11:  /* movhi_insn */
    case 10:  /* movqi_insn */
      extract_constrain_insn_cached (insn);
      if (((1 << which_alternative) & 0x3c0))
        {
	  return 5;
        }
      else
        {
	  return 1;
        }

    case 475:  /* *p setup_dsbt */
    case 469:  /* *p *muldf_ext2 */
    case 432:  /* *p floatunssidf2 */
    case 431:  /* *p floatsidf2 */
    case 390:  /* *p real_sign_extendhi */
    case 389:  /* *p real_zero_extendhi */
    case 388:  /* *p real_sign_extendqi */
    case 387:  /* *p real_zero_extendqi */
    case 380:  /* *p movmisalignv4qi_load */
    case 379:  /* *p movmisalignv2hi_load */
    case 378:  /* *p movmisaligndi_load */
    case 377:  /* *p movmisalignsi_load */
    case 370:  /* *p real_loadv8qi */
    case 369:  /* *p real_loadv4hi */
    case 368:  /* *p real_loadv2si */
    case 367:  /* *p real_loaddf */
    case 366:  /* *p real_loaddi */
    case 365:  /* *p real_loadv4qi */
    case 364:  /* *p real_loadv2hi */
    case 363:  /* *p real_loadsf */
    case 362:  /* *p real_loadsi */
    case 361:  /* *p real_loadhi */
    case 360:  /* *p real_loadqi */
    case 347:  /* *p load_got_gotoff */
    case 159:  /* setup_dsbt */
    case 153:  /* *muldf_ext2 */
    case 111:  /* floatunssidf2 */
    case 110:  /* floatsidf2 */
    case 51:  /* real_sign_extendhi */
    case 50:  /* real_zero_extendhi */
    case 49:  /* real_sign_extendqi */
    case 48:  /* real_zero_extendqi */
    case 41:  /* movmisalignv4qi_load */
    case 40:  /* movmisalignv2hi_load */
    case 39:  /* movmisaligndi_load */
    case 38:  /* movmisalignsi_load */
    case 31:  /* real_loadv8qi */
    case 30:  /* real_loadv4hi */
    case 29:  /* real_loadv2si */
    case 28:  /* real_loaddf */
    case 27:  /* real_loaddi */
    case 26:  /* real_loadv4qi */
    case 25:  /* real_loadv2hi */
    case 24:  /* real_loadsf */
    case 23:  /* real_loadsi */
    case 22:  /* real_loadhi */
    case 21:  /* real_loadqi */
    case 7:  /* load_got_gotoff */
      return 5;

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
      if (((cached_type = get_attr_type (insn)) == TYPE_BRANCH) || (cached_type == TYPE_CALL))
        {
	  return 6;
        }
      else if ((cached_type == TYPE_LOAD) || (cached_type == TYPE_LOADN))
        {
	  return 5;
        }
      else if (cached_type == TYPE_DP2)
        {
	  return 2;
        }
      else if (cached_type == TYPE_MPY2)
        {
	  return 2;
        }
      else if (cached_type == TYPE_MPY4)
        {
	  return 4;
        }
      else if (cached_type == TYPE_FP4)
        {
	  return 4;
        }
      else if (cached_type == TYPE_MVILC)
        {
	  return 4;
        }
      else if (cached_type == TYPE_CMPDP)
        {
	  return 2;
        }
      else if (cached_type == TYPE_INTDP)
        {
	  return 5;
        }
      else if (cached_type == TYPE_ADDDP)
        {
	  return 7;
        }
      else if (cached_type == TYPE_MPYDP)
        {
	  return 10 /* 0xa */;
        }
      else if (cached_type == TYPE_MPYI)
        {
	  return 9;
        }
      else if (cached_type == TYPE_MPYID)
        {
	  return 10 /* 0xa */;
        }
      else if (cached_type == TYPE_MPYSPDP)
        {
	  return 7;
        }
      else if (cached_type == TYPE_MPYSP2DP)
        {
	  return 5;
        }
      else
        {
	  return 1;
        }

    default:
      return 1;

    }
}

enum attr_cross
get_attr_cross (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case 435:  /* *p saddsi3 */
    case 114:  /* saddsi3 */
      extract_constrain_insn_cached (insn);
      if (((1 << which_alternative) & 0x3))
        {
	  return CROSS_N;
        }
      else if (((1 << which_alternative) & 0xc))
        {
	  return CROSS_Y;
        }
      else if (((1 << which_alternative) & 0x30))
        {
	  return CROSS_N;
        }
      else
        {
	  return CROSS_Y;
        }

    case 501:  /* *p *packv2hi_insv */
    case 425:  /* *p iorsi3 */
    case 424:  /* *p andsi3 */
    case 185:  /* *packv2hi_insv */
    case 104:  /* iorsi3 */
    case 103:  /* andsi3 */
      extract_constrain_insn_cached (insn);
      if (((1 << which_alternative) & 0x3))
        {
	  return CROSS_N;
        }
      else if (((1 << which_alternative) & 0xc))
        {
	  return CROSS_Y;
        }
      else
        {
	  return CROSS_N;
        }

    case 416:  /* *p subsi3 */
    case 95:  /* subsi3 */
      extract_constrain_insn_cached (insn);
      if (((1 << which_alternative) & 0xf))
        {
	  return CROSS_N;
        }
      else
        {
	  return CROSS_Y;
        }

    case 415:  /* *p addsi3 */
    case 94:  /* addsi3 */
      extract_constrain_insn_cached (insn);
      if (((1 << which_alternative) & 0x3))
        {
	  return CROSS_N;
        }
      else if (((1 << which_alternative) & 0xfc))
        {
	  return CROSS_Y;
        }
      else if (((1 << which_alternative) & 0x700))
        {
	  return CROSS_N;
        }
      else if (which_alternative == 11)
        {
	  return CROSS_Y;
        }
      else
        {
	  return CROSS_N;
        }

    case 384:  /* *p sign_extendhisi2 */
    case 383:  /* *p zero_extendhisi2 */
    case 382:  /* *p sign_extendqisi2 */
    case 381:  /* *p zero_extendqisi2 */
    case 45:  /* sign_extendhisi2 */
    case 44:  /* zero_extendhisi2 */
    case 43:  /* sign_extendqisi2 */
    case 42:  /* zero_extendqisi2 */
      extract_constrain_insn_cached (insn);
      if (((1 << which_alternative) & 0x7))
        {
	  return CROSS_N;
        }
      else if (which_alternative == 3)
        {
	  return CROSS_Y;
        }
      else if (which_alternative == 4)
        {
	  return CROSS_N;
        }
      else
        {
	  return CROSS_Y;
        }

    case 380:  /* *p movmisalignv4qi_load */
    case 379:  /* *p movmisalignv2hi_load */
    case 378:  /* *p movmisaligndi_load */
    case 377:  /* *p movmisalignsi_load */
    case 376:  /* *p movmisalignv4qi_store */
    case 375:  /* *p movmisalignv2hi_store */
    case 374:  /* *p movmisaligndi_store */
    case 373:  /* *p movmisalignsi_store */
    case 41:  /* movmisalignv4qi_load */
    case 40:  /* movmisalignv2hi_load */
    case 39:  /* movmisaligndi_load */
    case 38:  /* movmisalignsi_load */
    case 37:  /* movmisalignv4qi_store */
    case 36:  /* movmisalignv2hi_store */
    case 35:  /* movmisaligndi_store */
    case 34:  /* movmisalignsi_store */
      extract_constrain_insn_cached (insn);
      if (((1 << which_alternative) & 0x7))
        {
	  return CROSS_N;
        }
      else
        {
	  return CROSS_Y;
        }

    case 359:  /* *p *movv8qi_insn */
    case 358:  /* *p *movv4hi_insn */
    case 357:  /* *p *movv2si_insn */
    case 356:  /* *p *movdf_insn */
    case 355:  /* *p *movdi_insn */
    case 20:  /* *movv8qi_insn */
    case 19:  /* *movv4hi_insn */
    case 18:  /* *movv2si_insn */
    case 17:  /* *movdf_insn */
    case 16:  /* *movdi_insn */
      extract_constrain_insn_cached (insn);
      if (((1 << which_alternative) & 0x3))
        {
	  return CROSS_N;
        }
      else if (((1 << which_alternative) & 0xc))
        {
	  return CROSS_Y;
        }
      else if (((1 << which_alternative) & 0x30))
        {
	  return CROSS_N;
        }
      else if (which_alternative == 6)
        {
	  return CROSS_Y;
        }
      else if (which_alternative == 7)
        {
	  return CROSS_N;
        }
      else if (which_alternative == 8)
        {
	  return CROSS_Y;
        }
      else if (which_alternative == 9)
        {
	  return CROSS_N;
        }
      else if (which_alternative == 10)
        {
	  return CROSS_Y;
        }
      else if (which_alternative == 11)
        {
	  return CROSS_N;
        }
      else
        {
	  return CROSS_Y;
        }

    case 354:  /* *p movv4qi_insn */
    case 353:  /* *p movv2hi_insn */
    case 352:  /* *p movsf_insn */
    case 351:  /* *p movsi_insn */
    case 15:  /* movv4qi_insn */
    case 14:  /* movv2hi_insn */
    case 13:  /* movsf_insn */
    case 12:  /* movsi_insn */
      extract_constrain_insn_cached (insn);
      if (((1 << which_alternative) & 0x3))
        {
	  return CROSS_N;
        }
      else if (((1 << which_alternative) & 0xc))
        {
	  return CROSS_Y;
        }
      else if (((1 << which_alternative) & 0x30))
        {
	  return CROSS_N;
        }
      else if (which_alternative == 6)
        {
	  return CROSS_Y;
        }
      else if (((1 << which_alternative) & 0x380))
        {
	  return CROSS_N;
        }
      else if (which_alternative == 10)
        {
	  return CROSS_Y;
        }
      else if (which_alternative == 11)
        {
	  return CROSS_N;
        }
      else if (which_alternative == 12)
        {
	  return CROSS_Y;
        }
      else if (which_alternative == 13)
        {
	  return CROSS_N;
        }
      else if (which_alternative == 14)
        {
	  return CROSS_Y;
        }
      else if (which_alternative == 15)
        {
	  return CROSS_N;
        }
      else
        {
	  return CROSS_Y;
        }

    case 350:  /* *p movhi_insn */
    case 349:  /* *p movqi_insn */
    case 11:  /* movhi_insn */
    case 10:  /* movqi_insn */
      extract_constrain_insn_cached (insn);
      if (((1 << which_alternative) & 0x3))
        {
	  return CROSS_N;
        }
      else if (((1 << which_alternative) & 0xc))
        {
	  return CROSS_Y;
        }
      else if (((1 << which_alternative) & 0x70))
        {
	  return CROSS_N;
        }
      else if (which_alternative == 7)
        {
	  return CROSS_Y;
        }
      else if (which_alternative == 8)
        {
	  return CROSS_N;
        }
      else if (which_alternative == 9)
        {
	  return CROSS_Y;
        }
      else if (which_alternative == 10)
        {
	  return CROSS_N;
        }
      else if (which_alternative == 11)
        {
	  return CROSS_Y;
        }
      else if (which_alternative == 12)
        {
	  return CROSS_N;
        }
      else
        {
	  return CROSS_Y;
        }

    case 117:  /* call_internal */
    case 118:  /* call_value_internal */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return CROSS_N;
        }
      else if (which_alternative == 1)
        {
	  return CROSS_Y;
        }
      else
        {
	  return CROSS_N;
        }

    case 55:  /* scmpsi_insn */
    case 56:  /* *ucmpsi_insn_64 */
    case 57:  /* *ucmpsi_insn */
    case 394:  /* *p scmpsi_insn */
    case 395:  /* *p *ucmpsi_insn_64 */
    case 396:  /* *p *ucmpsi_insn */
      extract_constrain_insn_cached (insn);
      return 
#line 1054 "../../gcc-8.1.1-20180626/gcc/config/c6x/c6x.md"
(CROSS_OPERANDS (operands[0], operands[2]));

    case 403:  /* *p real_jump */
    case 82:  /* real_call */
    case 81:  /* real_jump */
    case 9:  /* load_sdata_pic */
    case 70:  /* indirect_jump */
    case 77:  /* mvilc */
    case 83:  /* real_ret */
    case 399:  /* *p indirect_jump */
    case 404:  /* *p real_ret */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return CROSS_Y;
        }
      else
        {
	  return CROSS_N;
        }

    case 21:  /* real_loadqi */
    case 22:  /* real_loadhi */
    case 23:  /* real_loadsi */
    case 24:  /* real_loadsf */
    case 25:  /* real_loadv2hi */
    case 26:  /* real_loadv4qi */
    case 27:  /* real_loaddi */
    case 28:  /* real_loaddf */
    case 29:  /* real_loadv2si */
    case 30:  /* real_loadv4hi */
    case 31:  /* real_loadv8qi */
    case 48:  /* real_zero_extendqi */
    case 49:  /* real_sign_extendqi */
    case 50:  /* real_zero_extendhi */
    case 51:  /* real_sign_extendhi */
    case 54:  /* extru */
    case 124:  /* negsi2 */
    case 125:  /* one_cmplsi2 */
    case 126:  /* clrsbsi2 */
    case 127:  /* clzsi2 */
    case 128:  /* ssabssi2 */
    case 184:  /* ssabsv2hi2 */
    case 188:  /* bitrevsi2 */
    case 220:  /* bitrevsi2_real */
    case 360:  /* *p real_loadqi */
    case 361:  /* *p real_loadhi */
    case 362:  /* *p real_loadsi */
    case 363:  /* *p real_loadsf */
    case 364:  /* *p real_loadv2hi */
    case 365:  /* *p real_loadv4qi */
    case 366:  /* *p real_loaddi */
    case 367:  /* *p real_loaddf */
    case 368:  /* *p real_loadv2si */
    case 369:  /* *p real_loadv4hi */
    case 370:  /* *p real_loadv8qi */
    case 387:  /* *p real_zero_extendqi */
    case 388:  /* *p real_sign_extendqi */
    case 389:  /* *p real_zero_extendhi */
    case 390:  /* *p real_sign_extendhi */
    case 393:  /* *p extru */
    case 440:  /* *p negsi2 */
    case 441:  /* *p one_cmplsi2 */
    case 442:  /* *p clrsbsi2 */
    case 443:  /* *p clzsi2 */
    case 444:  /* *p ssabssi2 */
    case 500:  /* *p ssabsv2hi2 */
    case 504:  /* *p bitrevsi2 */
    case 536:  /* *p bitrevsi2_real */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return CROSS_N;
        }
      else if (which_alternative == 1)
        {
	  return CROSS_Y;
        }
      else if (which_alternative == 2)
        {
	  return CROSS_N;
        }
      else
        {
	  return CROSS_Y;
        }

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    case 1:  /* nop */
    case 2:  /* nop_count */
    case 3:  /* movsi_lo_sum */
    case 4:  /* movsi_high */
    case 5:  /* movsi_gotoff_lo_sum */
    case 6:  /* movsi_gotoff_high */
    case 7:  /* load_got_gotoff */
    case 8:  /* *movstricthi_high */
    case 32:  /* load_shadow */
    case 33:  /* mult_shadow */
    case 46:  /* *extzv_const */
    case 47:  /* *extv_const */
    case 71:  /* jump */
    case 72:  /* *tablejump_internal */
    case 73:  /* casesi_internal */
    case 74:  /* br_true */
    case 75:  /* br_false */
    case 76:  /* eh_return */
    case 78:  /* sploop */
    case 79:  /* spkernel */
    case 80:  /* loop_end */
    case 84:  /* indirect_jump_shadow */
    case 85:  /* indirect_call_value_shadow */
    case 86:  /* indirect_sibcall_shadow */
    case 87:  /* indirect_call_shadow */
    case 88:  /* call_value_shadow */
    case 89:  /* call_shadow */
    case 90:  /* sibcall_shadow */
    case 91:  /* jump_shadow */
    case 92:  /* condjump_shadow */
    case 93:  /* return_shadow */
    case 96:  /* *addshiftsi */
    case 97:  /* *subshiftsi */
    case 107:  /* truncdfsf2 */
    case 113:  /* fix_truncdfsi2 */
    case 119:  /* sibcall_internal */
    case 120:  /* callp */
    case 121:  /* callp_value */
    case 122:  /* return_internal */
    case 123:  /* addkpc */
    case 133:  /* rotrdi3_16 */
    case 136:  /* divsi3_insn */
    case 137:  /* divsi3_insn_indcall */
    case 138:  /* udivsi3_insn */
    case 139:  /* udivsi3_insn_indcall */
    case 140:  /* modsi3_insn */
    case 141:  /* modsi3_insn_indcall */
    case 142:  /* divmodsi4_insn */
    case 143:  /* divmodsi4_insn_indcall */
    case 144:  /* umodsi3_insn */
    case 145:  /* umodsi3_insn_indcall */
    case 146:  /* udivmodsi4_insn */
    case 147:  /* udivmodsi4_insn_indcall */
    case 148:  /* divmodsi4 */
    case 149:  /* udivmodsi4 */
    case 151:  /* muldf3 */
    case 155:  /* rcpdf2 */
    case 156:  /* blockage */
    case 157:  /* push_rts */
    case 158:  /* pop_rts */
    case 159:  /* setup_dsbt */
    case 160:  /* epilogue_barrier */
    case 251:  /* *sync_compare_and_swapsi */
    case 252:  /* sync_addsi_insn */
    case 253:  /* sync_subsi_insn */
    case 254:  /* sync_iorsi_insn */
    case 255:  /* sync_xorsi_insn */
    case 256:  /* sync_andsi_insn */
    case 257:  /* sync_old_addsi_insn */
    case 258:  /* sync_old_subsi_insn */
    case 259:  /* sync_old_iorsi_insn */
    case 260:  /* sync_old_xorsi_insn */
    case 261:  /* sync_old_andsi_insn */
    case 262:  /* sync_new_addsi_insn */
    case 263:  /* sync_new_subsi_insn */
    case 264:  /* sync_new_iorsi_insn */
    case 265:  /* sync_new_xorsi_insn */
    case 266:  /* sync_new_andsi_insn */
    case 267:  /* sync_nandsi_insn */
    case 268:  /* sync_old_nandsi_insn */
    case 269:  /* sync_new_nandsi_insn */
    case 341:  /* *p nop */
    case 342:  /* *p nop_count */
    case 343:  /* *p movsi_lo_sum */
    case 344:  /* *p movsi_high */
    case 345:  /* *p movsi_gotoff_lo_sum */
    case 346:  /* *p movsi_gotoff_high */
    case 347:  /* *p load_got_gotoff */
    case 348:  /* *p *movstricthi_high */
    case 371:  /* *p load_shadow */
    case 372:  /* *p mult_shadow */
    case 385:  /* *p *extzv_const */
    case 386:  /* *p *extv_const */
    case 400:  /* *p jump */
    case 401:  /* *p eh_return */
    case 402:  /* *p loop_end */
    case 405:  /* *p indirect_jump_shadow */
    case 406:  /* *p indirect_call_value_shadow */
    case 407:  /* *p indirect_sibcall_shadow */
    case 408:  /* *p indirect_call_shadow */
    case 409:  /* *p call_value_shadow */
    case 410:  /* *p call_shadow */
    case 411:  /* *p sibcall_shadow */
    case 412:  /* *p jump_shadow */
    case 413:  /* *p condjump_shadow */
    case 414:  /* *p return_shadow */
    case 417:  /* *p *addshiftsi */
    case 418:  /* *p *subshiftsi */
    case 428:  /* *p truncdfsf2 */
    case 434:  /* *p fix_truncdfsi2 */
    case 438:  /* *p return_internal */
    case 439:  /* *p addkpc */
    case 449:  /* *p rotrdi3_16 */
    case 452:  /* *p divsi3_insn */
    case 453:  /* *p divsi3_insn_indcall */
    case 454:  /* *p udivsi3_insn */
    case 455:  /* *p udivsi3_insn_indcall */
    case 456:  /* *p modsi3_insn */
    case 457:  /* *p modsi3_insn_indcall */
    case 458:  /* *p divmodsi4_insn */
    case 459:  /* *p divmodsi4_insn_indcall */
    case 460:  /* *p umodsi3_insn */
    case 461:  /* *p umodsi3_insn_indcall */
    case 462:  /* *p udivmodsi4_insn */
    case 463:  /* *p udivmodsi4_insn_indcall */
    case 464:  /* *p divmodsi4 */
    case 465:  /* *p udivmodsi4 */
    case 467:  /* *p muldf3 */
    case 471:  /* *p rcpdf2 */
    case 472:  /* *p blockage */
    case 473:  /* *p push_rts */
    case 474:  /* *p pop_rts */
    case 475:  /* *p setup_dsbt */
    case 476:  /* *p epilogue_barrier */
    case 567:  /* *p *sync_compare_and_swapsi */
    case 568:  /* *p sync_addsi_insn */
    case 569:  /* *p sync_subsi_insn */
    case 570:  /* *p sync_iorsi_insn */
    case 571:  /* *p sync_xorsi_insn */
    case 572:  /* *p sync_andsi_insn */
    case 573:  /* *p sync_old_addsi_insn */
    case 574:  /* *p sync_old_subsi_insn */
    case 575:  /* *p sync_old_iorsi_insn */
    case 576:  /* *p sync_old_xorsi_insn */
    case 577:  /* *p sync_old_andsi_insn */
    case 578:  /* *p sync_new_addsi_insn */
    case 579:  /* *p sync_new_subsi_insn */
    case 580:  /* *p sync_new_iorsi_insn */
    case 581:  /* *p sync_new_xorsi_insn */
    case 582:  /* *p sync_new_andsi_insn */
    case 583:  /* *p sync_nandsi_insn */
    case 584:  /* *p sync_old_nandsi_insn */
    case 585:  /* *p sync_new_nandsi_insn */
      return CROSS_N;

    default:
      extract_constrain_insn_cached (insn);
      if (((1 << which_alternative) & 0x3))
        {
	  return CROSS_N;
        }
      else
        {
	  return CROSS_Y;
        }

    }
}

enum attr_ce_enabled
get_attr_ce_enabled (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case 415:  /* *p addsi3 */
      extract_constrain_insn_cached (insn);
      if (((1 << which_alternative) & 0x7ff))
        {
	  return CE_ENABLED_YES;
        }
      else if (((1 << which_alternative) & 0x1800))
        {
	  return CE_ENABLED_NO;
        }
      else
        {
	  return CE_ENABLED_YES;
        }

    case 354:  /* *p movv4qi_insn */
    case 353:  /* *p movv2hi_insn */
    case 352:  /* *p movsf_insn */
    case 351:  /* *p movsi_insn */
      extract_constrain_insn_cached (insn);
      if (((1 << which_alternative) & 0x3f))
        {
	  return CE_ENABLED_YES;
        }
      else if (((1 << which_alternative) & 0xc0))
        {
	  return CE_ENABLED_NO;
        }
      else
        {
	  return CE_ENABLED_YES;
        }

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return CE_ENABLED_YES;

    }
}

enum attr_dest_regfile
get_attr_dest_regfile (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  enum attr_type cached_type ATTRIBUTE_UNUSED;

  switch (recog_memoized (insn))
    {
    case 403:  /* *p real_jump */
    case 82:  /* real_call */
    case 81:  /* real_jump */
      extract_constrain_insn_cached (insn);
      if (((1 << which_alternative) & 0x3))
        {
	  return DEST_REGFILE_B;
        }
      else
        {
	  return DEST_REGFILE_ANY;
        }

    case 380:  /* *p movmisalignv4qi_load */
    case 379:  /* *p movmisalignv2hi_load */
    case 378:  /* *p movmisaligndi_load */
    case 377:  /* *p movmisalignsi_load */
    case 376:  /* *p movmisalignv4qi_store */
    case 375:  /* *p movmisalignv2hi_store */
    case 374:  /* *p movmisaligndi_store */
    case 373:  /* *p movmisalignsi_store */
    case 41:  /* movmisalignv4qi_load */
    case 40:  /* movmisalignv2hi_load */
    case 39:  /* movmisaligndi_load */
    case 38:  /* movmisalignsi_load */
    case 37:  /* movmisalignv4qi_store */
    case 36:  /* movmisalignv2hi_store */
    case 35:  /* movmisaligndi_store */
    case 34:  /* movmisalignsi_store */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return DEST_REGFILE_UNKNOWN;
        }
      else if (which_alternative == 1)
        {
	  return DEST_REGFILE_A;
        }
      else if (((1 << which_alternative) & 0xc))
        {
	  return DEST_REGFILE_B;
        }
      else
        {
	  return DEST_REGFILE_A;
        }

    case 390:  /* *p real_sign_extendhi */
    case 389:  /* *p real_zero_extendhi */
    case 388:  /* *p real_sign_extendqi */
    case 387:  /* *p real_zero_extendqi */
    case 370:  /* *p real_loadv8qi */
    case 369:  /* *p real_loadv4hi */
    case 368:  /* *p real_loadv2si */
    case 367:  /* *p real_loaddf */
    case 366:  /* *p real_loaddi */
    case 365:  /* *p real_loadv4qi */
    case 364:  /* *p real_loadv2hi */
    case 363:  /* *p real_loadsf */
    case 362:  /* *p real_loadsi */
    case 361:  /* *p real_loadhi */
    case 360:  /* *p real_loadqi */
    case 51:  /* real_sign_extendhi */
    case 50:  /* real_zero_extendhi */
    case 49:  /* real_sign_extendqi */
    case 48:  /* real_zero_extendqi */
    case 31:  /* real_loadv8qi */
    case 30:  /* real_loadv4hi */
    case 29:  /* real_loadv2si */
    case 28:  /* real_loaddf */
    case 27:  /* real_loaddi */
    case 26:  /* real_loadv4qi */
    case 25:  /* real_loadv2hi */
    case 24:  /* real_loadsf */
    case 23:  /* real_loadsi */
    case 22:  /* real_loadhi */
    case 21:  /* real_loadqi */
      extract_constrain_insn_cached (insn);
      if (((1 << which_alternative) & 0x3))
        {
	  return DEST_REGFILE_A;
        }
      else
        {
	  return DEST_REGFILE_B;
        }

    case 118:  /* call_value_internal */
    case 117:  /* call_internal */
    case 119:  /* sibcall_internal */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return DEST_REGFILE_ANY;
        }
      else
        {
	  return DEST_REGFILE_B;
        }

    case 7:  /* load_got_gotoff */
    case 347:  /* *p load_got_gotoff */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return DEST_REGFILE_A;
        }
      else
        {
	  return DEST_REGFILE_B;
        }

    case 10:  /* movqi_insn */
    case 11:  /* movhi_insn */
    case 349:  /* *p movqi_insn */
    case 350:  /* *p movhi_insn */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  if (((cached_type = get_attr_type (insn)) == TYPE_SINGLE) || (cached_type == TYPE_LOAD) || (cached_type == TYPE_MPY2) || (cached_type == TYPE_MPY4) || (cached_type == TYPE_DP2) || (cached_type == TYPE_FP4) || (cached_type == TYPE_INTDP) || (cached_type == TYPE_CMPDP) || (cached_type == TYPE_ADDDP) || (cached_type == TYPE_MPY) || (cached_type == TYPE_MPYI) || (cached_type == TYPE_MPYID) || (cached_type == TYPE_MPYDP) || (cached_type == TYPE_MPYSPDP) || (cached_type == TYPE_MPYSP2DP))
	    {
	      if (a_register (operands[0], VOIDmode))
	        {
		  return DEST_REGFILE_A;
	        }
	      else if (b_register (operands[0], VOIDmode))
	        {
		  return DEST_REGFILE_B;
	        }
	      else
	        {
		  return DEST_REGFILE_UNKNOWN;
	        }
	    }
	  else if (cached_type == TYPE_STORE)
	    {
	      if (a_register (operands[1], VOIDmode))
	        {
		  return DEST_REGFILE_A;
	        }
	      else if (b_register (operands[1], VOIDmode))
	        {
		  return DEST_REGFILE_B;
	        }
	      else
	        {
		  return DEST_REGFILE_UNKNOWN;
	        }
	    }
	  else
	    {
	      return DEST_REGFILE_UNKNOWN;
	    }
        }
      else if (which_alternative == 1)
        {
	  if (((cached_type = get_attr_type (insn)) == TYPE_SINGLE) || (cached_type == TYPE_LOAD) || (cached_type == TYPE_MPY2) || (cached_type == TYPE_MPY4) || (cached_type == TYPE_DP2) || (cached_type == TYPE_FP4) || (cached_type == TYPE_INTDP) || (cached_type == TYPE_CMPDP) || (cached_type == TYPE_ADDDP) || (cached_type == TYPE_MPY) || (cached_type == TYPE_MPYI) || (cached_type == TYPE_MPYID) || (cached_type == TYPE_MPYDP) || (cached_type == TYPE_MPYSPDP) || (cached_type == TYPE_MPYSP2DP))
	    {
	      if (a_register (operands[0], VOIDmode))
	        {
		  return DEST_REGFILE_A;
	        }
	      else if (b_register (operands[0], VOIDmode))
	        {
		  return DEST_REGFILE_B;
	        }
	      else
	        {
		  return DEST_REGFILE_UNKNOWN;
	        }
	    }
	  else if (cached_type == TYPE_STORE)
	    {
	      if (a_register (operands[1], VOIDmode))
	        {
		  return DEST_REGFILE_A;
	        }
	      else if (b_register (operands[1], VOIDmode))
	        {
		  return DEST_REGFILE_B;
	        }
	      else
	        {
		  return DEST_REGFILE_UNKNOWN;
	        }
	    }
	  else
	    {
	      return DEST_REGFILE_UNKNOWN;
	    }
        }
      else if (which_alternative == 2)
        {
	  if (((cached_type = get_attr_type (insn)) == TYPE_SINGLE) || (cached_type == TYPE_LOAD) || (cached_type == TYPE_MPY2) || (cached_type == TYPE_MPY4) || (cached_type == TYPE_DP2) || (cached_type == TYPE_FP4) || (cached_type == TYPE_INTDP) || (cached_type == TYPE_CMPDP) || (cached_type == TYPE_ADDDP) || (cached_type == TYPE_MPY) || (cached_type == TYPE_MPYI) || (cached_type == TYPE_MPYID) || (cached_type == TYPE_MPYDP) || (cached_type == TYPE_MPYSPDP) || (cached_type == TYPE_MPYSP2DP))
	    {
	      if (a_register (operands[0], VOIDmode))
	        {
		  return DEST_REGFILE_A;
	        }
	      else if (b_register (operands[0], VOIDmode))
	        {
		  return DEST_REGFILE_B;
	        }
	      else
	        {
		  return DEST_REGFILE_UNKNOWN;
	        }
	    }
	  else if (cached_type == TYPE_STORE)
	    {
	      if (a_register (operands[1], VOIDmode))
	        {
		  return DEST_REGFILE_A;
	        }
	      else if (b_register (operands[1], VOIDmode))
	        {
		  return DEST_REGFILE_B;
	        }
	      else
	        {
		  return DEST_REGFILE_UNKNOWN;
	        }
	    }
	  else
	    {
	      return DEST_REGFILE_UNKNOWN;
	    }
        }
      else if (which_alternative == 3)
        {
	  if (((cached_type = get_attr_type (insn)) == TYPE_SINGLE) || (cached_type == TYPE_LOAD) || (cached_type == TYPE_MPY2) || (cached_type == TYPE_MPY4) || (cached_type == TYPE_DP2) || (cached_type == TYPE_FP4) || (cached_type == TYPE_INTDP) || (cached_type == TYPE_CMPDP) || (cached_type == TYPE_ADDDP) || (cached_type == TYPE_MPY) || (cached_type == TYPE_MPYI) || (cached_type == TYPE_MPYID) || (cached_type == TYPE_MPYDP) || (cached_type == TYPE_MPYSPDP) || (cached_type == TYPE_MPYSP2DP))
	    {
	      if (a_register (operands[0], VOIDmode))
	        {
		  return DEST_REGFILE_A;
	        }
	      else if (b_register (operands[0], VOIDmode))
	        {
		  return DEST_REGFILE_B;
	        }
	      else
	        {
		  return DEST_REGFILE_UNKNOWN;
	        }
	    }
	  else if (cached_type == TYPE_STORE)
	    {
	      if (a_register (operands[1], VOIDmode))
	        {
		  return DEST_REGFILE_A;
	        }
	      else if (b_register (operands[1], VOIDmode))
	        {
		  return DEST_REGFILE_B;
	        }
	      else
	        {
		  return DEST_REGFILE_UNKNOWN;
	        }
	    }
	  else
	    {
	      return DEST_REGFILE_UNKNOWN;
	    }
        }
      else if (which_alternative == 4)
        {
	  if (((cached_type = get_attr_type (insn)) == TYPE_SINGLE) || (cached_type == TYPE_LOAD) || (cached_type == TYPE_MPY2) || (cached_type == TYPE_MPY4) || (cached_type == TYPE_DP2) || (cached_type == TYPE_FP4) || (cached_type == TYPE_INTDP) || (cached_type == TYPE_CMPDP) || (cached_type == TYPE_ADDDP) || (cached_type == TYPE_MPY) || (cached_type == TYPE_MPYI) || (cached_type == TYPE_MPYID) || (cached_type == TYPE_MPYDP) || (cached_type == TYPE_MPYSPDP) || (cached_type == TYPE_MPYSP2DP))
	    {
	      if (a_register (operands[0], VOIDmode))
	        {
		  return DEST_REGFILE_A;
	        }
	      else if (b_register (operands[0], VOIDmode))
	        {
		  return DEST_REGFILE_B;
	        }
	      else
	        {
		  return DEST_REGFILE_UNKNOWN;
	        }
	    }
	  else if (cached_type == TYPE_STORE)
	    {
	      if (a_register (operands[1], VOIDmode))
	        {
		  return DEST_REGFILE_A;
	        }
	      else if (b_register (operands[1], VOIDmode))
	        {
		  return DEST_REGFILE_B;
	        }
	      else
	        {
		  return DEST_REGFILE_UNKNOWN;
	        }
	    }
	  else
	    {
	      return DEST_REGFILE_UNKNOWN;
	    }
        }
      else if (which_alternative == 5)
        {
	  if (((cached_type = get_attr_type (insn)) == TYPE_SINGLE) || (cached_type == TYPE_LOAD) || (cached_type == TYPE_MPY2) || (cached_type == TYPE_MPY4) || (cached_type == TYPE_DP2) || (cached_type == TYPE_FP4) || (cached_type == TYPE_INTDP) || (cached_type == TYPE_CMPDP) || (cached_type == TYPE_ADDDP) || (cached_type == TYPE_MPY) || (cached_type == TYPE_MPYI) || (cached_type == TYPE_MPYID) || (cached_type == TYPE_MPYDP) || (cached_type == TYPE_MPYSPDP) || (cached_type == TYPE_MPYSP2DP))
	    {
	      if (a_register (operands[0], VOIDmode))
	        {
		  return DEST_REGFILE_A;
	        }
	      else if (b_register (operands[0], VOIDmode))
	        {
		  return DEST_REGFILE_B;
	        }
	      else
	        {
		  return DEST_REGFILE_UNKNOWN;
	        }
	    }
	  else if (cached_type == TYPE_STORE)
	    {
	      if (a_register (operands[1], VOIDmode))
	        {
		  return DEST_REGFILE_A;
	        }
	      else if (b_register (operands[1], VOIDmode))
	        {
		  return DEST_REGFILE_B;
	        }
	      else
	        {
		  return DEST_REGFILE_UNKNOWN;
	        }
	    }
	  else
	    {
	      return DEST_REGFILE_UNKNOWN;
	    }
        }
      else if (which_alternative == 6)
        {
	  return DEST_REGFILE_A;
        }
      else if (which_alternative == 7)
        {
	  return DEST_REGFILE_A;
        }
      else if (which_alternative == 8)
        {
	  return DEST_REGFILE_B;
        }
      else if (which_alternative == 9)
        {
	  return DEST_REGFILE_B;
        }
      else if (which_alternative == 10)
        {
	  return DEST_REGFILE_A;
        }
      else if (which_alternative == 11)
        {
	  return DEST_REGFILE_A;
        }
      else if (which_alternative == 12)
        {
	  return DEST_REGFILE_B;
        }
      else
        {
	  return DEST_REGFILE_B;
        }

    case 12:  /* movsi_insn */
    case 13:  /* movsf_insn */
    case 14:  /* movv2hi_insn */
    case 15:  /* movv4qi_insn */
    case 351:  /* *p movsi_insn */
    case 352:  /* *p movsf_insn */
    case 353:  /* *p movv2hi_insn */
    case 354:  /* *p movv4qi_insn */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  if (((cached_type = get_attr_type (insn)) == TYPE_SINGLE) || (cached_type == TYPE_LOAD) || (cached_type == TYPE_MPY2) || (cached_type == TYPE_MPY4) || (cached_type == TYPE_DP2) || (cached_type == TYPE_FP4) || (cached_type == TYPE_INTDP) || (cached_type == TYPE_CMPDP) || (cached_type == TYPE_ADDDP) || (cached_type == TYPE_MPY) || (cached_type == TYPE_MPYI) || (cached_type == TYPE_MPYID) || (cached_type == TYPE_MPYDP) || (cached_type == TYPE_MPYSPDP) || (cached_type == TYPE_MPYSP2DP))
	    {
	      if (a_register (operands[0], VOIDmode))
	        {
		  return DEST_REGFILE_A;
	        }
	      else if (b_register (operands[0], VOIDmode))
	        {
		  return DEST_REGFILE_B;
	        }
	      else
	        {
		  return DEST_REGFILE_UNKNOWN;
	        }
	    }
	  else if (cached_type == TYPE_STORE)
	    {
	      if (a_register (operands[1], VOIDmode))
	        {
		  return DEST_REGFILE_A;
	        }
	      else if (b_register (operands[1], VOIDmode))
	        {
		  return DEST_REGFILE_B;
	        }
	      else
	        {
		  return DEST_REGFILE_UNKNOWN;
	        }
	    }
	  else
	    {
	      return DEST_REGFILE_UNKNOWN;
	    }
        }
      else if (which_alternative == 1)
        {
	  if (((cached_type = get_attr_type (insn)) == TYPE_SINGLE) || (cached_type == TYPE_LOAD) || (cached_type == TYPE_MPY2) || (cached_type == TYPE_MPY4) || (cached_type == TYPE_DP2) || (cached_type == TYPE_FP4) || (cached_type == TYPE_INTDP) || (cached_type == TYPE_CMPDP) || (cached_type == TYPE_ADDDP) || (cached_type == TYPE_MPY) || (cached_type == TYPE_MPYI) || (cached_type == TYPE_MPYID) || (cached_type == TYPE_MPYDP) || (cached_type == TYPE_MPYSPDP) || (cached_type == TYPE_MPYSP2DP))
	    {
	      if (a_register (operands[0], VOIDmode))
	        {
		  return DEST_REGFILE_A;
	        }
	      else if (b_register (operands[0], VOIDmode))
	        {
		  return DEST_REGFILE_B;
	        }
	      else
	        {
		  return DEST_REGFILE_UNKNOWN;
	        }
	    }
	  else if (cached_type == TYPE_STORE)
	    {
	      if (a_register (operands[1], VOIDmode))
	        {
		  return DEST_REGFILE_A;
	        }
	      else if (b_register (operands[1], VOIDmode))
	        {
		  return DEST_REGFILE_B;
	        }
	      else
	        {
		  return DEST_REGFILE_UNKNOWN;
	        }
	    }
	  else
	    {
	      return DEST_REGFILE_UNKNOWN;
	    }
        }
      else if (which_alternative == 2)
        {
	  if (((cached_type = get_attr_type (insn)) == TYPE_SINGLE) || (cached_type == TYPE_LOAD) || (cached_type == TYPE_MPY2) || (cached_type == TYPE_MPY4) || (cached_type == TYPE_DP2) || (cached_type == TYPE_FP4) || (cached_type == TYPE_INTDP) || (cached_type == TYPE_CMPDP) || (cached_type == TYPE_ADDDP) || (cached_type == TYPE_MPY) || (cached_type == TYPE_MPYI) || (cached_type == TYPE_MPYID) || (cached_type == TYPE_MPYDP) || (cached_type == TYPE_MPYSPDP) || (cached_type == TYPE_MPYSP2DP))
	    {
	      if (a_register (operands[0], VOIDmode))
	        {
		  return DEST_REGFILE_A;
	        }
	      else if (b_register (operands[0], VOIDmode))
	        {
		  return DEST_REGFILE_B;
	        }
	      else
	        {
		  return DEST_REGFILE_UNKNOWN;
	        }
	    }
	  else if (cached_type == TYPE_STORE)
	    {
	      if (a_register (operands[1], VOIDmode))
	        {
		  return DEST_REGFILE_A;
	        }
	      else if (b_register (operands[1], VOIDmode))
	        {
		  return DEST_REGFILE_B;
	        }
	      else
	        {
		  return DEST_REGFILE_UNKNOWN;
	        }
	    }
	  else
	    {
	      return DEST_REGFILE_UNKNOWN;
	    }
        }
      else if (which_alternative == 3)
        {
	  if (((cached_type = get_attr_type (insn)) == TYPE_SINGLE) || (cached_type == TYPE_LOAD) || (cached_type == TYPE_MPY2) || (cached_type == TYPE_MPY4) || (cached_type == TYPE_DP2) || (cached_type == TYPE_FP4) || (cached_type == TYPE_INTDP) || (cached_type == TYPE_CMPDP) || (cached_type == TYPE_ADDDP) || (cached_type == TYPE_MPY) || (cached_type == TYPE_MPYI) || (cached_type == TYPE_MPYID) || (cached_type == TYPE_MPYDP) || (cached_type == TYPE_MPYSPDP) || (cached_type == TYPE_MPYSP2DP))
	    {
	      if (a_register (operands[0], VOIDmode))
	        {
		  return DEST_REGFILE_A;
	        }
	      else if (b_register (operands[0], VOIDmode))
	        {
		  return DEST_REGFILE_B;
	        }
	      else
	        {
		  return DEST_REGFILE_UNKNOWN;
	        }
	    }
	  else if (cached_type == TYPE_STORE)
	    {
	      if (a_register (operands[1], VOIDmode))
	        {
		  return DEST_REGFILE_A;
	        }
	      else if (b_register (operands[1], VOIDmode))
	        {
		  return DEST_REGFILE_B;
	        }
	      else
	        {
		  return DEST_REGFILE_UNKNOWN;
	        }
	    }
	  else
	    {
	      return DEST_REGFILE_UNKNOWN;
	    }
        }
      else if (which_alternative == 4)
        {
	  if (((cached_type = get_attr_type (insn)) == TYPE_SINGLE) || (cached_type == TYPE_LOAD) || (cached_type == TYPE_MPY2) || (cached_type == TYPE_MPY4) || (cached_type == TYPE_DP2) || (cached_type == TYPE_FP4) || (cached_type == TYPE_INTDP) || (cached_type == TYPE_CMPDP) || (cached_type == TYPE_ADDDP) || (cached_type == TYPE_MPY) || (cached_type == TYPE_MPYI) || (cached_type == TYPE_MPYID) || (cached_type == TYPE_MPYDP) || (cached_type == TYPE_MPYSPDP) || (cached_type == TYPE_MPYSP2DP))
	    {
	      if (a_register (operands[0], VOIDmode))
	        {
		  return DEST_REGFILE_A;
	        }
	      else if (b_register (operands[0], VOIDmode))
	        {
		  return DEST_REGFILE_B;
	        }
	      else
	        {
		  return DEST_REGFILE_UNKNOWN;
	        }
	    }
	  else if (cached_type == TYPE_STORE)
	    {
	      if (a_register (operands[1], VOIDmode))
	        {
		  return DEST_REGFILE_A;
	        }
	      else if (b_register (operands[1], VOIDmode))
	        {
		  return DEST_REGFILE_B;
	        }
	      else
	        {
		  return DEST_REGFILE_UNKNOWN;
	        }
	    }
	  else
	    {
	      return DEST_REGFILE_UNKNOWN;
	    }
        }
      else if (which_alternative == 5)
        {
	  if (((cached_type = get_attr_type (insn)) == TYPE_SINGLE) || (cached_type == TYPE_LOAD) || (cached_type == TYPE_MPY2) || (cached_type == TYPE_MPY4) || (cached_type == TYPE_DP2) || (cached_type == TYPE_FP4) || (cached_type == TYPE_INTDP) || (cached_type == TYPE_CMPDP) || (cached_type == TYPE_ADDDP) || (cached_type == TYPE_MPY) || (cached_type == TYPE_MPYI) || (cached_type == TYPE_MPYID) || (cached_type == TYPE_MPYDP) || (cached_type == TYPE_MPYSPDP) || (cached_type == TYPE_MPYSP2DP))
	    {
	      if (a_register (operands[0], VOIDmode))
	        {
		  return DEST_REGFILE_A;
	        }
	      else if (b_register (operands[0], VOIDmode))
	        {
		  return DEST_REGFILE_B;
	        }
	      else
	        {
		  return DEST_REGFILE_UNKNOWN;
	        }
	    }
	  else if (cached_type == TYPE_STORE)
	    {
	      if (a_register (operands[1], VOIDmode))
	        {
		  return DEST_REGFILE_A;
	        }
	      else if (b_register (operands[1], VOIDmode))
	        {
		  return DEST_REGFILE_B;
	        }
	      else
	        {
		  return DEST_REGFILE_UNKNOWN;
	        }
	    }
	  else
	    {
	      return DEST_REGFILE_UNKNOWN;
	    }
        }
      else if (which_alternative == 6)
        {
	  if (((cached_type = get_attr_type (insn)) == TYPE_SINGLE) || (cached_type == TYPE_LOAD) || (cached_type == TYPE_MPY2) || (cached_type == TYPE_MPY4) || (cached_type == TYPE_DP2) || (cached_type == TYPE_FP4) || (cached_type == TYPE_INTDP) || (cached_type == TYPE_CMPDP) || (cached_type == TYPE_ADDDP) || (cached_type == TYPE_MPY) || (cached_type == TYPE_MPYI) || (cached_type == TYPE_MPYID) || (cached_type == TYPE_MPYDP) || (cached_type == TYPE_MPYSPDP) || (cached_type == TYPE_MPYSP2DP))
	    {
	      if (a_register (operands[0], VOIDmode))
	        {
		  return DEST_REGFILE_A;
	        }
	      else if (b_register (operands[0], VOIDmode))
	        {
		  return DEST_REGFILE_B;
	        }
	      else
	        {
		  return DEST_REGFILE_UNKNOWN;
	        }
	    }
	  else if (cached_type == TYPE_STORE)
	    {
	      if (a_register (operands[1], VOIDmode))
	        {
		  return DEST_REGFILE_A;
	        }
	      else if (b_register (operands[1], VOIDmode))
	        {
		  return DEST_REGFILE_B;
	        }
	      else
	        {
		  return DEST_REGFILE_UNKNOWN;
	        }
	    }
	  else
	    {
	      return DEST_REGFILE_UNKNOWN;
	    }
        }
      else if (which_alternative == 7)
        {
	  if (((cached_type = get_attr_type (insn)) == TYPE_SINGLE) || (cached_type == TYPE_LOAD) || (cached_type == TYPE_MPY2) || (cached_type == TYPE_MPY4) || (cached_type == TYPE_DP2) || (cached_type == TYPE_FP4) || (cached_type == TYPE_INTDP) || (cached_type == TYPE_CMPDP) || (cached_type == TYPE_ADDDP) || (cached_type == TYPE_MPY) || (cached_type == TYPE_MPYI) || (cached_type == TYPE_MPYID) || (cached_type == TYPE_MPYDP) || (cached_type == TYPE_MPYSPDP) || (cached_type == TYPE_MPYSP2DP))
	    {
	      if (a_register (operands[0], VOIDmode))
	        {
		  return DEST_REGFILE_A;
	        }
	      else if (b_register (operands[0], VOIDmode))
	        {
		  return DEST_REGFILE_B;
	        }
	      else
	        {
		  return DEST_REGFILE_UNKNOWN;
	        }
	    }
	  else if (cached_type == TYPE_STORE)
	    {
	      if (a_register (operands[1], VOIDmode))
	        {
		  return DEST_REGFILE_A;
	        }
	      else if (b_register (operands[1], VOIDmode))
	        {
		  return DEST_REGFILE_B;
	        }
	      else
	        {
		  return DEST_REGFILE_UNKNOWN;
	        }
	    }
	  else
	    {
	      return DEST_REGFILE_UNKNOWN;
	    }
        }
      else if (which_alternative == 8)
        {
	  if (((cached_type = get_attr_type (insn)) == TYPE_SINGLE) || (cached_type == TYPE_LOAD) || (cached_type == TYPE_MPY2) || (cached_type == TYPE_MPY4) || (cached_type == TYPE_DP2) || (cached_type == TYPE_FP4) || (cached_type == TYPE_INTDP) || (cached_type == TYPE_CMPDP) || (cached_type == TYPE_ADDDP) || (cached_type == TYPE_MPY) || (cached_type == TYPE_MPYI) || (cached_type == TYPE_MPYID) || (cached_type == TYPE_MPYDP) || (cached_type == TYPE_MPYSPDP) || (cached_type == TYPE_MPYSP2DP))
	    {
	      if (a_register (operands[0], VOIDmode))
	        {
		  return DEST_REGFILE_A;
	        }
	      else if (b_register (operands[0], VOIDmode))
	        {
		  return DEST_REGFILE_B;
	        }
	      else
	        {
		  return DEST_REGFILE_UNKNOWN;
	        }
	    }
	  else if (cached_type == TYPE_STORE)
	    {
	      if (a_register (operands[1], VOIDmode))
	        {
		  return DEST_REGFILE_A;
	        }
	      else if (b_register (operands[1], VOIDmode))
	        {
		  return DEST_REGFILE_B;
	        }
	      else
	        {
		  return DEST_REGFILE_UNKNOWN;
	        }
	    }
	  else
	    {
	      return DEST_REGFILE_UNKNOWN;
	    }
        }
      else if (which_alternative == 9)
        {
	  return DEST_REGFILE_A;
        }
      else if (which_alternative == 10)
        {
	  return DEST_REGFILE_A;
        }
      else if (which_alternative == 11)
        {
	  return DEST_REGFILE_B;
        }
      else if (which_alternative == 12)
        {
	  return DEST_REGFILE_B;
        }
      else if (which_alternative == 13)
        {
	  return DEST_REGFILE_A;
        }
      else if (which_alternative == 14)
        {
	  return DEST_REGFILE_A;
        }
      else if (which_alternative == 15)
        {
	  return DEST_REGFILE_B;
        }
      else
        {
	  return DEST_REGFILE_B;
        }

    case 16:  /* *movdi_insn */
    case 17:  /* *movdf_insn */
    case 18:  /* *movv2si_insn */
    case 19:  /* *movv4hi_insn */
    case 20:  /* *movv8qi_insn */
    case 355:  /* *p *movdi_insn */
    case 356:  /* *p *movdf_insn */
    case 357:  /* *p *movv2si_insn */
    case 358:  /* *p *movv4hi_insn */
    case 359:  /* *p *movv8qi_insn */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  if (((cached_type = get_attr_type (insn)) == TYPE_SINGLE) || (cached_type == TYPE_LOAD) || (cached_type == TYPE_MPY2) || (cached_type == TYPE_MPY4) || (cached_type == TYPE_DP2) || (cached_type == TYPE_FP4) || (cached_type == TYPE_INTDP) || (cached_type == TYPE_CMPDP) || (cached_type == TYPE_ADDDP) || (cached_type == TYPE_MPY) || (cached_type == TYPE_MPYI) || (cached_type == TYPE_MPYID) || (cached_type == TYPE_MPYDP) || (cached_type == TYPE_MPYSPDP) || (cached_type == TYPE_MPYSP2DP))
	    {
	      if (a_register (operands[0], VOIDmode))
	        {
		  return DEST_REGFILE_A;
	        }
	      else if (b_register (operands[0], VOIDmode))
	        {
		  return DEST_REGFILE_B;
	        }
	      else
	        {
		  return DEST_REGFILE_UNKNOWN;
	        }
	    }
	  else if (cached_type == TYPE_STORE)
	    {
	      if (a_register (operands[1], VOIDmode))
	        {
		  return DEST_REGFILE_A;
	        }
	      else if (b_register (operands[1], VOIDmode))
	        {
		  return DEST_REGFILE_B;
	        }
	      else
	        {
		  return DEST_REGFILE_UNKNOWN;
	        }
	    }
	  else
	    {
	      return DEST_REGFILE_UNKNOWN;
	    }
        }
      else if (which_alternative == 1)
        {
	  if (((cached_type = get_attr_type (insn)) == TYPE_SINGLE) || (cached_type == TYPE_LOAD) || (cached_type == TYPE_MPY2) || (cached_type == TYPE_MPY4) || (cached_type == TYPE_DP2) || (cached_type == TYPE_FP4) || (cached_type == TYPE_INTDP) || (cached_type == TYPE_CMPDP) || (cached_type == TYPE_ADDDP) || (cached_type == TYPE_MPY) || (cached_type == TYPE_MPYI) || (cached_type == TYPE_MPYID) || (cached_type == TYPE_MPYDP) || (cached_type == TYPE_MPYSPDP) || (cached_type == TYPE_MPYSP2DP))
	    {
	      if (a_register (operands[0], VOIDmode))
	        {
		  return DEST_REGFILE_A;
	        }
	      else if (b_register (operands[0], VOIDmode))
	        {
		  return DEST_REGFILE_B;
	        }
	      else
	        {
		  return DEST_REGFILE_UNKNOWN;
	        }
	    }
	  else if (cached_type == TYPE_STORE)
	    {
	      if (a_register (operands[1], VOIDmode))
	        {
		  return DEST_REGFILE_A;
	        }
	      else if (b_register (operands[1], VOIDmode))
	        {
		  return DEST_REGFILE_B;
	        }
	      else
	        {
		  return DEST_REGFILE_UNKNOWN;
	        }
	    }
	  else
	    {
	      return DEST_REGFILE_UNKNOWN;
	    }
        }
      else if (which_alternative == 2)
        {
	  if (((cached_type = get_attr_type (insn)) == TYPE_SINGLE) || (cached_type == TYPE_LOAD) || (cached_type == TYPE_MPY2) || (cached_type == TYPE_MPY4) || (cached_type == TYPE_DP2) || (cached_type == TYPE_FP4) || (cached_type == TYPE_INTDP) || (cached_type == TYPE_CMPDP) || (cached_type == TYPE_ADDDP) || (cached_type == TYPE_MPY) || (cached_type == TYPE_MPYI) || (cached_type == TYPE_MPYID) || (cached_type == TYPE_MPYDP) || (cached_type == TYPE_MPYSPDP) || (cached_type == TYPE_MPYSP2DP))
	    {
	      if (a_register (operands[0], VOIDmode))
	        {
		  return DEST_REGFILE_A;
	        }
	      else if (b_register (operands[0], VOIDmode))
	        {
		  return DEST_REGFILE_B;
	        }
	      else
	        {
		  return DEST_REGFILE_UNKNOWN;
	        }
	    }
	  else if (cached_type == TYPE_STORE)
	    {
	      if (a_register (operands[1], VOIDmode))
	        {
		  return DEST_REGFILE_A;
	        }
	      else if (b_register (operands[1], VOIDmode))
	        {
		  return DEST_REGFILE_B;
	        }
	      else
	        {
		  return DEST_REGFILE_UNKNOWN;
	        }
	    }
	  else
	    {
	      return DEST_REGFILE_UNKNOWN;
	    }
        }
      else if (which_alternative == 3)
        {
	  if (((cached_type = get_attr_type (insn)) == TYPE_SINGLE) || (cached_type == TYPE_LOAD) || (cached_type == TYPE_MPY2) || (cached_type == TYPE_MPY4) || (cached_type == TYPE_DP2) || (cached_type == TYPE_FP4) || (cached_type == TYPE_INTDP) || (cached_type == TYPE_CMPDP) || (cached_type == TYPE_ADDDP) || (cached_type == TYPE_MPY) || (cached_type == TYPE_MPYI) || (cached_type == TYPE_MPYID) || (cached_type == TYPE_MPYDP) || (cached_type == TYPE_MPYSPDP) || (cached_type == TYPE_MPYSP2DP))
	    {
	      if (a_register (operands[0], VOIDmode))
	        {
		  return DEST_REGFILE_A;
	        }
	      else if (b_register (operands[0], VOIDmode))
	        {
		  return DEST_REGFILE_B;
	        }
	      else
	        {
		  return DEST_REGFILE_UNKNOWN;
	        }
	    }
	  else if (cached_type == TYPE_STORE)
	    {
	      if (a_register (operands[1], VOIDmode))
	        {
		  return DEST_REGFILE_A;
	        }
	      else if (b_register (operands[1], VOIDmode))
	        {
		  return DEST_REGFILE_B;
	        }
	      else
	        {
		  return DEST_REGFILE_UNKNOWN;
	        }
	    }
	  else
	    {
	      return DEST_REGFILE_UNKNOWN;
	    }
        }
      else if (which_alternative == 4)
        {
	  if (((cached_type = get_attr_type (insn)) == TYPE_SINGLE) || (cached_type == TYPE_LOAD) || (cached_type == TYPE_MPY2) || (cached_type == TYPE_MPY4) || (cached_type == TYPE_DP2) || (cached_type == TYPE_FP4) || (cached_type == TYPE_INTDP) || (cached_type == TYPE_CMPDP) || (cached_type == TYPE_ADDDP) || (cached_type == TYPE_MPY) || (cached_type == TYPE_MPYI) || (cached_type == TYPE_MPYID) || (cached_type == TYPE_MPYDP) || (cached_type == TYPE_MPYSPDP) || (cached_type == TYPE_MPYSP2DP))
	    {
	      if (a_register (operands[0], VOIDmode))
	        {
		  return DEST_REGFILE_A;
	        }
	      else if (b_register (operands[0], VOIDmode))
	        {
		  return DEST_REGFILE_B;
	        }
	      else
	        {
		  return DEST_REGFILE_UNKNOWN;
	        }
	    }
	  else if (cached_type == TYPE_STORE)
	    {
	      if (a_register (operands[1], VOIDmode))
	        {
		  return DEST_REGFILE_A;
	        }
	      else if (b_register (operands[1], VOIDmode))
	        {
		  return DEST_REGFILE_B;
	        }
	      else
	        {
		  return DEST_REGFILE_UNKNOWN;
	        }
	    }
	  else
	    {
	      return DEST_REGFILE_UNKNOWN;
	    }
        }
      else if (which_alternative == 5)
        {
	  return DEST_REGFILE_A;
        }
      else if (which_alternative == 6)
        {
	  return DEST_REGFILE_A;
        }
      else if (which_alternative == 7)
        {
	  return DEST_REGFILE_B;
        }
      else if (which_alternative == 8)
        {
	  return DEST_REGFILE_B;
        }
      else if (which_alternative == 9)
        {
	  return DEST_REGFILE_A;
        }
      else if (which_alternative == 10)
        {
	  return DEST_REGFILE_A;
        }
      else if (which_alternative == 11)
        {
	  return DEST_REGFILE_B;
        }
      else
        {
	  return DEST_REGFILE_B;
        }

    case 42:  /* zero_extendqisi2 */
    case 43:  /* sign_extendqisi2 */
    case 44:  /* zero_extendhisi2 */
    case 45:  /* sign_extendhisi2 */
    case 381:  /* *p zero_extendqisi2 */
    case 382:  /* *p sign_extendqisi2 */
    case 383:  /* *p zero_extendhisi2 */
    case 384:  /* *p sign_extendhisi2 */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  if (((cached_type = get_attr_type (insn)) == TYPE_SINGLE) || (cached_type == TYPE_LOAD) || (cached_type == TYPE_MPY2) || (cached_type == TYPE_MPY4) || (cached_type == TYPE_DP2) || (cached_type == TYPE_FP4) || (cached_type == TYPE_INTDP) || (cached_type == TYPE_CMPDP) || (cached_type == TYPE_ADDDP) || (cached_type == TYPE_MPY) || (cached_type == TYPE_MPYI) || (cached_type == TYPE_MPYID) || (cached_type == TYPE_MPYDP) || (cached_type == TYPE_MPYSPDP) || (cached_type == TYPE_MPYSP2DP))
	    {
	      if (a_register (operands[0], VOIDmode))
	        {
		  return DEST_REGFILE_A;
	        }
	      else if (b_register (operands[0], VOIDmode))
	        {
		  return DEST_REGFILE_B;
	        }
	      else
	        {
		  return DEST_REGFILE_UNKNOWN;
	        }
	    }
	  else if (cached_type == TYPE_STORE)
	    {
	      if (a_register (operands[1], VOIDmode))
	        {
		  return DEST_REGFILE_A;
	        }
	      else if (b_register (operands[1], VOIDmode))
	        {
		  return DEST_REGFILE_B;
	        }
	      else
	        {
		  return DEST_REGFILE_UNKNOWN;
	        }
	    }
	  else
	    {
	      return DEST_REGFILE_UNKNOWN;
	    }
        }
      else if (which_alternative == 1)
        {
	  if (((cached_type = get_attr_type (insn)) == TYPE_SINGLE) || (cached_type == TYPE_LOAD) || (cached_type == TYPE_MPY2) || (cached_type == TYPE_MPY4) || (cached_type == TYPE_DP2) || (cached_type == TYPE_FP4) || (cached_type == TYPE_INTDP) || (cached_type == TYPE_CMPDP) || (cached_type == TYPE_ADDDP) || (cached_type == TYPE_MPY) || (cached_type == TYPE_MPYI) || (cached_type == TYPE_MPYID) || (cached_type == TYPE_MPYDP) || (cached_type == TYPE_MPYSPDP) || (cached_type == TYPE_MPYSP2DP))
	    {
	      if (a_register (operands[0], VOIDmode))
	        {
		  return DEST_REGFILE_A;
	        }
	      else if (b_register (operands[0], VOIDmode))
	        {
		  return DEST_REGFILE_B;
	        }
	      else
	        {
		  return DEST_REGFILE_UNKNOWN;
	        }
	    }
	  else if (cached_type == TYPE_STORE)
	    {
	      if (a_register (operands[1], VOIDmode))
	        {
		  return DEST_REGFILE_A;
	        }
	      else if (b_register (operands[1], VOIDmode))
	        {
		  return DEST_REGFILE_B;
	        }
	      else
	        {
		  return DEST_REGFILE_UNKNOWN;
	        }
	    }
	  else
	    {
	      return DEST_REGFILE_UNKNOWN;
	    }
        }
      else if (which_alternative == 2)
        {
	  return DEST_REGFILE_A;
        }
      else if (which_alternative == 3)
        {
	  return DEST_REGFILE_A;
        }
      else if (which_alternative == 4)
        {
	  return DEST_REGFILE_B;
        }
      else
        {
	  return DEST_REGFILE_B;
        }

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
      extract_insn_cached (insn);
      if (((cached_type = get_attr_type (insn)) == TYPE_SINGLE) || (cached_type == TYPE_LOAD) || (cached_type == TYPE_MPY2) || (cached_type == TYPE_MPY4) || (cached_type == TYPE_DP2) || (cached_type == TYPE_FP4) || (cached_type == TYPE_INTDP) || (cached_type == TYPE_CMPDP) || (cached_type == TYPE_ADDDP) || (cached_type == TYPE_MPY) || (cached_type == TYPE_MPYI) || (cached_type == TYPE_MPYID) || (cached_type == TYPE_MPYDP) || (cached_type == TYPE_MPYSPDP) || (cached_type == TYPE_MPYSP2DP))
        {
	  if (a_register (operands[0], VOIDmode))
	    {
	      return DEST_REGFILE_A;
	    }
	  else if (b_register (operands[0], VOIDmode))
	    {
	      return DEST_REGFILE_B;
	    }
	  else
	    {
	      return DEST_REGFILE_UNKNOWN;
	    }
        }
      else if (cached_type == TYPE_STORE)
        {
	  if (a_register (operands[1], VOIDmode))
	    {
	      return DEST_REGFILE_A;
	    }
	  else if (b_register (operands[1], VOIDmode))
	    {
	      return DEST_REGFILE_B;
	    }
	  else
	    {
	      return DEST_REGFILE_UNKNOWN;
	    }
        }
      else
        {
	  return DEST_REGFILE_UNKNOWN;
        }

    case 70:  /* indirect_jump */
    case 72:  /* *tablejump_internal */
    case 73:  /* casesi_internal */
    case 77:  /* mvilc */
    case 83:  /* real_ret */
    case 120:  /* callp */
    case 121:  /* callp_value */
    case 122:  /* return_internal */
    case 123:  /* addkpc */
    case 159:  /* setup_dsbt */
    case 399:  /* *p indirect_jump */
    case 404:  /* *p real_ret */
    case 438:  /* *p return_internal */
    case 439:  /* *p addkpc */
    case 475:  /* *p setup_dsbt */
      return DEST_REGFILE_B;

    case 157:  /* push_rts */
    case 158:  /* pop_rts */
    case 473:  /* *p push_rts */
    case 474:  /* *p pop_rts */
      return DEST_REGFILE_A;

    case 71:  /* jump */
    case 74:  /* br_true */
    case 75:  /* br_false */
    case 136:  /* divsi3_insn */
    case 137:  /* divsi3_insn_indcall */
    case 138:  /* udivsi3_insn */
    case 139:  /* udivsi3_insn_indcall */
    case 140:  /* modsi3_insn */
    case 141:  /* modsi3_insn_indcall */
    case 142:  /* divmodsi4_insn */
    case 143:  /* divmodsi4_insn_indcall */
    case 144:  /* umodsi3_insn */
    case 145:  /* umodsi3_insn_indcall */
    case 146:  /* udivmodsi4_insn */
    case 147:  /* udivmodsi4_insn_indcall */
    case 400:  /* *p jump */
    case 452:  /* *p divsi3_insn */
    case 453:  /* *p divsi3_insn_indcall */
    case 454:  /* *p udivsi3_insn */
    case 455:  /* *p udivsi3_insn_indcall */
    case 456:  /* *p modsi3_insn */
    case 457:  /* *p modsi3_insn_indcall */
    case 458:  /* *p divmodsi4_insn */
    case 459:  /* *p divmodsi4_insn_indcall */
    case 460:  /* *p umodsi3_insn */
    case 461:  /* *p umodsi3_insn_indcall */
    case 462:  /* *p udivmodsi4_insn */
    case 463:  /* *p udivmodsi4_insn_indcall */
      return DEST_REGFILE_ANY;

    case 585:  /* *p sync_new_nandsi_insn */
    case 584:  /* *p sync_old_nandsi_insn */
    case 583:  /* *p sync_nandsi_insn */
    case 582:  /* *p sync_new_andsi_insn */
    case 581:  /* *p sync_new_xorsi_insn */
    case 580:  /* *p sync_new_iorsi_insn */
    case 579:  /* *p sync_new_subsi_insn */
    case 578:  /* *p sync_new_addsi_insn */
    case 577:  /* *p sync_old_andsi_insn */
    case 576:  /* *p sync_old_xorsi_insn */
    case 575:  /* *p sync_old_iorsi_insn */
    case 574:  /* *p sync_old_subsi_insn */
    case 573:  /* *p sync_old_addsi_insn */
    case 572:  /* *p sync_andsi_insn */
    case 571:  /* *p sync_xorsi_insn */
    case 570:  /* *p sync_iorsi_insn */
    case 569:  /* *p sync_subsi_insn */
    case 568:  /* *p sync_addsi_insn */
    case 567:  /* *p *sync_compare_and_swapsi */
    case 476:  /* *p epilogue_barrier */
    case 472:  /* *p blockage */
    case 414:  /* *p return_shadow */
    case 413:  /* *p condjump_shadow */
    case 412:  /* *p jump_shadow */
    case 411:  /* *p sibcall_shadow */
    case 410:  /* *p call_shadow */
    case 409:  /* *p call_value_shadow */
    case 408:  /* *p indirect_call_shadow */
    case 407:  /* *p indirect_sibcall_shadow */
    case 406:  /* *p indirect_call_value_shadow */
    case 405:  /* *p indirect_jump_shadow */
    case 402:  /* *p loop_end */
    case 372:  /* *p mult_shadow */
    case 371:  /* *p load_shadow */
    case 269:  /* sync_new_nandsi_insn */
    case 268:  /* sync_old_nandsi_insn */
    case 267:  /* sync_nandsi_insn */
    case 266:  /* sync_new_andsi_insn */
    case 265:  /* sync_new_xorsi_insn */
    case 264:  /* sync_new_iorsi_insn */
    case 263:  /* sync_new_subsi_insn */
    case 262:  /* sync_new_addsi_insn */
    case 261:  /* sync_old_andsi_insn */
    case 260:  /* sync_old_xorsi_insn */
    case 259:  /* sync_old_iorsi_insn */
    case 258:  /* sync_old_subsi_insn */
    case 257:  /* sync_old_addsi_insn */
    case 256:  /* sync_andsi_insn */
    case 255:  /* sync_xorsi_insn */
    case 254:  /* sync_iorsi_insn */
    case 253:  /* sync_subsi_insn */
    case 252:  /* sync_addsi_insn */
    case 251:  /* *sync_compare_and_swapsi */
    case 160:  /* epilogue_barrier */
    case 156:  /* blockage */
    case 93:  /* return_shadow */
    case 92:  /* condjump_shadow */
    case 91:  /* jump_shadow */
    case 90:  /* sibcall_shadow */
    case 89:  /* call_shadow */
    case 88:  /* call_value_shadow */
    case 87:  /* indirect_call_shadow */
    case 86:  /* indirect_sibcall_shadow */
    case 85:  /* indirect_call_value_shadow */
    case 84:  /* indirect_jump_shadow */
    case 80:  /* loop_end */
    case 79:  /* spkernel */
    case 78:  /* sploop */
    case 33:  /* mult_shadow */
    case 32:  /* load_shadow */
      return DEST_REGFILE_UNKNOWN;

    default:
      extract_insn_cached (insn);
      if (a_register (operands[0], VOIDmode))
        {
	  return DEST_REGFILE_A;
        }
      else if (b_register (operands[0], VOIDmode))
        {
	  return DEST_REGFILE_B;
        }
      else
        {
	  return DEST_REGFILE_UNKNOWN;
        }

    }
}

enum attr_enabled
get_attr_enabled (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case 415:  /* *p addsi3 */
      extract_constrain_insn_cached (insn);
      if (!((1 << which_alternative) & 0x1800))
        {
	  return ENABLED_YES;
        }
      else
        {
	  return ENABLED_NO;
        }

    case 354:  /* *p movv4qi_insn */
    case 353:  /* *p movv2hi_insn */
    case 352:  /* *p movsf_insn */
    case 351:  /* *p movsi_insn */
      extract_constrain_insn_cached (insn);
      if (!((1 << which_alternative) & 0xc0))
        {
	  return ENABLED_YES;
        }
      else
        {
	  return ENABLED_NO;
        }

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
      if (get_attr_ce_enabled (insn) == CE_ENABLED_YES)
        {
	  return ENABLED_YES;
        }
      else
        {
	  return ENABLED_NO;
        }

    default:
      return ENABLED_YES;

    }
}

enum attr_has_shadow
get_attr_has_shadow (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case 81:  /* real_jump */
    case 82:  /* real_call */
    case 83:  /* real_ret */
    case 403:  /* *p real_jump */
    case 404:  /* *p real_ret */
      return HAS_SHADOW_Y;

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return HAS_SHADOW_N;

    }
}

enum attr_nonce_enabled
get_attr_nonce_enabled (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return NONCE_ENABLED_YES;

    }
}

enum attr_op_pattern
get_attr_op_pattern (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  enum attr_type cached_type ATTRIBUTE_UNUSED;

  switch (recog_memoized (insn))
    {
    case 384:  /* *p sign_extendhisi2 */
    case 383:  /* *p zero_extendhisi2 */
    case 382:  /* *p sign_extendqisi2 */
    case 381:  /* *p zero_extendqisi2 */
    case 45:  /* sign_extendhisi2 */
    case 44:  /* zero_extendhisi2 */
    case 43:  /* sign_extendqisi2 */
    case 42:  /* zero_extendqisi2 */
      extract_constrain_insn_cached (insn);
      if (!((1 << which_alternative) & 0x3))
        {
	  return OP_PATTERN_TD;
        }
      else
        {
	  return OP_PATTERN_UNKNOWN;
        }

    case 359:  /* *p *movv8qi_insn */
    case 358:  /* *p *movv4hi_insn */
    case 357:  /* *p *movv2si_insn */
    case 356:  /* *p *movdf_insn */
    case 355:  /* *p *movdi_insn */
    case 20:  /* *movv8qi_insn */
    case 19:  /* *movv4hi_insn */
    case 18:  /* *movv2si_insn */
    case 17:  /* *movdf_insn */
    case 16:  /* *movdi_insn */
      extract_constrain_insn_cached (insn);
      if (((1 << which_alternative) & 0x1e0))
        {
	  return OP_PATTERN_TD;
        }
      else if (!((1 << which_alternative) & 0x1ff))
        {
	  return OP_PATTERN_DT;
        }
      else
        {
	  return OP_PATTERN_UNKNOWN;
        }

    case 354:  /* *p movv4qi_insn */
    case 353:  /* *p movv2hi_insn */
    case 352:  /* *p movsf_insn */
    case 351:  /* *p movsi_insn */
    case 15:  /* movv4qi_insn */
    case 14:  /* movv2hi_insn */
    case 13:  /* movsf_insn */
    case 12:  /* movsi_insn */
      extract_constrain_insn_cached (insn);
      if (((1 << which_alternative) & 0xf))
        {
	  return OP_PATTERN_SX;
        }
      else
        {
	  if (((1 << which_alternative) & 0x1e00))
	    {
	      return OP_PATTERN_TD;
	    }
	  else if (!((1 << which_alternative) & 0x1fff))
	    {
	      return OP_PATTERN_DT;
	    }
	  else
	    {
	      return OP_PATTERN_UNKNOWN;
	    }
        }

    case 350:  /* *p movhi_insn */
    case 349:  /* *p movqi_insn */
    case 11:  /* movhi_insn */
    case 10:  /* movqi_insn */
      extract_constrain_insn_cached (insn);
      if (((1 << which_alternative) & 0xf))
        {
	  return OP_PATTERN_SX;
        }
      else
        {
	  if (((1 << which_alternative) & 0x3c0))
	    {
	      return OP_PATTERN_TD;
	    }
	  else if (!((1 << which_alternative) & 0x3ff))
	    {
	      return OP_PATTERN_DT;
	    }
	  else
	    {
	      return OP_PATTERN_UNKNOWN;
	    }
        }

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
      if ((cached_type = get_attr_type (insn)) == TYPE_LOAD)
        {
	  return OP_PATTERN_TD;
        }
      else if (cached_type == TYPE_STORE)
        {
	  return OP_PATTERN_DT;
        }
      else
        {
	  return OP_PATTERN_UNKNOWN;
        }

    case 193:  /* *mulhisi3_insn */
    case 225:  /* *mulhisi3_insn_real */
    case 509:  /* *p *mulhisi3_insn */
    case 541:  /* *p *mulhisi3_insn_real */
      return OP_PATTERN_SSX;

    case 191:  /* mulhi3 */
    case 223:  /* mulhi3_real */
    case 507:  /* *p mulhi3 */
    case 539:  /* *p mulhi3_real */
      return OP_PATTERN_SXS;

    case 475:  /* *p setup_dsbt */
    case 390:  /* *p real_sign_extendhi */
    case 389:  /* *p real_zero_extendhi */
    case 388:  /* *p real_sign_extendqi */
    case 387:  /* *p real_zero_extendqi */
    case 370:  /* *p real_loadv8qi */
    case 369:  /* *p real_loadv4hi */
    case 368:  /* *p real_loadv2si */
    case 367:  /* *p real_loaddf */
    case 366:  /* *p real_loaddi */
    case 365:  /* *p real_loadv4qi */
    case 364:  /* *p real_loadv2hi */
    case 363:  /* *p real_loadsf */
    case 362:  /* *p real_loadsi */
    case 361:  /* *p real_loadhi */
    case 360:  /* *p real_loadqi */
    case 159:  /* setup_dsbt */
    case 51:  /* real_sign_extendhi */
    case 50:  /* real_zero_extendhi */
    case 49:  /* real_sign_extendqi */
    case 48:  /* real_zero_extendqi */
    case 31:  /* real_loadv8qi */
    case 30:  /* real_loadv4hi */
    case 29:  /* real_loadv2si */
    case 28:  /* real_loaddf */
    case 27:  /* real_loaddi */
    case 26:  /* real_loadv4qi */
    case 25:  /* real_loadv2hi */
    case 24:  /* real_loadsf */
    case 23:  /* real_loadsi */
    case 22:  /* real_loadhi */
    case 21:  /* real_loadqi */
      return OP_PATTERN_TD;

    default:
      return OP_PATTERN_UNKNOWN;

    }
}

enum attr_predicable
get_attr_predicable (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case 94:  /* addsi3 */
      extract_constrain_insn_cached (insn);
      if (((1 << which_alternative) & 0x7ff))
        {
	  return PREDICABLE_YES;
        }
      else if (((1 << which_alternative) & 0x1800))
        {
	  return PREDICABLE_NO;
        }
      else
        {
	  return PREDICABLE_YES;
        }

    case 15:  /* movv4qi_insn */
    case 14:  /* movv2hi_insn */
    case 13:  /* movsf_insn */
    case 12:  /* movsi_insn */
      extract_constrain_insn_cached (insn);
      if (((1 << which_alternative) & 0x3f))
        {
	  return PREDICABLE_YES;
        }
      else if (((1 << which_alternative) & 0xc0))
        {
	  return PREDICABLE_NO;
        }
      else
        {
	  return PREDICABLE_YES;
        }

    case 9:  /* load_sdata_pic */
    case 58:  /* *scmpsi_and_insn */
    case 59:  /* *scmpsi_ior_insn */
    case 60:  /* *ucmpsi_and_insn_64 */
    case 61:  /* *ucmpsi_ior_insn_64 */
    case 62:  /* *ucmpsi_and_insn */
    case 63:  /* *ucmpsi_ior_insn */
    case 66:  /* *cmpsf_and_insn */
    case 67:  /* *cmpsf_ior_insn */
    case 68:  /* *cmpdf_and_insn */
    case 69:  /* *cmpdf_ior_insn */
    case 72:  /* *tablejump_internal */
    case 73:  /* casesi_internal */
    case 74:  /* br_true */
    case 75:  /* br_false */
    case 77:  /* mvilc */
    case 78:  /* sploop */
    case 79:  /* spkernel */
    case 82:  /* real_call */
    case 117:  /* call_internal */
    case 118:  /* call_value_internal */
    case 119:  /* sibcall_internal */
    case 120:  /* callp */
    case 121:  /* callp_value */
      return PREDICABLE_NO;

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return PREDICABLE_YES;

    }
}

int
get_attr_reserve_cycles (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  enum attr_type cached_type ATTRIBUTE_UNUSED;

  switch (recog_memoized (insn))
    {
    case 467:  /* *p muldf3 */
    case 151:  /* muldf3 */
      return 4;

    case 468:  /* *p *muldf_ext1 */
    case 423:  /* *p subdf3 */
    case 421:  /* *p adddf3 */
    case 398:  /* *p *cmpdf_insn */
    case 152:  /* *muldf_ext1 */
    case 102:  /* subdf3 */
    case 100:  /* adddf3 */
    case 69:  /* *cmpdf_ior_insn */
    case 68:  /* *cmpdf_and_insn */
    case 65:  /* *cmpdf_insn */
      return 2;

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
      if ((cached_type = get_attr_type (insn)) == TYPE_CMPDP)
        {
	  return 2;
        }
      else if (cached_type == TYPE_ADDDP)
        {
	  return 2;
        }
      else if (cached_type == TYPE_MPYDP)
        {
	  return 4;
        }
      else if (cached_type == TYPE_MPYI)
        {
	  return 4;
        }
      else if (cached_type == TYPE_MPYID)
        {
	  return 4;
        }
      else if (cached_type == TYPE_MPYSPDP)
        {
	  return 2;
        }
      else
        {
	  return 1;
        }

    default:
      return 1;

    }
}

enum attr_type
get_attr_type (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case 384:  /* *p sign_extendhisi2 */
    case 383:  /* *p zero_extendhisi2 */
    case 382:  /* *p sign_extendqisi2 */
    case 381:  /* *p zero_extendqisi2 */
    case 45:  /* sign_extendhisi2 */
    case 44:  /* zero_extendhisi2 */
    case 43:  /* sign_extendqisi2 */
    case 42:  /* zero_extendqisi2 */
      extract_constrain_insn_cached (insn);
      if (((1 << which_alternative) & 0x3))
        {
	  return TYPE_SINGLE;
        }
      else
        {
	  return TYPE_LOAD;
        }

    case 359:  /* *p *movv8qi_insn */
    case 358:  /* *p *movv4hi_insn */
    case 357:  /* *p *movv2si_insn */
    case 356:  /* *p *movdf_insn */
    case 355:  /* *p *movdi_insn */
    case 20:  /* *movv8qi_insn */
    case 19:  /* *movv4hi_insn */
    case 18:  /* *movv2si_insn */
    case 17:  /* *movdf_insn */
    case 16:  /* *movdi_insn */
      extract_constrain_insn_cached (insn);
      if (((1 << which_alternative) & 0x1f))
        {
	  return TYPE_SINGLE;
        }
      else if (((1 << which_alternative) & 0x1e0))
        {
	  return TYPE_LOAD;
        }
      else
        {
	  return TYPE_STORE;
        }

    case 354:  /* *p movv4qi_insn */
    case 353:  /* *p movv2hi_insn */
    case 352:  /* *p movsf_insn */
    case 351:  /* *p movsi_insn */
    case 15:  /* movv4qi_insn */
    case 14:  /* movv2hi_insn */
    case 13:  /* movsf_insn */
    case 12:  /* movsi_insn */
      extract_constrain_insn_cached (insn);
      if (((1 << which_alternative) & 0x1ff))
        {
	  return TYPE_SINGLE;
        }
      else if (((1 << which_alternative) & 0x1e00))
        {
	  return TYPE_LOAD;
        }
      else
        {
	  return TYPE_STORE;
        }

    case 350:  /* *p movhi_insn */
    case 349:  /* *p movqi_insn */
    case 11:  /* movhi_insn */
    case 10:  /* movqi_insn */
      extract_constrain_insn_cached (insn);
      if (((1 << which_alternative) & 0x3f))
        {
	  return TYPE_SINGLE;
        }
      else if (((1 << which_alternative) & 0x3c0))
        {
	  return TYPE_LOAD;
        }
      else
        {
	  return TYPE_STORE;
        }

    case 251:  /* *sync_compare_and_swapsi */
    case 252:  /* sync_addsi_insn */
    case 253:  /* sync_subsi_insn */
    case 254:  /* sync_iorsi_insn */
    case 255:  /* sync_xorsi_insn */
    case 256:  /* sync_andsi_insn */
    case 257:  /* sync_old_addsi_insn */
    case 258:  /* sync_old_subsi_insn */
    case 259:  /* sync_old_iorsi_insn */
    case 260:  /* sync_old_xorsi_insn */
    case 261:  /* sync_old_andsi_insn */
    case 262:  /* sync_new_addsi_insn */
    case 263:  /* sync_new_subsi_insn */
    case 264:  /* sync_new_iorsi_insn */
    case 265:  /* sync_new_xorsi_insn */
    case 266:  /* sync_new_andsi_insn */
    case 267:  /* sync_nandsi_insn */
    case 268:  /* sync_old_nandsi_insn */
    case 269:  /* sync_new_nandsi_insn */
    case 567:  /* *p *sync_compare_and_swapsi */
    case 568:  /* *p sync_addsi_insn */
    case 569:  /* *p sync_subsi_insn */
    case 570:  /* *p sync_iorsi_insn */
    case 571:  /* *p sync_xorsi_insn */
    case 572:  /* *p sync_andsi_insn */
    case 573:  /* *p sync_old_addsi_insn */
    case 574:  /* *p sync_old_subsi_insn */
    case 575:  /* *p sync_old_iorsi_insn */
    case 576:  /* *p sync_old_xorsi_insn */
    case 577:  /* *p sync_old_andsi_insn */
    case 578:  /* *p sync_new_addsi_insn */
    case 579:  /* *p sync_new_subsi_insn */
    case 580:  /* *p sync_new_iorsi_insn */
    case 581:  /* *p sync_new_xorsi_insn */
    case 582:  /* *p sync_new_andsi_insn */
    case 583:  /* *p sync_nandsi_insn */
    case 584:  /* *p sync_old_nandsi_insn */
    case 585:  /* *p sync_new_nandsi_insn */
      return TYPE_ATOMIC;

    case 33:  /* mult_shadow */
    case 372:  /* *p mult_shadow */
      return TYPE_MULT_SHADOW;

    case 32:  /* load_shadow */
    case 371:  /* *p load_shadow */
      return TYPE_LOAD_SHADOW;

    case 84:  /* indirect_jump_shadow */
    case 85:  /* indirect_call_value_shadow */
    case 86:  /* indirect_sibcall_shadow */
    case 87:  /* indirect_call_shadow */
    case 88:  /* call_value_shadow */
    case 89:  /* call_shadow */
    case 90:  /* sibcall_shadow */
    case 91:  /* jump_shadow */
    case 92:  /* condjump_shadow */
    case 93:  /* return_shadow */
    case 405:  /* *p indirect_jump_shadow */
    case 406:  /* *p indirect_call_value_shadow */
    case 407:  /* *p indirect_sibcall_shadow */
    case 408:  /* *p indirect_call_shadow */
    case 409:  /* *p call_value_shadow */
    case 410:  /* *p call_shadow */
    case 411:  /* *p sibcall_shadow */
    case 412:  /* *p jump_shadow */
    case 413:  /* *p condjump_shadow */
    case 414:  /* *p return_shadow */
      return TYPE_SHADOW;

    case 156:  /* blockage */
    case 160:  /* epilogue_barrier */
    case 472:  /* *p blockage */
    case 476:  /* *p epilogue_barrier */
      return TYPE_BLOCKAGE;

    case 77:  /* mvilc */
      return TYPE_MVILC;

    case 78:  /* sploop */
      return TYPE_SPLOOP;

    case 79:  /* spkernel */
    case 80:  /* loop_end */
    case 402:  /* *p loop_end */
      return TYPE_SPKERNEL;

    case 153:  /* *muldf_ext2 */
    case 469:  /* *p *muldf_ext2 */
      return TYPE_MPYSP2DP;

    case 152:  /* *muldf_ext1 */
    case 468:  /* *p *muldf_ext1 */
      return TYPE_MPYSPDP;

    case 151:  /* muldf3 */
    case 467:  /* *p muldf3 */
      return TYPE_MPYDP;

    case 100:  /* adddf3 */
    case 102:  /* subdf3 */
    case 421:  /* *p adddf3 */
    case 423:  /* *p subdf3 */
      return TYPE_ADDDP;

    case 65:  /* *cmpdf_insn */
    case 68:  /* *cmpdf_and_insn */
    case 69:  /* *cmpdf_ior_insn */
    case 398:  /* *p *cmpdf_insn */
      return TYPE_CMPDP;

    case 110:  /* floatsidf2 */
    case 111:  /* floatunssidf2 */
    case 431:  /* *p floatsidf2 */
    case 432:  /* *p floatunssidf2 */
      return TYPE_INTDP;

    case 99:  /* addsf3 */
    case 101:  /* subsf3 */
    case 107:  /* truncdfsf2 */
    case 108:  /* floatsisf2 */
    case 109:  /* floatunssisf2 */
    case 112:  /* fix_truncsfsi2 */
    case 113:  /* fix_truncdfsi2 */
    case 420:  /* *p addsf3 */
    case 422:  /* *p subsf3 */
    case 428:  /* *p truncdfsf2 */
    case 429:  /* *p floatsisf2 */
    case 430:  /* *p floatunssisf2 */
    case 433:  /* *p fix_truncsfsi2 */
    case 434:  /* *p fix_truncdfsi2 */
      return TYPE_FP4;

    case 106:  /* extendsfdf2 */
    case 155:  /* rcpdf2 */
    case 427:  /* *p extendsfdf2 */
    case 471:  /* *p rcpdf2 */
      return TYPE_DP2;

    case 120:  /* callp */
    case 121:  /* callp_value */
    case 157:  /* push_rts */
    case 158:  /* pop_rts */
    case 473:  /* *p push_rts */
    case 474:  /* *p pop_rts */
      return TYPE_CALLP;

    case 82:  /* real_call */
    case 117:  /* call_internal */
    case 118:  /* call_value_internal */
    case 136:  /* divsi3_insn */
    case 137:  /* divsi3_insn_indcall */
    case 138:  /* udivsi3_insn */
    case 139:  /* udivsi3_insn_indcall */
    case 140:  /* modsi3_insn */
    case 141:  /* modsi3_insn_indcall */
    case 142:  /* divmodsi4_insn */
    case 143:  /* divmodsi4_insn_indcall */
    case 144:  /* umodsi3_insn */
    case 145:  /* umodsi3_insn_indcall */
    case 146:  /* udivmodsi4_insn */
    case 147:  /* udivmodsi4_insn_indcall */
    case 452:  /* *p divsi3_insn */
    case 453:  /* *p divsi3_insn_indcall */
    case 454:  /* *p udivsi3_insn */
    case 455:  /* *p udivsi3_insn_indcall */
    case 456:  /* *p modsi3_insn */
    case 457:  /* *p modsi3_insn_indcall */
    case 458:  /* *p divmodsi4_insn */
    case 459:  /* *p divmodsi4_insn_indcall */
    case 460:  /* *p umodsi3_insn */
    case 461:  /* *p umodsi3_insn_indcall */
    case 462:  /* *p udivmodsi4_insn */
    case 463:  /* *p udivmodsi4_insn_indcall */
      return TYPE_CALL;

    case 70:  /* indirect_jump */
    case 71:  /* jump */
    case 72:  /* *tablejump_internal */
    case 73:  /* casesi_internal */
    case 74:  /* br_true */
    case 75:  /* br_false */
    case 81:  /* real_jump */
    case 83:  /* real_ret */
    case 119:  /* sibcall_internal */
    case 122:  /* return_internal */
    case 399:  /* *p indirect_jump */
    case 400:  /* *p jump */
    case 403:  /* *p real_jump */
    case 404:  /* *p real_ret */
    case 438:  /* *p return_internal */
      return TYPE_BRANCH;

    case 38:  /* movmisalignsi_load */
    case 39:  /* movmisaligndi_load */
    case 40:  /* movmisalignv2hi_load */
    case 41:  /* movmisalignv4qi_load */
    case 377:  /* *p movmisalignsi_load */
    case 378:  /* *p movmisaligndi_load */
    case 379:  /* *p movmisalignv2hi_load */
    case 380:  /* *p movmisalignv4qi_load */
      return TYPE_LOADN;

    case 7:  /* load_got_gotoff */
    case 21:  /* real_loadqi */
    case 22:  /* real_loadhi */
    case 23:  /* real_loadsi */
    case 24:  /* real_loadsf */
    case 25:  /* real_loadv2hi */
    case 26:  /* real_loadv4qi */
    case 27:  /* real_loaddi */
    case 28:  /* real_loaddf */
    case 29:  /* real_loadv2si */
    case 30:  /* real_loadv4hi */
    case 31:  /* real_loadv8qi */
    case 48:  /* real_zero_extendqi */
    case 49:  /* real_sign_extendqi */
    case 50:  /* real_zero_extendhi */
    case 51:  /* real_sign_extendhi */
    case 159:  /* setup_dsbt */
    case 347:  /* *p load_got_gotoff */
    case 360:  /* *p real_loadqi */
    case 361:  /* *p real_loadhi */
    case 362:  /* *p real_loadsi */
    case 363:  /* *p real_loadsf */
    case 364:  /* *p real_loadv2hi */
    case 365:  /* *p real_loadv4qi */
    case 366:  /* *p real_loaddi */
    case 367:  /* *p real_loaddf */
    case 368:  /* *p real_loadv2si */
    case 369:  /* *p real_loadv4hi */
    case 370:  /* *p real_loadv8qi */
    case 387:  /* *p real_zero_extendqi */
    case 388:  /* *p real_sign_extendqi */
    case 389:  /* *p real_zero_extendhi */
    case 390:  /* *p real_sign_extendhi */
    case 475:  /* *p setup_dsbt */
      return TYPE_LOAD;

    case 150:  /* mulsf3 */
    case 206:  /* mulsi3_insn */
    case 207:  /* umulsidi3 */
    case 208:  /* mulsidi3 */
    case 209:  /* usmulsidi3 */
    case 210:  /* mulv2hiv2si3 */
    case 211:  /* umulv4qiv4hi3 */
    case 212:  /* usmulv4qiv4hi3 */
    case 213:  /* dotv2hi */
    case 214:  /* mulv2hqv2sq3 */
    case 238:  /* mulsi3_insn_real */
    case 239:  /* umulsidi3_real */
    case 240:  /* mulsidi3_real */
    case 241:  /* usmulsidi3_real */
    case 242:  /* mulv2hiv2si3_real */
    case 243:  /* umulv4qiv4hi3_real */
    case 244:  /* usmulv4qiv4hi3_real */
    case 245:  /* dotv2hi_real */
    case 246:  /* mulv2hqv2sq3_real */
    case 466:  /* *p mulsf3 */
    case 522:  /* *p mulsi3_insn */
    case 523:  /* *p umulsidi3 */
    case 524:  /* *p mulsidi3 */
    case 525:  /* *p usmulsidi3 */
    case 526:  /* *p mulv2hiv2si3 */
    case 527:  /* *p umulv4qiv4hi3 */
    case 528:  /* *p usmulv4qiv4hi3 */
    case 529:  /* *p dotv2hi */
    case 530:  /* *p mulv2hqv2sq3 */
    case 554:  /* *p mulsi3_insn_real */
    case 555:  /* *p umulsidi3_real */
    case 556:  /* *p mulsidi3_real */
    case 557:  /* *p usmulsidi3_real */
    case 558:  /* *p mulv2hiv2si3_real */
    case 559:  /* *p umulv4qiv4hi3_real */
    case 560:  /* *p usmulv4qiv4hi3_real */
    case 561:  /* *p dotv2hi_real */
    case 562:  /* *p mulv2hqv2sq3_real */
      return TYPE_MPY4;

    case 34:  /* movmisalignsi_store */
    case 35:  /* movmisaligndi_store */
    case 36:  /* movmisalignv2hi_store */
    case 37:  /* movmisalignv4qi_store */
    case 373:  /* *p movmisalignsi_store */
    case 374:  /* *p movmisaligndi_store */
    case 375:  /* *p movmisalignv2hi_store */
    case 376:  /* *p movmisalignv4qi_store */
      return TYPE_STOREN;

    case 187:  /* rotlsi3 */
    case 188:  /* bitrevsi2 */
    case 189:  /* avgv2hi3 */
    case 190:  /* uavgv4qi3 */
    case 191:  /* mulhi3 */
    case 192:  /* mulhisi3_const */
    case 193:  /* *mulhisi3_insn */
    case 194:  /* mulhisi3_lh */
    case 195:  /* mulhisi3_hl */
    case 196:  /* mulhisi3_hh */
    case 197:  /* umulhisi3 */
    case 198:  /* umulhisi3_lh */
    case 199:  /* umulhisi3_hl */
    case 200:  /* umulhisi3_hh */
    case 201:  /* usmulhisi3_const */
    case 202:  /* *usmulhisi3_insn */
    case 203:  /* usmulhisi3_lh */
    case 204:  /* usmulhisi3_hl */
    case 205:  /* usmulhisi3_hh */
    case 215:  /* mulhqsq3 */
    case 216:  /* mulhqsq3_lh */
    case 217:  /* mulhqsq3_hl */
    case 218:  /* mulhqsq3_hh */
    case 219:  /* rotlsi3_real */
    case 220:  /* bitrevsi2_real */
    case 221:  /* avgv2hi3_real */
    case 222:  /* uavgv4qi3_real */
    case 223:  /* mulhi3_real */
    case 224:  /* mulhisi3_const_real */
    case 225:  /* *mulhisi3_insn_real */
    case 226:  /* mulhisi3_lh_real */
    case 227:  /* mulhisi3_hl_real */
    case 228:  /* mulhisi3_hh_real */
    case 229:  /* umulhisi3_real */
    case 230:  /* umulhisi3_lh_real */
    case 231:  /* umulhisi3_hl_real */
    case 232:  /* umulhisi3_hh_real */
    case 233:  /* usmulhisi3_const_real */
    case 234:  /* *usmulhisi3_insn_real */
    case 235:  /* usmulhisi3_lh_real */
    case 236:  /* usmulhisi3_hl_real */
    case 237:  /* usmulhisi3_hh_real */
    case 247:  /* mulhqsq3_real */
    case 248:  /* mulhqsq3_lh_real */
    case 249:  /* mulhqsq3_hl_real */
    case 250:  /* mulhqsq3_hh_real */
    case 503:  /* *p rotlsi3 */
    case 504:  /* *p bitrevsi2 */
    case 505:  /* *p avgv2hi3 */
    case 506:  /* *p uavgv4qi3 */
    case 507:  /* *p mulhi3 */
    case 508:  /* *p mulhisi3_const */
    case 509:  /* *p *mulhisi3_insn */
    case 510:  /* *p mulhisi3_lh */
    case 511:  /* *p mulhisi3_hl */
    case 512:  /* *p mulhisi3_hh */
    case 513:  /* *p umulhisi3 */
    case 514:  /* *p umulhisi3_lh */
    case 515:  /* *p umulhisi3_hl */
    case 516:  /* *p umulhisi3_hh */
    case 517:  /* *p usmulhisi3_const */
    case 518:  /* *p *usmulhisi3_insn */
    case 519:  /* *p usmulhisi3_lh */
    case 520:  /* *p usmulhisi3_hl */
    case 521:  /* *p usmulhisi3_hh */
    case 531:  /* *p mulhqsq3 */
    case 532:  /* *p mulhqsq3_lh */
    case 533:  /* *p mulhqsq3_hl */
    case 534:  /* *p mulhqsq3_hh */
    case 535:  /* *p rotlsi3_real */
    case 536:  /* *p bitrevsi2_real */
    case 537:  /* *p avgv2hi3_real */
    case 538:  /* *p uavgv4qi3_real */
    case 539:  /* *p mulhi3_real */
    case 540:  /* *p mulhisi3_const_real */
    case 541:  /* *p *mulhisi3_insn_real */
    case 542:  /* *p mulhisi3_lh_real */
    case 543:  /* *p mulhisi3_hl_real */
    case 544:  /* *p mulhisi3_hh_real */
    case 545:  /* *p umulhisi3_real */
    case 546:  /* *p umulhisi3_lh_real */
    case 547:  /* *p umulhisi3_hl_real */
    case 548:  /* *p umulhisi3_hh_real */
    case 549:  /* *p usmulhisi3_const_real */
    case 550:  /* *p *usmulhisi3_insn_real */
    case 551:  /* *p usmulhisi3_lh_real */
    case 552:  /* *p usmulhisi3_hl_real */
    case 553:  /* *p usmulhisi3_hh_real */
    case 563:  /* *p mulhqsq3_real */
    case 564:  /* *p mulhqsq3_lh_real */
    case 565:  /* *p mulhqsq3_hl_real */
    case 566:  /* *p mulhqsq3_hh_real */
      return TYPE_MPY2;

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return TYPE_SINGLE;

    }
}

enum attr_units
get_attr_units (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case 435:  /* *p saddsi3 */
    case 114:  /* saddsi3 */
      extract_constrain_insn_cached (insn);
      if (((1 << which_alternative) & 0xf))
        {
	  return UNITS_LS;
        }
      else
        {
	  return UNITS_L;
        }

    case 384:  /* *p sign_extendhisi2 */
    case 383:  /* *p zero_extendhisi2 */
    case 382:  /* *p sign_extendqisi2 */
    case 381:  /* *p zero_extendqisi2 */
    case 45:  /* sign_extendhisi2 */
    case 44:  /* zero_extendhisi2 */
    case 43:  /* sign_extendqisi2 */
    case 42:  /* zero_extendqisi2 */
      extract_constrain_insn_cached (insn);
      if (((1 << which_alternative) & 0x3))
        {
	  return UNITS_S;
        }
      else
        {
	  return UNITS_D_ADDR;
        }

    case 16:  /* *movdi_insn */
    case 17:  /* *movdf_insn */
    case 18:  /* *movv2si_insn */
    case 19:  /* *movv4hi_insn */
    case 20:  /* *movv8qi_insn */
    case 355:  /* *p *movdi_insn */
    case 356:  /* *p *movdf_insn */
    case 357:  /* *p *movv2si_insn */
    case 358:  /* *p *movv4hi_insn */
    case 359:  /* *p *movv8qi_insn */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return UNITS_S;
        }
      else if (which_alternative == 1)
        {
	  return UNITS_S;
        }
      else if (which_alternative == 2)
        {
	  if (((
#line 136 "../../gcc-8.1.1-20180626/gcc/config/c6x/c6x.md"
((enum attr_cpu)c6x_arch)) == (
(CPU_C62X))))
	    {
	      return (enum attr_units)get_attr_units62 (insn);
	    }
	  else if (((
#line 136 "../../gcc-8.1.1-20180626/gcc/config/c6x/c6x.md"
((enum attr_cpu)c6x_arch)) == (
(CPU_C67X))))
	    {
	      return (enum attr_units)get_attr_units67 (insn);
	    }
	  else if (((
#line 136 "../../gcc-8.1.1-20180626/gcc/config/c6x/c6x.md"
((enum attr_cpu)c6x_arch)) == (
(CPU_C67XP))))
	    {
	      return (enum attr_units)get_attr_units67p (insn);
	    }
	  else if (((
#line 136 "../../gcc-8.1.1-20180626/gcc/config/c6x/c6x.md"
((enum attr_cpu)c6x_arch)) == (
(CPU_C64X))))
	    {
	      return (enum attr_units)get_attr_units64 (insn);
	    }
	  else if (((
#line 136 "../../gcc-8.1.1-20180626/gcc/config/c6x/c6x.md"
((enum attr_cpu)c6x_arch)) == (
(CPU_C64XP))))
	    {
	      return (enum attr_units)get_attr_units64p (insn);
	    }
	  else if (((
#line 136 "../../gcc-8.1.1-20180626/gcc/config/c6x/c6x.md"
((enum attr_cpu)c6x_arch)) == (
(CPU_C674X))))
	    {
	      return (enum attr_units)get_attr_units674 (insn);
	    }
	  else
	    {
	      return UNITS_UNKNOWN;
	    }
        }
      else if (which_alternative == 3)
        {
	  if (((
#line 136 "../../gcc-8.1.1-20180626/gcc/config/c6x/c6x.md"
((enum attr_cpu)c6x_arch)) == (
(CPU_C62X))))
	    {
	      return (enum attr_units)get_attr_units62 (insn);
	    }
	  else if (((
#line 136 "../../gcc-8.1.1-20180626/gcc/config/c6x/c6x.md"
((enum attr_cpu)c6x_arch)) == (
(CPU_C67X))))
	    {
	      return (enum attr_units)get_attr_units67 (insn);
	    }
	  else if (((
#line 136 "../../gcc-8.1.1-20180626/gcc/config/c6x/c6x.md"
((enum attr_cpu)c6x_arch)) == (
(CPU_C67XP))))
	    {
	      return (enum attr_units)get_attr_units67p (insn);
	    }
	  else if (((
#line 136 "../../gcc-8.1.1-20180626/gcc/config/c6x/c6x.md"
((enum attr_cpu)c6x_arch)) == (
(CPU_C64X))))
	    {
	      return (enum attr_units)get_attr_units64 (insn);
	    }
	  else if (((
#line 136 "../../gcc-8.1.1-20180626/gcc/config/c6x/c6x.md"
((enum attr_cpu)c6x_arch)) == (
(CPU_C64XP))))
	    {
	      return (enum attr_units)get_attr_units64p (insn);
	    }
	  else if (((
#line 136 "../../gcc-8.1.1-20180626/gcc/config/c6x/c6x.md"
((enum attr_cpu)c6x_arch)) == (
(CPU_C674X))))
	    {
	      return (enum attr_units)get_attr_units674 (insn);
	    }
	  else
	    {
	      return UNITS_UNKNOWN;
	    }
        }
      else if (which_alternative == 4)
        {
	  if (((
#line 136 "../../gcc-8.1.1-20180626/gcc/config/c6x/c6x.md"
((enum attr_cpu)c6x_arch)) == (
(CPU_C62X))))
	    {
	      return (enum attr_units)get_attr_units62 (insn);
	    }
	  else if (((
#line 136 "../../gcc-8.1.1-20180626/gcc/config/c6x/c6x.md"
((enum attr_cpu)c6x_arch)) == (
(CPU_C67X))))
	    {
	      return (enum attr_units)get_attr_units67 (insn);
	    }
	  else if (((
#line 136 "../../gcc-8.1.1-20180626/gcc/config/c6x/c6x.md"
((enum attr_cpu)c6x_arch)) == (
(CPU_C67XP))))
	    {
	      return (enum attr_units)get_attr_units67p (insn);
	    }
	  else if (((
#line 136 "../../gcc-8.1.1-20180626/gcc/config/c6x/c6x.md"
((enum attr_cpu)c6x_arch)) == (
(CPU_C64X))))
	    {
	      return (enum attr_units)get_attr_units64 (insn);
	    }
	  else if (((
#line 136 "../../gcc-8.1.1-20180626/gcc/config/c6x/c6x.md"
((enum attr_cpu)c6x_arch)) == (
(CPU_C64XP))))
	    {
	      return (enum attr_units)get_attr_units64p (insn);
	    }
	  else if (((
#line 136 "../../gcc-8.1.1-20180626/gcc/config/c6x/c6x.md"
((enum attr_cpu)c6x_arch)) == (
(CPU_C674X))))
	    {
	      return (enum attr_units)get_attr_units674 (insn);
	    }
	  else
	    {
	      return UNITS_UNKNOWN;
	    }
        }
      else if (which_alternative == 5)
        {
	  return UNITS_D_ADDR;
        }
      else if (which_alternative == 6)
        {
	  return UNITS_D_ADDR;
        }
      else if (which_alternative == 7)
        {
	  return UNITS_D_ADDR;
        }
      else if (which_alternative == 8)
        {
	  return UNITS_D_ADDR;
        }
      else if (which_alternative == 9)
        {
	  return UNITS_D_ADDR;
        }
      else if (which_alternative == 10)
        {
	  return UNITS_D_ADDR;
        }
      else if (which_alternative == 11)
        {
	  return UNITS_D_ADDR;
        }
      else
        {
	  return UNITS_D_ADDR;
        }

    case 124:  /* negsi2 */
    case 125:  /* one_cmplsi2 */
    case 134:  /* shlmbsi3 */
    case 185:  /* *packv2hi_insv */
    case 186:  /* movstricthi */
    case 440:  /* *p negsi2 */
    case 441:  /* *p one_cmplsi2 */
    case 450:  /* *p shlmbsi3 */
    case 501:  /* *p *packv2hi_insv */
    case 502:  /* *p movstricthi */
      return UNITS_LS;

    case 3:  /* movsi_lo_sum */
    case 4:  /* movsi_high */
    case 5:  /* movsi_gotoff_lo_sum */
    case 6:  /* movsi_gotoff_high */
    case 8:  /* *movstricthi_high */
    case 46:  /* *extzv_const */
    case 47:  /* *extv_const */
    case 52:  /* clrr */
    case 53:  /* extr */
    case 54:  /* extru */
    case 64:  /* *cmpsf_insn */
    case 65:  /* *cmpdf_insn */
    case 66:  /* *cmpsf_and_insn */
    case 67:  /* *cmpsf_ior_insn */
    case 68:  /* *cmpdf_and_insn */
    case 69:  /* *cmpdf_ior_insn */
    case 70:  /* indirect_jump */
    case 71:  /* jump */
    case 72:  /* *tablejump_internal */
    case 74:  /* br_true */
    case 75:  /* br_false */
    case 77:  /* mvilc */
    case 81:  /* real_jump */
    case 82:  /* real_call */
    case 83:  /* real_ret */
    case 106:  /* extendsfdf2 */
    case 117:  /* call_internal */
    case 118:  /* call_value_internal */
    case 119:  /* sibcall_internal */
    case 120:  /* callp */
    case 121:  /* callp_value */
    case 122:  /* return_internal */
    case 123:  /* addkpc */
    case 129:  /* ss_ashlsi3 */
    case 130:  /* ashlsi3 */
    case 131:  /* ashrsi3 */
    case 132:  /* lshrsi3 */
    case 136:  /* divsi3_insn */
    case 137:  /* divsi3_insn_indcall */
    case 138:  /* udivsi3_insn */
    case 139:  /* udivsi3_insn_indcall */
    case 140:  /* modsi3_insn */
    case 141:  /* modsi3_insn_indcall */
    case 142:  /* divmodsi4_insn */
    case 143:  /* divmodsi4_insn_indcall */
    case 144:  /* umodsi3_insn */
    case 145:  /* umodsi3_insn_indcall */
    case 146:  /* udivmodsi4_insn */
    case 147:  /* udivmodsi4_insn_indcall */
    case 154:  /* rcpsf2 */
    case 155:  /* rcpdf2 */
    case 157:  /* push_rts */
    case 158:  /* pop_rts */
    case 171:  /* ss_addv2hi3 */
    case 173:  /* us_addv4qi3 */
    case 182:  /* ashrv2hi3 */
    case 183:  /* lshrv2hi3 */
    case 343:  /* *p movsi_lo_sum */
    case 344:  /* *p movsi_high */
    case 345:  /* *p movsi_gotoff_lo_sum */
    case 346:  /* *p movsi_gotoff_high */
    case 348:  /* *p *movstricthi_high */
    case 385:  /* *p *extzv_const */
    case 386:  /* *p *extv_const */
    case 391:  /* *p clrr */
    case 392:  /* *p extr */
    case 393:  /* *p extru */
    case 397:  /* *p *cmpsf_insn */
    case 398:  /* *p *cmpdf_insn */
    case 399:  /* *p indirect_jump */
    case 400:  /* *p jump */
    case 403:  /* *p real_jump */
    case 404:  /* *p real_ret */
    case 427:  /* *p extendsfdf2 */
    case 438:  /* *p return_internal */
    case 439:  /* *p addkpc */
    case 445:  /* *p ss_ashlsi3 */
    case 446:  /* *p ashlsi3 */
    case 447:  /* *p ashrsi3 */
    case 448:  /* *p lshrsi3 */
    case 452:  /* *p divsi3_insn */
    case 453:  /* *p divsi3_insn_indcall */
    case 454:  /* *p udivsi3_insn */
    case 455:  /* *p udivsi3_insn_indcall */
    case 456:  /* *p modsi3_insn */
    case 457:  /* *p modsi3_insn_indcall */
    case 458:  /* *p divmodsi4_insn */
    case 459:  /* *p divmodsi4_insn_indcall */
    case 460:  /* *p umodsi3_insn */
    case 461:  /* *p umodsi3_insn_indcall */
    case 462:  /* *p udivmodsi4_insn */
    case 463:  /* *p udivmodsi4_insn_indcall */
    case 470:  /* *p rcpsf2 */
    case 471:  /* *p rcpdf2 */
    case 473:  /* *p push_rts */
    case 474:  /* *p pop_rts */
    case 487:  /* *p ss_addv2hi3 */
    case 489:  /* *p us_addv4qi3 */
    case 498:  /* *p ashrv2hi3 */
    case 499:  /* *p lshrv2hi3 */
      return UNITS_S;

    case 150:  /* mulsf3 */
    case 151:  /* muldf3 */
    case 152:  /* *muldf_ext1 */
    case 153:  /* *muldf_ext2 */
    case 187:  /* rotlsi3 */
    case 188:  /* bitrevsi2 */
    case 189:  /* avgv2hi3 */
    case 190:  /* uavgv4qi3 */
    case 191:  /* mulhi3 */
    case 192:  /* mulhisi3_const */
    case 193:  /* *mulhisi3_insn */
    case 194:  /* mulhisi3_lh */
    case 195:  /* mulhisi3_hl */
    case 196:  /* mulhisi3_hh */
    case 197:  /* umulhisi3 */
    case 198:  /* umulhisi3_lh */
    case 199:  /* umulhisi3_hl */
    case 200:  /* umulhisi3_hh */
    case 201:  /* usmulhisi3_const */
    case 202:  /* *usmulhisi3_insn */
    case 203:  /* usmulhisi3_lh */
    case 204:  /* usmulhisi3_hl */
    case 205:  /* usmulhisi3_hh */
    case 206:  /* mulsi3_insn */
    case 207:  /* umulsidi3 */
    case 208:  /* mulsidi3 */
    case 209:  /* usmulsidi3 */
    case 210:  /* mulv2hiv2si3 */
    case 211:  /* umulv4qiv4hi3 */
    case 212:  /* usmulv4qiv4hi3 */
    case 213:  /* dotv2hi */
    case 214:  /* mulv2hqv2sq3 */
    case 215:  /* mulhqsq3 */
    case 216:  /* mulhqsq3_lh */
    case 217:  /* mulhqsq3_hl */
    case 218:  /* mulhqsq3_hh */
    case 219:  /* rotlsi3_real */
    case 220:  /* bitrevsi2_real */
    case 221:  /* avgv2hi3_real */
    case 222:  /* uavgv4qi3_real */
    case 223:  /* mulhi3_real */
    case 224:  /* mulhisi3_const_real */
    case 225:  /* *mulhisi3_insn_real */
    case 226:  /* mulhisi3_lh_real */
    case 227:  /* mulhisi3_hl_real */
    case 228:  /* mulhisi3_hh_real */
    case 229:  /* umulhisi3_real */
    case 230:  /* umulhisi3_lh_real */
    case 231:  /* umulhisi3_hl_real */
    case 232:  /* umulhisi3_hh_real */
    case 233:  /* usmulhisi3_const_real */
    case 234:  /* *usmulhisi3_insn_real */
    case 235:  /* usmulhisi3_lh_real */
    case 236:  /* usmulhisi3_hl_real */
    case 237:  /* usmulhisi3_hh_real */
    case 238:  /* mulsi3_insn_real */
    case 239:  /* umulsidi3_real */
    case 240:  /* mulsidi3_real */
    case 241:  /* usmulsidi3_real */
    case 242:  /* mulv2hiv2si3_real */
    case 243:  /* umulv4qiv4hi3_real */
    case 244:  /* usmulv4qiv4hi3_real */
    case 245:  /* dotv2hi_real */
    case 246:  /* mulv2hqv2sq3_real */
    case 247:  /* mulhqsq3_real */
    case 248:  /* mulhqsq3_lh_real */
    case 249:  /* mulhqsq3_hl_real */
    case 250:  /* mulhqsq3_hh_real */
    case 466:  /* *p mulsf3 */
    case 467:  /* *p muldf3 */
    case 468:  /* *p *muldf_ext1 */
    case 469:  /* *p *muldf_ext2 */
    case 503:  /* *p rotlsi3 */
    case 504:  /* *p bitrevsi2 */
    case 505:  /* *p avgv2hi3 */
    case 506:  /* *p uavgv4qi3 */
    case 507:  /* *p mulhi3 */
    case 508:  /* *p mulhisi3_const */
    case 509:  /* *p *mulhisi3_insn */
    case 510:  /* *p mulhisi3_lh */
    case 511:  /* *p mulhisi3_hl */
    case 512:  /* *p mulhisi3_hh */
    case 513:  /* *p umulhisi3 */
    case 514:  /* *p umulhisi3_lh */
    case 515:  /* *p umulhisi3_hl */
    case 516:  /* *p umulhisi3_hh */
    case 517:  /* *p usmulhisi3_const */
    case 518:  /* *p *usmulhisi3_insn */
    case 519:  /* *p usmulhisi3_lh */
    case 520:  /* *p usmulhisi3_hl */
    case 521:  /* *p usmulhisi3_hh */
    case 522:  /* *p mulsi3_insn */
    case 523:  /* *p umulsidi3 */
    case 524:  /* *p mulsidi3 */
    case 525:  /* *p usmulsidi3 */
    case 526:  /* *p mulv2hiv2si3 */
    case 527:  /* *p umulv4qiv4hi3 */
    case 528:  /* *p usmulv4qiv4hi3 */
    case 529:  /* *p dotv2hi */
    case 530:  /* *p mulv2hqv2sq3 */
    case 531:  /* *p mulhqsq3 */
    case 532:  /* *p mulhqsq3_lh */
    case 533:  /* *p mulhqsq3_hl */
    case 534:  /* *p mulhqsq3_hh */
    case 535:  /* *p rotlsi3_real */
    case 536:  /* *p bitrevsi2_real */
    case 537:  /* *p avgv2hi3_real */
    case 538:  /* *p uavgv4qi3_real */
    case 539:  /* *p mulhi3_real */
    case 540:  /* *p mulhisi3_const_real */
    case 541:  /* *p *mulhisi3_insn_real */
    case 542:  /* *p mulhisi3_lh_real */
    case 543:  /* *p mulhisi3_hl_real */
    case 544:  /* *p mulhisi3_hh_real */
    case 545:  /* *p umulhisi3_real */
    case 546:  /* *p umulhisi3_lh_real */
    case 547:  /* *p umulhisi3_hl_real */
    case 548:  /* *p umulhisi3_hh_real */
    case 549:  /* *p usmulhisi3_const_real */
    case 550:  /* *p *usmulhisi3_insn_real */
    case 551:  /* *p usmulhisi3_lh_real */
    case 552:  /* *p usmulhisi3_hl_real */
    case 553:  /* *p usmulhisi3_hh_real */
    case 554:  /* *p mulsi3_insn_real */
    case 555:  /* *p umulsidi3_real */
    case 556:  /* *p mulsidi3_real */
    case 557:  /* *p usmulsidi3_real */
    case 558:  /* *p mulv2hiv2si3_real */
    case 559:  /* *p umulv4qiv4hi3_real */
    case 560:  /* *p usmulv4qiv4hi3_real */
    case 561:  /* *p dotv2hi_real */
    case 562:  /* *p mulv2hqv2sq3_real */
    case 563:  /* *p mulhqsq3_real */
    case 564:  /* *p mulhqsq3_lh_real */
    case 565:  /* *p mulhqsq3_hl_real */
    case 566:  /* *p mulhqsq3_hh_real */
      return UNITS_M;

    case 55:  /* scmpsi_insn */
    case 56:  /* *ucmpsi_insn_64 */
    case 57:  /* *ucmpsi_insn */
    case 58:  /* *scmpsi_and_insn */
    case 59:  /* *scmpsi_ior_insn */
    case 60:  /* *ucmpsi_and_insn_64 */
    case 61:  /* *ucmpsi_ior_insn_64 */
    case 62:  /* *ucmpsi_and_insn */
    case 63:  /* *ucmpsi_ior_insn */
    case 98:  /* addsidi3_widen */
    case 107:  /* truncdfsf2 */
    case 108:  /* floatsisf2 */
    case 109:  /* floatunssisf2 */
    case 110:  /* floatsidf2 */
    case 111:  /* floatunssidf2 */
    case 112:  /* fix_truncsfsi2 */
    case 113:  /* fix_truncdfsi2 */
    case 115:  /* ssubsi3 */
    case 116:  /* subcsi3 */
    case 126:  /* clrsbsi2 */
    case 127:  /* clzsi2 */
    case 128:  /* ssabssi2 */
    case 133:  /* rotrdi3_16 */
    case 135:  /* bswapv2hi2 */
    case 169:  /* addv4qi3 */
    case 170:  /* subv4qi3 */
    case 172:  /* ss_subv2hi3 */
    case 178:  /* umaxqi3 */
    case 179:  /* umaxv4qi3 */
    case 180:  /* uminqi3 */
    case 181:  /* uminv4qi3 */
    case 184:  /* ssabsv2hi2 */
    case 394:  /* *p scmpsi_insn */
    case 395:  /* *p *ucmpsi_insn_64 */
    case 396:  /* *p *ucmpsi_insn */
    case 419:  /* *p addsidi3_widen */
    case 428:  /* *p truncdfsf2 */
    case 429:  /* *p floatsisf2 */
    case 430:  /* *p floatunssisf2 */
    case 431:  /* *p floatsidf2 */
    case 432:  /* *p floatunssidf2 */
    case 433:  /* *p fix_truncsfsi2 */
    case 434:  /* *p fix_truncdfsi2 */
    case 436:  /* *p ssubsi3 */
    case 437:  /* *p subcsi3 */
    case 442:  /* *p clrsbsi2 */
    case 443:  /* *p clzsi2 */
    case 444:  /* *p ssabssi2 */
    case 449:  /* *p rotrdi3_16 */
    case 451:  /* *p bswapv2hi2 */
    case 485:  /* *p addv4qi3 */
    case 486:  /* *p subv4qi3 */
    case 488:  /* *p ss_subv2hi3 */
    case 494:  /* *p umaxqi3 */
    case 495:  /* *p umaxv4qi3 */
    case 496:  /* *p uminqi3 */
    case 497:  /* *p uminv4qi3 */
    case 500:  /* *p ssabsv2hi2 */
      return UNITS_L;

    case 7:  /* load_got_gotoff */
    case 21:  /* real_loadqi */
    case 22:  /* real_loadhi */
    case 23:  /* real_loadsi */
    case 24:  /* real_loadsf */
    case 25:  /* real_loadv2hi */
    case 26:  /* real_loadv4qi */
    case 27:  /* real_loaddi */
    case 28:  /* real_loaddf */
    case 29:  /* real_loadv2si */
    case 30:  /* real_loadv4hi */
    case 31:  /* real_loadv8qi */
    case 34:  /* movmisalignsi_store */
    case 35:  /* movmisaligndi_store */
    case 36:  /* movmisalignv2hi_store */
    case 37:  /* movmisalignv4qi_store */
    case 38:  /* movmisalignsi_load */
    case 39:  /* movmisaligndi_load */
    case 40:  /* movmisalignv2hi_load */
    case 41:  /* movmisalignv4qi_load */
    case 48:  /* real_zero_extendqi */
    case 49:  /* real_sign_extendqi */
    case 50:  /* real_zero_extendhi */
    case 51:  /* real_sign_extendhi */
    case 159:  /* setup_dsbt */
    case 347:  /* *p load_got_gotoff */
    case 360:  /* *p real_loadqi */
    case 361:  /* *p real_loadhi */
    case 362:  /* *p real_loadsi */
    case 363:  /* *p real_loadsf */
    case 364:  /* *p real_loadv2hi */
    case 365:  /* *p real_loadv4qi */
    case 366:  /* *p real_loaddi */
    case 367:  /* *p real_loaddf */
    case 368:  /* *p real_loadv2si */
    case 369:  /* *p real_loadv4hi */
    case 370:  /* *p real_loadv8qi */
    case 373:  /* *p movmisalignsi_store */
    case 374:  /* *p movmisaligndi_store */
    case 375:  /* *p movmisalignv2hi_store */
    case 376:  /* *p movmisalignv4qi_store */
    case 377:  /* *p movmisalignsi_load */
    case 378:  /* *p movmisaligndi_load */
    case 379:  /* *p movmisalignv2hi_load */
    case 380:  /* *p movmisalignv4qi_load */
    case 387:  /* *p real_zero_extendqi */
    case 388:  /* *p real_sign_extendqi */
    case 389:  /* *p real_zero_extendhi */
    case 390:  /* *p real_sign_extendhi */
    case 475:  /* *p setup_dsbt */
      return UNITS_D_ADDR;

    case 9:  /* load_sdata_pic */
    case 96:  /* *addshiftsi */
    case 97:  /* *subshiftsi */
    case 417:  /* *p *addshiftsi */
    case 418:  /* *p *subshiftsi */
      return UNITS_D;

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      if (((
#line 136 "../../gcc-8.1.1-20180626/gcc/config/c6x/c6x.md"
((enum attr_cpu)c6x_arch)) == (
(CPU_C62X))))
        {
	  return (enum attr_units)get_attr_units62 (insn);
        }
      else if (((
#line 136 "../../gcc-8.1.1-20180626/gcc/config/c6x/c6x.md"
((enum attr_cpu)c6x_arch)) == (
(CPU_C67X))))
        {
	  return (enum attr_units)get_attr_units67 (insn);
        }
      else if (((
#line 136 "../../gcc-8.1.1-20180626/gcc/config/c6x/c6x.md"
((enum attr_cpu)c6x_arch)) == (
(CPU_C67XP))))
        {
	  return (enum attr_units)get_attr_units67p (insn);
        }
      else if (((
#line 136 "../../gcc-8.1.1-20180626/gcc/config/c6x/c6x.md"
((enum attr_cpu)c6x_arch)) == (
(CPU_C64X))))
        {
	  return (enum attr_units)get_attr_units64 (insn);
        }
      else if (((
#line 136 "../../gcc-8.1.1-20180626/gcc/config/c6x/c6x.md"
((enum attr_cpu)c6x_arch)) == (
(CPU_C64XP))))
        {
	  return (enum attr_units)get_attr_units64p (insn);
        }
      else if (((
#line 136 "../../gcc-8.1.1-20180626/gcc/config/c6x/c6x.md"
((enum attr_cpu)c6x_arch)) == (
(CPU_C674X))))
        {
	  return (enum attr_units)get_attr_units674 (insn);
        }
      else
        {
	  return UNITS_UNKNOWN;
        }

    }
}

enum attr_units674
get_attr_units674 (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case 99:  /* addsf3 */
    case 100:  /* adddf3 */
    case 101:  /* subsf3 */
    case 102:  /* subdf3 */
    case 420:  /* *p addsf3 */
    case 421:  /* *p adddf3 */
    case 422:  /* *p subsf3 */
    case 423:  /* *p subdf3 */
      return UNITS674_LS;

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return (enum attr_units674)get_attr_units64 (insn);

    }
}

enum attr_units67p
get_attr_units67p (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case 99:  /* addsf3 */
    case 100:  /* adddf3 */
    case 101:  /* subsf3 */
    case 102:  /* subdf3 */
    case 420:  /* *p addsf3 */
    case 421:  /* *p adddf3 */
    case 422:  /* *p subsf3 */
    case 423:  /* *p subdf3 */
      return UNITS67P_LS;

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return (enum attr_units67p)get_attr_units67 (insn);

    }
}

enum attr_units67
get_attr_units67 (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case 415:  /* *p addsi3 */
    case 94:  /* addsi3 */
      extract_constrain_insn_cached (insn);
      if (((1 << which_alternative) & 0x3))
        {
	  return UNITS67_DLS;
        }
      else if (((1 << which_alternative) & 0xfc))
        {
	  return UNITS67_LS;
        }
      else if (which_alternative == 8)
        {
	  return UNITS67_DS;
        }
      else if (((1 << which_alternative) & 0x600))
        {
	  return UNITS67_D;
        }
      else if (((1 << which_alternative) & 0x1800))
        {
	  return (enum attr_units67)get_attr_units62 (insn);
        }
      else
        {
	  return UNITS67_S;
        }

    case 99:  /* addsf3 */
    case 100:  /* adddf3 */
    case 101:  /* subsf3 */
    case 102:  /* subdf3 */
    case 420:  /* *p addsf3 */
    case 421:  /* *p adddf3 */
    case 422:  /* *p subsf3 */
    case 423:  /* *p subdf3 */
      return UNITS67_L;

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return (enum attr_units67)get_attr_units62 (insn);

    }
}

enum attr_units64p
get_attr_units64p (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case 174:  /* smaxhi3 */
    case 175:  /* smaxv2hi3 */
    case 176:  /* sminhi3 */
    case 177:  /* sminv2hi3 */
    case 490:  /* *p smaxhi3 */
    case 491:  /* *p smaxv2hi3 */
    case 492:  /* *p sminhi3 */
    case 493:  /* *p sminv2hi3 */
      return UNITS64P_LS;

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return (enum attr_units64p)get_attr_units64 (insn);

    }
}

enum attr_units64
get_attr_units64 (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case 425:  /* *p iorsi3 */
    case 424:  /* *p andsi3 */
    case 104:  /* iorsi3 */
    case 103:  /* andsi3 */
      extract_constrain_insn_cached (insn);
      if (((1 << which_alternative) & 0xf))
        {
	  return UNITS64_DLS;
        }
      else
        {
	  return UNITS64_S;
        }

    case 416:  /* *p subsi3 */
    case 95:  /* subsi3 */
      extract_constrain_insn_cached (insn);
      if (((1 << which_alternative) & 0x3))
        {
	  return UNITS64_DLS;
        }
      else
        {
	  return UNITS64_LS;
        }

    case 415:  /* *p addsi3 */
    case 94:  /* addsi3 */
      extract_constrain_insn_cached (insn);
      if (((1 << which_alternative) & 0x3f))
        {
	  return UNITS64_DLS;
        }
      else if (((1 << which_alternative) & 0xc0))
        {
	  return UNITS64_LS;
        }
      else if (which_alternative == 8)
        {
	  return UNITS64_DS;
        }
      else if (((1 << which_alternative) & 0x1e00))
        {
	  return UNITS64_D;
        }
      else
        {
	  return UNITS64_S;
        }

    case 354:  /* *p movv4qi_insn */
    case 353:  /* *p movv2hi_insn */
    case 352:  /* *p movsf_insn */
    case 351:  /* *p movsi_insn */
    case 15:  /* movv4qi_insn */
    case 14:  /* movv2hi_insn */
    case 13:  /* movsf_insn */
    case 12:  /* movsi_insn */
      extract_constrain_insn_cached (insn);
      if (((1 << which_alternative) & 0x3))
        {
	  return UNITS64_DLS;
        }
      else if (((1 << which_alternative) & 0xc))
        {
	  return UNITS64_LS;
        }
      else if (which_alternative == 4)
        {
	  return UNITS64_DL;
        }
      else if (which_alternative == 5)
        {
	  return UNITS64_S;
        }
      else if (((1 << which_alternative) & 0xc0))
        {
	  return UNITS64_D;
        }
      else if (which_alternative == 8)
        {
	  return UNITS64_UNKNOWN;
        }
      else
        {
	  return UNITS64_D_ADDR;
        }

    case 350:  /* *p movhi_insn */
    case 349:  /* *p movqi_insn */
    case 11:  /* movhi_insn */
    case 10:  /* movqi_insn */
      extract_constrain_insn_cached (insn);
      if (((1 << which_alternative) & 0x3))
        {
	  return UNITS64_DLS;
        }
      else if (((1 << which_alternative) & 0xc))
        {
	  return UNITS64_LS;
        }
      else if (which_alternative == 4)
        {
	  return UNITS64_DL;
        }
      else if (which_alternative == 5)
        {
	  return UNITS64_S;
        }
      else
        {
	  return UNITS64_D_ADDR;
        }

    case 105:  /* xorsi3 */
    case 161:  /* andv2hi3 */
    case 162:  /* iorv2hi3 */
    case 163:  /* xorv2hi3 */
    case 164:  /* andv4qi3 */
    case 165:  /* iorv4qi3 */
    case 166:  /* xorv4qi3 */
    case 167:  /* addv2hi3 */
    case 168:  /* subv2hi3 */
    case 426:  /* *p xorsi3 */
    case 477:  /* *p andv2hi3 */
    case 478:  /* *p iorv2hi3 */
    case 479:  /* *p xorv2hi3 */
    case 480:  /* *p andv4qi3 */
    case 481:  /* *p iorv4qi3 */
    case 482:  /* *p xorv4qi3 */
    case 483:  /* *p addv2hi3 */
    case 484:  /* *p subv2hi3 */
      return UNITS64_DLS;

    case 174:  /* smaxhi3 */
    case 175:  /* smaxv2hi3 */
    case 176:  /* sminhi3 */
    case 177:  /* sminv2hi3 */
    case 490:  /* *p smaxhi3 */
    case 491:  /* *p smaxv2hi3 */
    case 492:  /* *p sminhi3 */
    case 493:  /* *p sminv2hi3 */
      return UNITS64_L;

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return UNITS64_UNKNOWN;

    }
}

enum attr_units62
get_attr_units62 (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case 425:  /* *p iorsi3 */
    case 424:  /* *p andsi3 */
    case 104:  /* iorsi3 */
    case 103:  /* andsi3 */
      extract_constrain_insn_cached (insn);
      if (((1 << which_alternative) & 0xf))
        {
	  return UNITS62_LS;
        }
      else
        {
	  return UNITS62_S;
        }

    case 416:  /* *p subsi3 */
    case 95:  /* subsi3 */
      extract_constrain_insn_cached (insn);
      if (((1 << which_alternative) & 0x3))
        {
	  return UNITS62_DLS;
        }
      else if (((1 << which_alternative) & 0xc))
        {
	  return UNITS62_LS;
        }
      else
        {
	  return UNITS62_L;
        }

    case 415:  /* *p addsi3 */
    case 94:  /* addsi3 */
      extract_constrain_insn_cached (insn);
      if (((1 << which_alternative) & 0x3))
        {
	  return UNITS62_DLS;
        }
      else if (((1 << which_alternative) & 0xfc))
        {
	  return UNITS62_LS;
        }
      else if (which_alternative == 8)
        {
	  return UNITS62_S;
        }
      else if (((1 << which_alternative) & 0x600))
        {
	  return UNITS62_D;
        }
      else if (((1 << which_alternative) & 0x1800))
        {
	  return UNITS62_UNKNOWN;
        }
      else
        {
	  return UNITS62_S;
        }

    case 354:  /* *p movv4qi_insn */
    case 353:  /* *p movv2hi_insn */
    case 352:  /* *p movsf_insn */
    case 351:  /* *p movsi_insn */
    case 15:  /* movv4qi_insn */
    case 14:  /* movv2hi_insn */
    case 13:  /* movsf_insn */
    case 12:  /* movsi_insn */
      extract_constrain_insn_cached (insn);
      if (((1 << which_alternative) & 0x3))
        {
	  return UNITS62_DLS;
        }
      else if (((1 << which_alternative) & 0xc))
        {
	  return UNITS62_LS;
        }
      else if (((1 << which_alternative) & 0x30))
        {
	  return UNITS62_S;
        }
      else if (((1 << which_alternative) & 0xc0))
        {
	  return UNITS62_D;
        }
      else if (which_alternative == 8)
        {
	  return UNITS62_UNKNOWN;
        }
      else
        {
	  return UNITS62_D_ADDR;
        }

    case 350:  /* *p movhi_insn */
    case 349:  /* *p movqi_insn */
    case 11:  /* movhi_insn */
    case 10:  /* movqi_insn */
      extract_constrain_insn_cached (insn);
      if (((1 << which_alternative) & 0x3))
        {
	  return UNITS62_DLS;
        }
      else if (((1 << which_alternative) & 0xc))
        {
	  return UNITS62_LS;
        }
      else if (((1 << which_alternative) & 0x30))
        {
	  return UNITS62_S;
        }
      else
        {
	  return UNITS62_D_ADDR;
        }

    case 105:  /* xorsi3 */
    case 161:  /* andv2hi3 */
    case 162:  /* iorv2hi3 */
    case 163:  /* xorv2hi3 */
    case 164:  /* andv4qi3 */
    case 165:  /* iorv4qi3 */
    case 166:  /* xorv4qi3 */
    case 426:  /* *p xorsi3 */
    case 477:  /* *p andv2hi3 */
    case 478:  /* *p iorv2hi3 */
    case 479:  /* *p xorv2hi3 */
    case 480:  /* *p andv4qi3 */
    case 481:  /* *p iorv4qi3 */
    case 482:  /* *p xorv4qi3 */
      return UNITS62_LS;

    case 167:  /* addv2hi3 */
    case 168:  /* subv2hi3 */
    case 483:  /* *p addv2hi3 */
    case 484:  /* *p subv2hi3 */
      return UNITS62_L;

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return UNITS62_UNKNOWN;

    }
}

int
eligible_for_delay (rtx_insn *delay_insn ATTRIBUTE_UNUSED, int slot, 
		   rtx_insn *candidate_insn, int flags ATTRIBUTE_UNUSED)
{
  rtx_insn *insn ATTRIBUTE_UNUSED;

  if (num_delay_slots (delay_insn) == 0)
    return 0;
  gcc_assert (slot < 0);

  if (!INSN_P (candidate_insn))
    return 0;

  insn = candidate_insn;
  switch (slot)
    {
    default:
      gcc_unreachable ();
    }
}

int
eligible_for_annul_true (rtx_insn *delay_insn ATTRIBUTE_UNUSED,
    int slot ATTRIBUTE_UNUSED,
    rtx_insn *candidate_insn ATTRIBUTE_UNUSED,
    int flags ATTRIBUTE_UNUSED)
{
  return 0;
}

int
eligible_for_annul_false (rtx_insn *delay_insn ATTRIBUTE_UNUSED,
    int slot ATTRIBUTE_UNUSED,
    rtx_insn *candidate_insn ATTRIBUTE_UNUSED,
    int flags ATTRIBUTE_UNUSED)
{
  return 0;
}

int
const_num_delay_slots (rtx_insn *insn)
{
  switch (recog_memoized (insn))
    {
    default:
      return 1;
    }
}

EXPORTED_CONST int length_unit_log = 0;
