/* Generated automatically by the program `genextract'
   from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "tm.h"
#include "rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "diagnostic-core.h"

/* This variable is used as the "location" of any missing operand
   whose numbers are skipped by a given pattern.  */
static rtx junk ATTRIBUTE_UNUSED;

void
insn_extract (rtx_insn *insn)
{
  rtx *ro = recog_data.operand;
  rtx **ro_loc = recog_data.operand_loc;
  rtx pat = PATTERN (insn);
  int i ATTRIBUTE_UNUSED; /* only for peepholes */

  if (flag_checking)
    {
      memset (ro, 0xab, sizeof (*ro) * MAX_RECOG_OPERANDS);
      memset (ro_loc, 0xab, sizeof (*ro_loc) * MAX_RECOG_OPERANDS);
    }

  switch (INSN_CODE (insn))
    {
    default:
      /* Control reaches here if insn_extract has been called with an
         unrecognizable insn (code -1), or an insn whose INSN_CODE
         corresponds to a DEFINE_EXPAND in the machine description;
         either way, a bug.  */
      if (INSN_CODE (insn) < 0)
        fatal_insn ("unrecognizable insn:", insn);
      else
        fatal_insn ("insn with invalid code number:", insn);

    case 304:  /* *h8300.md:4541 */
    case 303:  /* *h8300.md:4521 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 302:  /* *h8300.md:4511 */
    case 301:  /* *h8300.md:4501 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 296:  /* *iorsi3_ashift_16_ashift_24_mem */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0));
      break;

    case 294:  /* *iorsi2_and_1_lshiftrt_1 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 1), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 297:  /* *addsi3_shift */
    case 293:  /* *iorsi3_shift */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 292:  /* *iorsi3_and_lshiftrt_9_sb */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 290:  /* *iorsi3_zero_extract */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 2));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 289:  /* *iorsi3_and_lshiftrt */
    case 288:  /* *iorsi3_and_ashift */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 283:  /* *iorsi3_two_qi_zext */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0), 0));
      break;

    case 285:  /* *iorsi3_two_qi_sext */
    case 281:  /* *iorhi3_two_qi_mem */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0));
      break;

    case 277:  /* *ixorsi3_lshiftrt_16 */
    case 276:  /* *ixorsi3_ashift_16 */
    case 275:  /* *ixorsi3_zext_hi */
    case 274:  /* *ixorsi3_zext_qi */
    case 273:  /* *ixorhi3_zext */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 267:  /* *andsi3_lshiftrt_n_sb */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 266:  /* *andsi3_ashift_n_lower */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 263:  /* *extzv_16_8 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 260:  /* *insv_si_8_8_lshiftrt_8 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 258:  /* *insv_si_1_n_lshiftrt_16 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 0), 2));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 257:  /* *insv_si_1_n_lshiftrt */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 0), 2));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 255:  /* *condbclrreg */
    case 253:  /* *condbsetreg */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 1), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (pat, 1), 2);
      recog_data.dup_num[0] = 3;
      break;

    case 254:  /* *cmpcondbclrreg */
    case 252:  /* *cmpcondbsetreg */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[5] = *(ro_loc[5] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 1), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (pat, 1), 2);
      recog_data.dup_num[0] = 4;
      break;

    case 251:  /* *condbclr */
    case 249:  /* *condbset */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 1), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (pat, 1), 2);
      recog_data.dup_num[0] = 3;
      break;

    case 250:  /* *cmpcondbclr */
    case 248:  /* *cmpcondbset */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[5] = *(ro_loc[5] = &XEXP (XEXP (XEXP (pat, 1), 1), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (pat, 1), 2);
      recog_data.dup_num[0] = 4;
      break;

    case 247:  /* *bistz */
    case 246:  /* *bstz */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 0), 2));
      break;

    case 245:  /* *cmpstz */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 0), 2));
      ro[2] = *(ro_loc[2] = &XEXP (pat, 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 243:  /* bfst */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 0), 2));
      break;

    case 242:  /* bfld */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 2));
      break;

    case 241:  /* *h8300.md:3510 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 2));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XEXP (pat, 1), 1), 2));
      ro[5] = *(ro_loc[5] = &XEXP (pat, 1));
      break;

    case 240:  /* *h8300.md:3499 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 2));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      ro[4] = *(ro_loc[4] = &XEXP (pat, 1));
      break;

    case 256:  /* *insv_si_1_n */
    case 239:  /* *h8300.md:3431 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 0), 2));
      ro[2] = *(ro_loc[2] = &XEXP (pat, 1));
      break;

    case 238:  /* *extzv_1_r_inv_h8300hs */
    case 237:  /* *extzv_1_r_inv_h8300 */
    case 234:  /* *h8300.md:3300 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 2));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 236:  /* *extzv_1_r_h8300hs */
    case 235:  /* *extzv_1_r_h8300 */
    case 233:  /* *h8300.md:3287 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 2));
      break;

    case 229:  /* *shiftsi */
    case 226:  /* *shifthi */
    case 223:  /* *shiftqi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 204:  /* return_h8sx */
      ro[0] = *(ro_loc[0] = &PATTERN (insn));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 1));
      break;

    case 203:  /* stm_h8300sx */
    case 202:  /* ldm_h8300sx */
      ro[0] = *(ro_loc[0] = &PATTERN (insn));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 0), 1));
      break;

    case 206:  /* monitor_prologue */
    case 205:  /* *return_1 */
    case 201:  /* nop */
      break;

    case 195:  /* *tablejump_h8300hs_normal */
    case 194:  /* *tablejump_h8300hs_advanced */
    case 193:  /* *tablejump_h8300 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 0), 0));
      break;

    case 191:  /* *brabs */
    case 190:  /* *brabc */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 2));
      break;

    case 189:  /* branch_false */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 2), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 188:  /* branch_true */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 264:  /* *extzv_8_23 */
    case 262:  /* *extzv_8_16 */
    case 261:  /* *extzv_8_8 */
    case 220:  /* *extendhisi2_h8300hs */
    case 219:  /* *extendhisi2_h8300 */
    case 218:  /* *extendqisi2_h8sx */
    case 217:  /* *extendqisi2_h8300hs */
    case 216:  /* *extendqisi2_h8300 */
    case 215:  /* *extendqihi2_h8300hs */
    case 214:  /* *extendqihi2_h8300 */
    case 213:  /* *zero_extendhisi2_h8300hs */
    case 212:  /* *zero_extendhisi2_h8300 */
    case 211:  /* *zero_extendqisi2_h8sx */
    case 210:  /* *zero_extendqisi2_h8300hs */
    case 209:  /* *zero_extendqisi2_h8300 */
    case 208:  /* *zero_extendqihi2_h8300hs */
    case 207:  /* *zero_extendqihi2_h8300 */
    case 187:  /* *one_cmplsi2_h8300hs */
    case 186:  /* *one_cmplsi2_h8300 */
    case 185:  /* *one_cmplhi2_h8300hs */
    case 184:  /* *one_cmplhi2_h8300 */
    case 183:  /* *one_cmplqi2 */
    case 182:  /* *abssf2_h8300hs */
    case 181:  /* *abssf2_h8300 */
    case 180:  /* *negsf2_h8300hs */
    case 179:  /* *negsf2_h8300 */
    case 178:  /* *negsi2_h8300hs */
    case 177:  /* *neghi2_h8300hs */
    case 176:  /* *negqi2 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 228:  /* *h8300.md:3111 */
    case 227:  /* *h8300.md:3099 */
    case 225:  /* *h8300.md:3040 */
    case 224:  /* *h8300.md:3028 */
    case 222:  /* *h8300.md:2969 */
    case 221:  /* *h8300.md:2957 */
    case 175:  /* *logicalsi3 */
    case 174:  /* *logicalhi3 */
    case 173:  /* *logicalsi3_sn */
    case 172:  /* *logicalhi3_sn */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (pat, 1));
      break;

    case 165:  /* *andorsi3_shift_8 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      break;

    case 164:  /* *andorsi3 */
    case 163:  /* *andorhi3 */
    case 162:  /* *andorqi3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 157:  /* divmodhi4 */
    case 156:  /* udivmodhi4 */
    case 155:  /* divmodqi4 */
    case 154:  /* udivmodqi4 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 1), 0);
      recog_data.dup_num[1] = 2;
      break;

    case 149:  /* *h8300.md:1564 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 148:  /* *h8300.md:1552 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0), 0));
      break;

    case 147:  /* umulsi3_highpart */
    case 146:  /* smulsi3_highpart */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1), 0));
      break;

    case 295:  /* *iorsi3_ashift_16_ashift_24 */
    case 286:  /* *iorsi3_w */
    case 284:  /* *iorsi3_e2f */
    case 282:  /* *iorsi3_two_hi */
    case 280:  /* *iorhi3_two_qi */
    case 270:  /* *addsi3_lshiftrt_16_zexthi */
    case 143:  /* *umulhisi3 */
    case 141:  /* *umulqihi3 */
    case 139:  /* *mulhisi3 */
    case 137:  /* *mulqihi3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 130:  /* *addsi3_incdec */
    case 126:  /* *addhi3_incdec */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (pat, 1), 0, 1));
      break;

    case 232:  /* rotlsi3_1 */
    case 231:  /* rotlhi3_1 */
    case 230:  /* rotlqi3_1 */
    case 200:  /* call_value */
    case 171:  /* xorqi3_1 */
    case 170:  /* bnothi_msx */
    case 169:  /* bnotqi_msx */
    case 168:  /* iorqi3_1 */
    case 167:  /* bsethi_msx */
    case 166:  /* bsetqi_msx */
    case 161:  /* andqi3_1 */
    case 160:  /* *andqi3_2 */
    case 159:  /* bclrhi_msx */
    case 158:  /* bclrqi_msx */
    case 153:  /* divsi3 */
    case 152:  /* udivsi3 */
    case 151:  /* divhi3 */
    case 150:  /* udivhi3 */
    case 145:  /* mulsi3 */
    case 144:  /* mulhi3 */
    case 135:  /* *subsi3_h8300hs */
    case 134:  /* *subsi3_h8300 */
    case 133:  /* *subhi3_h8300hs */
    case 132:  /* *subhi3_h8300 */
    case 131:  /* *subqi3 */
    case 129:  /* *addsi_h8300hs */
    case 128:  /* *addsi_h8300 */
    case 127:  /* *addhi3_h8sx */
    case 125:  /* *addhi3_h8300hs */
    case 124:  /* *addhi3_h8300 */
    case 123:  /* *addqi3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 122:  /* cmpsi */
    case 121:  /* *cmphi_h8300hs_znvc */
    case 120:  /* *cmphi_h8300_znvc */
    case 119:  /* *cmpqi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 118:  /* *tstsi_upper */
    case 116:  /* *tsthi_upper */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 192:  /* jump */
    case 117:  /* *tstsi */
    case 115:  /* *tsthi */
    case 114:  /* *tstqi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 113:  /* *tstsi_variable_bit_qi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 2), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 112:  /* *tstsi_variable_bit */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 2), 0));
      break;

    case 111:  /* *tstsi_upper_bit */
    case 109:  /* *tst_extzv_1_n */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 2));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 110:  /* *h8300.md:929 */
    case 108:  /* *h8300.md:893 */
    case 107:  /* *h8300.md:882 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 2));
      break;

    case 198:  /* *indirect_jump_h8300hs_normal */
    case 197:  /* *indirect_jump_h8300hs_advanced */
    case 196:  /* *indirect_jump_h8300 */
    case 106:  /* *pushhi1_h8300hs_si */
    case 105:  /* *pushhi1_h8300hs_hi */
    case 104:  /* *pushqi1_h8300hs_si */
    case 103:  /* *pushqi1_h8300hs_hi */
    case 102:  /* *pushqi1_h8300 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 1));
      break;

    case 97:  /* *mova.md:827 */
    case 91:  /* *mova.md:766 */
    case 85:  /* *mova.md:705 */
    case 79:  /* *mova.md:644 */
    case 68:  /* *mova.md:534 */
    case 62:  /* *mova.md:473 */
    case 56:  /* *mova.md:412 */
    case 50:  /* *mova.md:351 */
    case 43:  /* *mova.md:281 */
    case 37:  /* *mova.md:220 */
    case 31:  /* *mova.md:159 */
    case 25:  /* *mova.md:98 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 96:  /* *mova.md:817 */
    case 90:  /* *mova.md:756 */
    case 84:  /* *mova.md:695 */
    case 78:  /* *mova.md:634 */
    case 67:  /* *mova.md:524 */
    case 61:  /* *mova.md:463 */
    case 55:  /* *mova.md:402 */
    case 49:  /* *mova.md:341 */
    case 42:  /* *mova.md:271 */
    case 36:  /* *mova.md:210 */
    case 30:  /* *mova.md:149 */
    case 24:  /* *mova.md:88 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      break;

    case 291:  /* *iorsi3_and_lshiftrt_n_sb */
    case 272:  /* *addsi3_and_not_r_1 */
    case 99:  /* *mova.md:848 */
    case 95:  /* *mova.md:807 */
    case 93:  /* *mova.md:787 */
    case 89:  /* *mova.md:746 */
    case 87:  /* *mova.md:726 */
    case 83:  /* *mova.md:685 */
    case 81:  /* *mova.md:665 */
    case 77:  /* *mova.md:624 */
    case 70:  /* *mova.md:555 */
    case 66:  /* *mova.md:514 */
    case 64:  /* *mova.md:494 */
    case 60:  /* *mova.md:453 */
    case 58:  /* *mova.md:433 */
    case 54:  /* *mova.md:392 */
    case 52:  /* *mova.md:372 */
    case 48:  /* *mova.md:331 */
    case 45:  /* *mova.md:302 */
    case 41:  /* *mova.md:261 */
    case 39:  /* *mova.md:241 */
    case 35:  /* *mova.md:200 */
    case 33:  /* *mova.md:180 */
    case 29:  /* *mova.md:139 */
    case 27:  /* *mova.md:119 */
    case 23:  /* *mova.md:78 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 300:  /* *h8300.md:4492 */
    case 299:  /* *h8300.md:4481 */
    case 298:  /* *ashiftsi_sextqi_7 */
    case 268:  /* *andsi3_lshiftrt_9_sb */
    case 265:  /* *twoshifts_l16_r1 */
    case 98:  /* *mova.md:838 */
    case 94:  /* *mova.md:798 */
    case 92:  /* *mova.md:777 */
    case 88:  /* *mova.md:737 */
    case 86:  /* *mova.md:716 */
    case 82:  /* *mova.md:676 */
    case 80:  /* *mova.md:655 */
    case 76:  /* *mova.md:615 */
    case 69:  /* *mova.md:545 */
    case 65:  /* *mova.md:505 */
    case 63:  /* *mova.md:484 */
    case 59:  /* *mova.md:444 */
    case 57:  /* *mova.md:423 */
    case 53:  /* *mova.md:383 */
    case 51:  /* *mova.md:362 */
    case 47:  /* *mova.md:322 */
    case 44:  /* *mova.md:292 */
    case 40:  /* *mova.md:252 */
    case 38:  /* *mova.md:231 */
    case 34:  /* *mova.md:191 */
    case 32:  /* *mova.md:170 */
    case 28:  /* *mova.md:130 */
    case 26:  /* *mova.md:109 */
    case 22:  /* *mova.md:69 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 287:  /* *iorsi3_ashift_31 */
    case 279:  /* *iorhi3_lshiftrt_8 */
    case 278:  /* *iorhi3_ashift_8 */
    case 271:  /* *addsi3_and_r_1 */
    case 269:  /* *addsi3_upper */
    case 142:  /* *umulhisi3_const */
    case 140:  /* *umulqihi3_const */
    case 138:  /* *mulhisi3_const */
    case 136:  /* *mulqihi3_const */
    case 75:  /* *mova.md:606 */
    case 74:  /* *mova.md:596 */
    case 73:  /* *mova.md:586 */
    case 72:  /* *mova.md:576 */
    case 71:  /* *mova.md:566 */
    case 46:  /* *mova.md:313 */
    case 21:  /* *mova.md:60 */
    case 20:  /* *mova.md:50 */
    case 19:  /* *mova.md:40 */
    case 18:  /* *mova.md:30 */
    case 17:  /* *mova.md:20 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 16:  /* stpcpy_internal */
    case 15:  /* stpcpy_internal_normal */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 2), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 3), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0), 0));
      break;

    case 14:  /* movmd_internal */
    case 13:  /* movmd_internal_normal */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 2), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 3), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 4), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[5] = *(ro_loc[5] = &XVECEXP (XVECEXP (pat, 0, 1), 0, 0));
      ro[6] = *(ro_loc[6] = &XVECEXP (XVECEXP (pat, 0, 1), 0, 1));
      break;

    case 259:  /* *insv_si_8_8 */
    case 8:  /* movstricthi */
    case 4:  /* movstrictqi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      break;

    case 244:  /* *bstzhireg */
    case 199:  /* call */
    case 101:  /* *movsf_h8300hs */
    case 100:  /* *movsf_h8300 */
    case 12:  /* *movsf_h8sx */
    case 11:  /* *movsi_h8sx */
    case 10:  /* *movsi_h8300hs */
    case 9:  /* *movsi_h8300 */
    case 7:  /* *movhi_h8sx */
    case 6:  /* *movhi_h8300hs */
    case 5:  /* *movhi_h8300 */
    case 3:  /* *movqi_h8sx */
    case 2:  /* *movqi_h8300hs */
    case 1:  /* *movqi_h8300 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      break;

    }
}
