/* Generated automatically by the program `genextract'
   from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "tm.h"
#include "rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "diagnostic-core.h"

/* This variable is used as the "location" of any missing operand
   whose numbers are skipped by a given pattern.  */
static rtx junk ATTRIBUTE_UNUSED;

void
insn_extract (rtx_insn *insn)
{
  rtx *ro = recog_data.operand;
  rtx **ro_loc = recog_data.operand_loc;
  rtx pat = PATTERN (insn);
  int i ATTRIBUTE_UNUSED; /* only for peepholes */

  if (flag_checking)
    {
      memset (ro, 0xab, sizeof (*ro) * MAX_RECOG_OPERANDS);
      memset (ro_loc, 0xab, sizeof (*ro_loc) * MAX_RECOG_OPERANDS);
    }

  switch (INSN_CODE (insn))
    {
    default:
      /* Control reaches here if insn_extract has been called with an
         unrecognizable insn (code -1), or an insn whose INSN_CODE
         corresponds to a DEFINE_EXPAND in the machine description;
         either way, a bug.  */
      if (INSN_CODE (insn) < 0)
        fatal_insn ("unrecognizable insn:", insn);
      else
        fatal_insn ("insn with invalid code number:", insn);

    case 587:
    case 586:
    case 585:
    case 584:
      for (i = XVECLEN (pat, 0) - 1; i >= 0; i--)
          ro[i] = *(ro_loc[i] = &XVECEXP (pat, 0, i));
      break;

    case 472:  /* atomic_test_and_set_1 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0);
      recog_data.dup_num[1] = 1;
      break;

    case 471:  /* atomic_compare_and_swapsi_1 */
    case 470:  /* atomic_compare_and_swaphi_1 */
    case 469:  /* atomic_compare_and_swapqi_1 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 2), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 1));
      ro[4] = *(ro_loc[4] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 2));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (XVECEXP (pat, 0, 2), 1), 0, 2);
      recog_data.dup_num[0] = 4;
      recog_data.dup_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 2), 1), 0, 1);
      recog_data.dup_num[1] = 3;
      recog_data.dup_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 2), 1), 0, 0);
      recog_data.dup_num[2] = 2;
      recog_data.dup_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[3] = 2;
      recog_data.dup_loc[4] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 2);
      recog_data.dup_num[4] = 4;
      recog_data.dup_loc[5] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 1);
      recog_data.dup_num[5] = 3;
      recog_data.dup_loc[6] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0);
      recog_data.dup_num[6] = 2;
      break;

    case 467:  /* stack_tie */
      ro[0] = *(ro_loc[0] = &XVECEXP (XEXP (pat, 1), 0, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 1));
      break;

    case 464:  /* cosxf2 */
    case 463:  /* cosdf2 */
    case 462:  /* cossf2 */
    case 461:  /* sinxf2 */
    case 460:  /* sindf2 */
    case 459:  /* sinsf2 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 0));
      break;

    case 453:  /* indirect_jump */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 1));
      break;

    case 451:  /* *unlink */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[0] = 0;
      recog_data.dup_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0);
      recog_data.dup_num[1] = 0;
      break;

    case 450:  /* *link */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 2), 1), 1));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 1);
      recog_data.dup_num[0] = 0;
      break;

    case 449:  /* *m68k_load_multiple_automod */
    case 447:  /* *m68k_store_multiple_automod */
      ro[0] = *(ro_loc[0] = &PATTERN (insn));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      break;

    case 448:  /* *m68k_load_multiple */
    case 446:  /* *m68k_store_multiple */
      ro[0] = *(ro_loc[0] = &PATTERN (insn));
      ro[1] = *(ro_loc[1] = &XVECEXP (pat, 0, 0));
      break;

    case 468:  /* ib */
    case 465:  /* trap */
    case 445:  /* *return */
    case 444:  /* nop */
    case 443:  /* blockage */
      break;

    case 436:  /* *dbge_si */
    case 435:  /* *dbge_hi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 0;
      recog_data.dup_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[1] = 0;
      break;

    case 434:  /* *dbne_si */
    case 433:  /* *dbne_hi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 0;
      recog_data.dup_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[1] = 0;
      break;

    case 432:  /* *tablejump_pcrel_hi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 0), 0));
      break;

    case 431:  /* *tablejump_pcrel_si */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 0), 0));
      break;

    case 430:  /* *tablejump_internal */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 0), 0));
      break;

    case 428:  /* *bltgt_rev */
    case 427:  /* *bunlt_rev */
    case 426:  /* *bunle_rev */
    case 425:  /* *bungt_rev */
    case 424:  /* *bunge_rev */
    case 423:  /* *buneq_rev */
    case 422:  /* *bunordered_rev */
    case 421:  /* *bordered_rev */
    case 420:  /* *bleu_rev */
    case 419:  /* *ble_rev */
    case 418:  /* *bgeu_rev */
    case 417:  /* *bge_rev */
    case 416:  /* *bltu_rev */
    case 415:  /* *blt_rev */
    case 414:  /* *bgtu_rev */
    case 413:  /* *bgt_rev */
    case 412:  /* *bne_rev */
    case 411:  /* *beq_rev */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 2), 0));
      break;

    case 410:  /* bltgt */
    case 409:  /* bunlt */
    case 408:  /* bunle */
    case 407:  /* bungt */
    case 406:  /* bunge */
    case 405:  /* buneq */
    case 404:  /* bunordered */
    case 403:  /* bordered */
    case 402:  /* bleu */
    case 401:  /* ble */
    case 400:  /* bgeu */
    case 399:  /* bge */
    case 398:  /* bltu */
    case 397:  /* blt */
    case 396:  /* bgtu */
    case 395:  /* bgt */
    case 394:  /* bne */
    case 393:  /* beq */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 392:  /* blt0_di */
    case 391:  /* bge0_di */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 390:  /* bne0_di */
    case 389:  /* beq0_di */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 366:  /* scc_di_5200 */
    case 365:  /* scc_di */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 364:  /* scc0_di_5200 */
    case 363:  /* scc0_di */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 362:  /* *tst_bftst_reg */
    case 361:  /* *tst_bftst_mem */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 2));
      break;

    case 359:  /* *insv_bfset_reg */
    case 358:  /* *insv_bfclr_reg */
    case 354:  /* *insv_bfset_mem */
    case 353:  /* *insv_bfclr_mem */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 0), 2));
      break;

    case 352:  /* *insv_bfchg_mem */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 0), 2));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0);
      recog_data.dup_num[0] = 0;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 1);
      recog_data.dup_num[1] = 1;
      recog_data.dup_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 2);
      recog_data.dup_num[2] = 2;
      break;

    case 357:  /* *extv_bfextu_reg */
    case 356:  /* *extv_bfexts_reg */
    case 351:  /* *extzv_bfextu_mem */
    case 350:  /* *extv_bfexts_mem */
    case 349:  /* *extv_8_16_reg */
    case 347:  /* *extzv_8_16_reg */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 2));
      break;

    case 348:  /* *extv_32_mem */
    case 346:  /* *extzv_32_mem */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 2));
      break;

    case 360:  /* *insv_bfins_reg */
    case 355:  /* *insv_bfins_mem */
    case 345:  /* *insv_8_16_reg */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 0), 2));
      ro[3] = *(ro_loc[3] = &XEXP (pat, 1));
      break;

    case 344:  /* *insv_32_mem */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 0), 2));
      ro[2] = *(ro_loc[2] = &XEXP (pat, 1));
      break;

    case 343:  /* *bclrmemqi_ext */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 0), 2), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 0), 2), 1));
      break;

    case 342:  /* bclrmemqi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 0), 2), 1));
      break;

    case 341:  /* *bclrdreg */
    case 340:  /* *bchgdreg */
    case 339:  /* *bsetdreg */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 338:  /* *bsetmemqi_ext */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (pat, 1), 1);
      recog_data.dup_num[0] = 0;
      break;

    case 337:  /* bsetmemqi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (pat, 1), 1);
      recog_data.dup_num[0] = 0;
      break;

    case 313:  /* subreg1lshrdi_const32 */
    case 302:  /* subregsi1ashrdi_const32 */
    case 301:  /* subreghi1ashrdi_const32 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 288:  /* ashldi_sexthi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 287:  /* ashldi_extsi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 286:  /* *m68k.md:4342 */
    case 284:  /* *m68k.md:4330 */
    case 263:  /* *m68k.md:3983 */
    case 261:  /* *m68k.md:3971 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (pat, 1), 0);
      recog_data.dup_num[0] = 0;
      break;

    case 227:  /* udivmodhi4 */
    case 226:  /* divmodhi4 */
    case 225:  /* *m68k.md:3542 */
    case 224:  /* *m68k.md:3524 */
    case 223:  /* *m68k.md:3500 */
    case 222:  /* *m68k.md:3482 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[1] = 2;
      break;

    case 193:  /* const_smulsi3_highpart */
    case 191:  /* const_umulsi3_highpart */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 1));
      break;

    case 192:  /* *m68k.md:3277 */
    case 190:  /* *m68k.md:3234 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 1), 0));
      break;

    case 189:  /* *m68k.md:3198 */
    case 187:  /* *m68k.md:3163 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0), 1);
      recog_data.dup_num[1] = 2;
      break;

    case 188:  /* *m68k.md:3187 */
    case 186:  /* *m68k.md:3148 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0), 1), 0);
      recog_data.dup_num[1] = 2;
      break;

    case 246:  /* iorsi_zexthi_ashl16 */
    case 184:  /* umulhisi3 */
    case 180:  /* mulhisi3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 157:  /* subdi_dishl32 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (pat, 1), 0);
      recog_data.dup_num[0] = 0;
      break;

    case 156:  /* subdi_sexthishl32 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 202:  /* mulxf3_floatqi_68881 */
    case 201:  /* muldf3_floatqi_68881 */
    case 200:  /* mulsf3_floatqi_68881 */
    case 199:  /* mulxf3_floathi_68881 */
    case 198:  /* muldf3_floathi_68881 */
    case 197:  /* mulsf3_floathi_68881 */
    case 196:  /* mulxf3_floatsi_68881 */
    case 195:  /* muldf3_floatsi_68881 */
    case 194:  /* mulsf3_floatsi_68881 */
    case 150:  /* addxf3_floatqi_68881 */
    case 149:  /* adddf3_floatqi_68881 */
    case 148:  /* addsf3_floatqi_68881 */
    case 147:  /* addxf3_floathi_68881 */
    case 146:  /* adddf3_floathi_68881 */
    case 145:  /* addsf3_floathi_68881 */
    case 144:  /* addxf3_floatsi_68881 */
    case 143:  /* adddf3_floatsi_68881 */
    case 142:  /* addsf3_floatsi_68881 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 255:  /* *m68k.md:3892 */
    case 252:  /* *m68k.md:3871 */
    case 245:  /* *m68k.md:3784 */
    case 242:  /* *m68k.md:3763 */
    case 236:  /* *m68k.md:3690 */
    case 233:  /* *m68k.md:3669 */
    case 141:  /* *m68k.md:2737 */
    case 138:  /* *m68k.md:2642 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (pat, 1), 1);
      recog_data.dup_num[0] = 0;
      break;

    case 336:  /* *m68k.md:5293 */
    case 334:  /* rotrhi_lowpart */
    case 331:  /* *rotlqi3_lowpart */
    case 329:  /* *rotlhi3_lowpart */
    case 325:  /* *m68k.md:5171 */
    case 323:  /* *m68k.md:5157 */
    case 312:  /* *m68k.md:4872 */
    case 310:  /* *m68k.md:4858 */
    case 298:  /* *m68k.md:4627 */
    case 296:  /* *m68k.md:4613 */
    case 254:  /* *m68k.md:3885 */
    case 251:  /* *m68k.md:3864 */
    case 244:  /* *m68k.md:3777 */
    case 241:  /* *m68k.md:3756 */
    case 235:  /* *m68k.md:3683 */
    case 232:  /* *m68k.md:3662 */
    case 164:  /* *m68k.md:2977 */
    case 162:  /* *m68k.md:2963 */
    case 140:  /* *m68k.md:2714 */
    case 137:  /* *m68k.md:2593 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (pat, 1), 0);
      recog_data.dup_num[0] = 0;
      break;

    case 216:  /* divxf3_floatqi_68881 */
    case 215:  /* divdf3_floatqi_68881 */
    case 214:  /* divsf3_floatqi_68881 */
    case 213:  /* divxf3_floathi_68881 */
    case 212:  /* divdf3_floathi_68881 */
    case 211:  /* divsf3_floathi_68881 */
    case 210:  /* divxf3_floatsi_68881 */
    case 209:  /* divdf3_floatsi_68881 */
    case 208:  /* divsf3_floatsi_68881 */
    case 173:  /* subxf3_floatqi_68881 */
    case 172:  /* subdf3_floatqi_68881 */
    case 171:  /* subsf3_floatqi_68881 */
    case 170:  /* subxf3_floathi_68881 */
    case 169:  /* subdf3_floathi_68881 */
    case 168:  /* subsf3_floathi_68881 */
    case 167:  /* subxf3_floatsi_68881 */
    case 166:  /* subdf3_floatsi_68881 */
    case 165:  /* subsf3_floatsi_68881 */
    case 160:  /* *m68k.md:2948 */
    case 135:  /* *m68k.md:2530 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 335:  /* rotrqi3 */
    case 333:  /* rotrhi3 */
    case 332:  /* rotrsi3 */
    case 330:  /* rotlqi3 */
    case 328:  /* rotlhi3 */
    case 327:  /* rotlsi3 */
    case 324:  /* lshrqi3 */
    case 322:  /* lshrhi3 */
    case 321:  /* lshrsi3 */
    case 320:  /* lshrsi_17_24 */
    case 317:  /* *lshrdi3_const */
    case 311:  /* ashrqi3 */
    case 309:  /* ashrhi3 */
    case 308:  /* ashrsi3 */
    case 306:  /* ashrdi_const */
    case 300:  /* *m68k.md:4645 */
    case 297:  /* ashlqi3 */
    case 295:  /* ashlhi3 */
    case 294:  /* ashlsi3 */
    case 293:  /* ashlsi_17_24 */
    case 291:  /* *ashldi3 */
    case 253:  /* xorqi3 */
    case 250:  /* xorhi3 */
    case 249:  /* xorsi3_5200 */
    case 248:  /* xorsi3_internal */
    case 243:  /* iorqi3 */
    case 240:  /* iorhi3 */
    case 239:  /* iorsi3_5200 */
    case 238:  /* iorsi3_internal */
    case 234:  /* andqi3 */
    case 231:  /* andhi3 */
    case 230:  /* andsi3_5200 */
    case 229:  /* andsi3_internal */
    case 228:  /* *andsi3_split */
    case 221:  /* divdf3_cf */
    case 220:  /* divsf3_cf */
    case 219:  /* divxf3_68881 */
    case 218:  /* divdf3_68881 */
    case 217:  /* divsf3_68881 */
    case 207:  /* fmuldf3_cf */
    case 206:  /* fmulsf3_cf */
    case 205:  /* mulxf3_68881 */
    case 204:  /* mulsf_68881 */
    case 203:  /* muldf_68881 */
    case 183:  /* *mulsi3_cf */
    case 182:  /* *mulsi3_68020 */
    case 179:  /* mulhi3 */
    case 178:  /* subdf3_cf */
    case 177:  /* subsf3_cf */
    case 176:  /* subxf3_68881 */
    case 175:  /* subdf3_68881 */
    case 174:  /* subsf3_68881 */
    case 163:  /* subqi3 */
    case 161:  /* subhi3 */
    case 159:  /* subsi3 */
    case 155:  /* adddf3_cf */
    case 154:  /* addsf3_cf */
    case 153:  /* addxf3_68881 */
    case 152:  /* adddf3_68881 */
    case 151:  /* addsf3_68881 */
    case 139:  /* addqi3 */
    case 136:  /* addhi3 */
    case 134:  /* *addsi3_5200 */
    case 133:  /* *addsi3_internal */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 132:  /* addsi_lshrsi_31 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (pat, 1), 1);
      recog_data.dup_num[0] = 1;
      break;

    case 158:  /* subdi3 */
    case 131:  /* adddi3 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 442:  /* *symbolic_call_value_bsr */
    case 441:  /* *symbolic_call_value_jsr */
    case 440:  /* *non_symbolic_call_value */
    case 438:  /* *sibcall_value */
    case 247:  /* iorsi_zext */
    case 237:  /* iordi_zext */
    case 185:  /* *mulhisisi3_z */
    case 181:  /* *mulhisisi3_s */
    case 130:  /* adddi_dishl32 */
    case 129:  /* *adddi_dilshr32_cf */
    case 128:  /* *adddi_dilshr32 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 127:  /* adddi_sexthishl32 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 126:  /* adddi_lshrdi_63 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1);
      recog_data.dup_num[0] = 1;
      break;

    case 105:  /* fix_truncdfqi2 */
    case 104:  /* fix_truncdfhi2 */
    case 103:  /* fix_truncdfsi2 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 2), 0));
      break;

    case 77:  /* extendplussidi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 305:  /* *ashrdi_const32_mem */
    case 76:  /* extendsidi2 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 458:  /* truncxfsf2 */
    case 457:  /* truncxfdf2 */
    case 456:  /* extenddfxf2 */
    case 455:  /* extendsfxf2 */
    case 326:  /* rotlsi_16 */
    case 319:  /* lshrsi_16 */
    case 318:  /* lshrsi_31 */
    case 316:  /* *lshrdi_const63 */
    case 315:  /* *lshrdi_const32 */
    case 314:  /* *lshrdi3_const1 */
    case 307:  /* ashrsi_31 */
    case 304:  /* *ashrdi_const32 */
    case 303:  /* *ashrdi3_const1 */
    case 299:  /* ashrsi_16 */
    case 292:  /* ashlsi_16 */
    case 290:  /* *ashldi3_const32 */
    case 289:  /* *ashldi3_const1 */
    case 285:  /* one_cmplqi2 */
    case 283:  /* one_cmplhi2 */
    case 282:  /* one_cmplsi2_5200 */
    case 281:  /* one_cmplsi2_internal */
    case 280:  /* *clzsi2_cf */
    case 279:  /* *clzsi2_68k */
    case 278:  /* absdf2_cf */
    case 277:  /* abssf2_cf */
    case 276:  /* absxf2_68881 */
    case 275:  /* absdf2_68881 */
    case 274:  /* abssf2_68881 */
    case 273:  /* sqrtdf2_cf */
    case 272:  /* sqrtsf2_cf */
    case 271:  /* sqrtxf2_68881 */
    case 270:  /* sqrtdf2_68881 */
    case 269:  /* sqrtsf2_68881 */
    case 268:  /* negdf2_cf */
    case 267:  /* negsf2_cf */
    case 266:  /* negxf2_68881 */
    case 265:  /* negdf2_68881 */
    case 264:  /* negsf2_68881 */
    case 262:  /* negqi2 */
    case 260:  /* neghi2 */
    case 259:  /* negsi2_5200 */
    case 258:  /* negsi2_internal */
    case 257:  /* negdi2_5200 */
    case 256:  /* negdi2_internal */
    case 125:  /* fixdfsi2_cf */
    case 124:  /* fixsfsi2_cf */
    case 123:  /* fixxfsi2_68881 */
    case 122:  /* fixdfsi2_68881 */
    case 121:  /* fixsfsi2_68881 */
    case 120:  /* fixdfhi2_cf */
    case 119:  /* fixsfhi2_cf */
    case 118:  /* fixxfhi2_68881 */
    case 117:  /* fixdfhi2_68881 */
    case 116:  /* fixsfhi2_68881 */
    case 115:  /* fixdfqi2_cf */
    case 114:  /* fixsfqi2_cf */
    case 113:  /* fixxfqi2_68881 */
    case 112:  /* fixdfqi2_68881 */
    case 111:  /* fixsfqi2_68881 */
    case 110:  /* ftruncdf2_cf */
    case 109:  /* ftruncsf2_cf */
    case 108:  /* ftruncxf2_68881 */
    case 107:  /* ftruncdf2_68881 */
    case 106:  /* ftruncsf2_68881 */
    case 102:  /* floatqidf2_cf */
    case 101:  /* floatqisf2_cf */
    case 100:  /* floatqixf2_68881 */
    case 99:  /* floatqidf2_68881 */
    case 98:  /* floatqisf2_68881 */
    case 97:  /* floathidf2_cf */
    case 96:  /* floathisf2_cf */
    case 95:  /* floathixf2_68881 */
    case 94:  /* floathidf2_68881 */
    case 93:  /* floathisf2_68881 */
    case 92:  /* floatsidf2_cf */
    case 91:  /* floatsisf2_cf */
    case 90:  /* floatsixf2_68881 */
    case 89:  /* floatsidf2_68881 */
    case 88:  /* floatsisf2_68881 */
    case 87:  /* *truncdfsf2_68881 */
    case 86:  /* truncdfsf2_cf */
    case 85:  /* *m68k.md:2028 */
    case 84:  /* extendsfdf2_cf */
    case 83:  /* *m68k.md:1968 */
    case 82:  /* *68k_extendqisi2 */
    case 81:  /* *cfv4_extendqisi2 */
    case 80:  /* extendqihi2 */
    case 79:  /* *68k_extendhisi2 */
    case 78:  /* *cfv4_extendhisi2 */
    case 75:  /* extendhidi2 */
    case 74:  /* extendqidi2 */
    case 73:  /* zero_extendqisi2 */
    case 72:  /* *zero_extendqisi2_cfv4 */
    case 71:  /* *zero_extendqihi2 */
    case 70:  /* zero_extendhisi2 */
    case 69:  /* *zero_extendhisi2_cf */
    case 68:  /* *zero_extendsidi2 */
    case 67:  /* zero_extendhidi2 */
    case 66:  /* zero_extendqidi2 */
    case 65:  /* *zero_extend_dec */
    case 64:  /* *zero_extend_inc */
    case 63:  /* truncsihi2 */
    case 62:  /* trunchiqi2 */
    case 61:  /* truncsiqi2 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 439:  /* *call */
    case 437:  /* *sibcall */
    case 48:  /* *movstrictqi_cf */
    case 47:  /* *m68k.md:1105 */
    case 44:  /* *m68k.md:1075 */
    case 43:  /* *m68k.md:1069 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      break;

    case 452:  /* load_got */
    case 388:  /* *fsole_1 */
    case 387:  /* *fsolt_1 */
    case 386:  /* *fsoge_1 */
    case 385:  /* *fsogt_1 */
    case 384:  /* *sltgt_1 */
    case 383:  /* *sunlt_1 */
    case 382:  /* *sunle_1 */
    case 381:  /* *sungt_1 */
    case 380:  /* *sunge_1 */
    case 379:  /* *suneq_1 */
    case 378:  /* *sunordered_1 */
    case 377:  /* *sordered_1 */
    case 376:  /* *sls */
    case 375:  /* *m68k.md:5891 */
    case 374:  /* *scc */
    case 373:  /* *m68k.md:5872 */
    case 372:  /* *m68k.md:5863 */
    case 371:  /* *m68k.md:5854 */
    case 370:  /* *m68k.md:5845 */
    case 369:  /* *m68k.md:5836 */
    case 368:  /* *m68k.md:5827 */
    case 367:  /* *m68k.md:5818 */
    case 36:  /* *movsi_const0 */
    case 35:  /* *movsi_const0_68040_60 */
    case 34:  /* *movsi_const0_68000_10 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      break;

    case 32:  /* *m68k.md:787 */
    case 31:  /* *m68k.md:763 */
    case 30:  /* *m68k.md:750 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 2));
      break;

    case 29:  /* *m68k.md:733 */
    case 28:  /* *m68k.md:718 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 2), 1), 0));
      break;

    case 27:  /* *m68k.md:701 */
    case 26:  /* *m68k.md:688 */
    case 25:  /* *m68k.md:672 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 2), 1));
      break;

    case 14:  /* cmpdi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 13:  /* *cmpdi_internal */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      break;

    case 24:  /* *cmpxf_cf */
    case 23:  /* *cmpdf_cf */
    case 22:  /* *cmpsf_cf */
    case 21:  /* *cmpxf_68881 */
    case 20:  /* *cmpdf_68881 */
    case 19:  /* *cmpsf_68881 */
    case 18:  /* *m68k.md:600 */
    case 17:  /* *m68k.md:561 */
    case 16:  /* *cmpsi_cf */
    case 15:  /* *m68k.md:501 */
    case 12:  /* tstdf_cf */
    case 11:  /* tstsf_cf */
    case 10:  /* tstxf_68881 */
    case 9:  /* tstdf_68881 */
    case 8:  /* tstsf_68881 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 429:  /* jump */
    case 7:  /* *tstqi_internal */
    case 6:  /* *tsthi_internal */
    case 5:  /* *tstsi_internal */
    case 4:  /* *tstsi_internal_68020_cf */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 3:  /* tstdi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 2), 0));
      break;

    case 466:  /* *conditional_trap */
    case 454:  /* *lea */
    case 60:  /* pushasi */
    case 59:  /* *m68k.md:1559 */
    case 58:  /* *m68k.md:1519 */
    case 57:  /* *m68k.md:1505 */
    case 56:  /* *m68k.md:1466 */
    case 55:  /* *m68k.md:1427 */
    case 54:  /* movdf_cf_hard */
    case 53:  /* movdf_cf_soft */
    case 52:  /* *m68k.md:1308 */
    case 51:  /* movsf_cf_hard */
    case 50:  /* movsf_cf_soft */
    case 49:  /* *m68k.md:1163 */
    case 46:  /* *m68k.md:1093 */
    case 45:  /* *m68k.md:1087 */
    case 42:  /* *m68k.md:1057 */
    case 41:  /* *m68k.md:1051 */
    case 40:  /* *m68k.md:1035 */
    case 39:  /* *movsi_cf */
    case 38:  /* *movsi_m68k2 */
    case 37:  /* *movsi_m68k */
    case 33:  /* pushexthisi_const */
    case 2:  /* pushdi */
    case 1:  /* *movdf_internal */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      break;

    }
}
