/* Generated automatically by the program `genpeep'
from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "tree.h"
#include "rtl.h"
#include "insn-config.h"
#include "alias.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "memmodel.h"
#include "tm_p.h"
#include "regs.h"
#include "output.h"
#include "recog.h"
#include "except.h"
#include "diagnostic-core.h"
#include "flags.h"
#include "tm-constrs.h"

extern rtx peep_operand[];

#define operands peep_operand

rtx_insn *
peephole (rtx_insn *ins1)
{
  rtx_insn *insn ATTRIBUTE_UNUSED;
  rtx x ATTRIBUTE_UNUSED, pat ATTRIBUTE_UNUSED;

  if (NEXT_INSN (ins1)
      && BARRIER_P (NEXT_INSN (ins1)))
    return 0;

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L801;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! arith_reg_operand (x, SImode)) goto L801;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L801;
  if (GET_MODE (x) != SImode) goto L801;
  x = XEXP (XEXP (pat, 1), 0);
  operands[1] = x;
  if (! arith_reg_operand (x, SImode)) goto L801;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L801; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L801;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L801;
  x = XEXP (pat, 0);
  if (!rtx_equal_p (operands[1], x)) goto L801;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != PLUS) goto L801;
  if (GET_MODE (x) != SImode) goto L801;
  x = XEXP (XEXP (pat, 1), 0);
  if (!rtx_equal_p (operands[1], x)) goto L801;
  x = XEXP (XEXP (pat, 1), 1);
  if (GET_CODE (x) != CONST_INT) goto L801;
  if (XWINT (x, 0) != 4) goto L801;
  if (! (TARGET_SH1 && REGNO (operands[1]) != REGNO (operands[0]))) goto L801;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (2, operands));
  INSN_CODE (ins1) = 801;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L801:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L802;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! arith_reg_operand (x, SImode)) goto L802;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != PLUS) goto L802;
  if (GET_MODE (x) != SImode) goto L802;
  x = XEXP (XEXP (pat, 1), 0);
  if (!rtx_equal_p (operands[0], x)) goto L802;
  x = XEXP (XEXP (pat, 1), 1);
  if (GET_CODE (x) != CONST_INT) goto L802;
  if (XWINT (x, 0) != -1) goto L802;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L802; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L802;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L802;
  x = XEXP (pat, 0);
  if (GET_CODE (x) != REG) goto L802;
  if (GET_MODE (x) != SImode) goto L802;
  if (REGNO (x) != 147) goto L802;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != EQ) goto L802;
  if (GET_MODE (x) != SImode) goto L802;
  x = XEXP (XEXP (pat, 1), 0);
  if (!rtx_equal_p (operands[0], x)) goto L802;
  x = XEXP (XEXP (pat, 1), 1);
  if (GET_CODE (x) != CONST_INT) goto L802;
  if (XWINT (x, 0) != 0) goto L802;
  if (! (TARGET_SH2)) goto L802;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (1, operands));
  INSN_CODE (ins1) = 802;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L802:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L803;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! register_operand (x, SImode)) goto L803;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != PLUS) goto L803;
  if (GET_MODE (x) != SImode) goto L803;
  x = XEXP (XEXP (pat, 1), 0);
  if (!rtx_equal_p (operands[0], x)) goto L803;
  x = XEXP (XEXP (pat, 1), 1);
  operands[1] = x;
  if (! register_operand (x, SImode)) goto L803;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L803; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L803;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L803;
  x = XEXP (pat, 0);
  if (GET_CODE (x) != MEM) goto L803;
  if (GET_MODE (x) != SFmode) goto L803;
  x = XEXP (XEXP (pat, 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L803;
  x = XEXP (pat, 1);
  operands[2] = x;
  if (! general_movsrc_operand (x, SFmode)) goto L803;
  if (! (TARGET_SH1 && REGNO (operands[0]) == 0
   && ((REG_P (operands[2]) && REGNO (operands[2]) < 16)
       || (GET_CODE (operands[2]) == SUBREG
	   && REGNO (SUBREG_REG (operands[2])) < 16))
   && reg_unused_after (operands[0], insn))) goto L803;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (3, operands));
  INSN_CODE (ins1) = 803;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L803:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L804;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! register_operand (x, SImode)) goto L804;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != PLUS) goto L804;
  if (GET_MODE (x) != SImode) goto L804;
  x = XEXP (XEXP (pat, 1), 0);
  if (!rtx_equal_p (operands[0], x)) goto L804;
  x = XEXP (XEXP (pat, 1), 1);
  operands[1] = x;
  if (! register_operand (x, SImode)) goto L804;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L804; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L804;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L804;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! general_movdst_operand (x, SFmode)) goto L804;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L804;
  if (GET_MODE (x) != SFmode) goto L804;
  x = XEXP (XEXP (pat, 1), 0);
  if (!rtx_equal_p (operands[0], x)) goto L804;
  if (! (TARGET_SH1 && REGNO (operands[0]) == 0
   && ((REG_P (operands[2]) && REGNO (operands[2]) < 16)
       || (GET_CODE (operands[2]) == SUBREG
	   && REGNO (SUBREG_REG (operands[2])) < 16))
   && reg_unused_after (operands[0], insn))) goto L804;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (3, operands));
  INSN_CODE (ins1) = 804;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L804:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L805;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! register_operand (x, SImode)) goto L805;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != PLUS) goto L805;
  if (GET_MODE (x) != SImode) goto L805;
  x = XEXP (XEXP (pat, 1), 0);
  if (!rtx_equal_p (operands[0], x)) goto L805;
  x = XEXP (XEXP (pat, 1), 1);
  operands[1] = x;
  if (! register_operand (x, SImode)) goto L805;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L805; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L805;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L805;
  x = XEXP (pat, 0);
  if (GET_CODE (x) != MEM) goto L805;
  if (GET_MODE (x) != SFmode) goto L805;
  x = XEXP (XEXP (pat, 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L805;
  x = XEXP (pat, 1);
  operands[2] = x;
  if (! general_movsrc_operand (x, SFmode)) goto L805;
  if (! (TARGET_SH2E && REGNO (operands[0]) == 0
   && ((REG_P (operands[2])
        && FP_OR_XD_REGISTER_P (REGNO (operands[2])))
       || (GET_CODE (operands[2]) == SUBREG
	   && FP_OR_XD_REGISTER_P (REGNO (SUBREG_REG (operands[2])))))
   && reg_unused_after (operands[0], insn))) goto L805;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (3, operands));
  INSN_CODE (ins1) = 805;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L805:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L806;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! register_operand (x, SImode)) goto L806;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != PLUS) goto L806;
  if (GET_MODE (x) != SImode) goto L806;
  x = XEXP (XEXP (pat, 1), 0);
  if (!rtx_equal_p (operands[0], x)) goto L806;
  x = XEXP (XEXP (pat, 1), 1);
  operands[1] = x;
  if (! register_operand (x, SImode)) goto L806;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L806; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L806;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L806;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! general_movdst_operand (x, SFmode)) goto L806;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L806;
  if (GET_MODE (x) != SFmode) goto L806;
  x = XEXP (XEXP (pat, 1), 0);
  if (!rtx_equal_p (operands[0], x)) goto L806;
  if (! (TARGET_SH2E && REGNO (operands[0]) == 0
   && ((REG_P (operands[2])
	&& FP_OR_XD_REGISTER_P (REGNO (operands[2])))
       || (GET_CODE (operands[2]) == SUBREG
	   && FP_OR_XD_REGISTER_P (REGNO (SUBREG_REG (operands[2])))))
   && reg_unused_after (operands[0], insn))) goto L806;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (3, operands));
  INSN_CODE (ins1) = 806;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L806:

  return 0;
}

rtx peep_operand[3];
