/* Generated automatically by the program 'build/genpreds'
   from the machine description file '../../gcc-8.1.1-20180626/gcc/config/arc/arc.md'.  */

#ifndef GCC_TM_CONSTRS_H
#define GCC_TM_CONSTRS_H

static inline bool
satisfies_constraint_m (rtx op)
{
  return (GET_CODE (op) == MEM) && (
#line 26 "../../gcc-8.1.1-20180626/gcc/common.md"
(memory_address_addr_space_p (GET_MODE (op), XEXP (op, 0),
						 MEM_ADDR_SPACE (op))));
}
static inline bool
satisfies_constraint_o (rtx op)
{
  return (GET_CODE (op) == MEM) && (
#line 32 "../../gcc-8.1.1-20180626/gcc/common.md"
(offsettable_nonstrict_memref_p (op)));
}
static inline bool
satisfies_constraint_V (rtx op)
{
  return (GET_CODE (op) == MEM) && ((
#line 41 "../../gcc-8.1.1-20180626/gcc/common.md"
(memory_address_addr_space_p (GET_MODE (op), XEXP (op, 0),
						 MEM_ADDR_SPACE (op)))) && (!(
#line 43 "../../gcc-8.1.1-20180626/gcc/common.md"
(offsettable_nonstrict_memref_p (op)))));
}
static inline bool
satisfies_constraint__l (rtx op)
{
  return (GET_CODE (op) == MEM) && ((
#line 50 "../../gcc-8.1.1-20180626/gcc/common.md"
(GET_CODE (XEXP (op, 0)) == PRE_DEC)) || (
#line 51 "../../gcc-8.1.1-20180626/gcc/common.md"
(GET_CODE (XEXP (op, 0)) == POST_DEC)));
}
static inline bool
satisfies_constraint__g (rtx op)
{
  return (GET_CODE (op) == MEM) && ((
#line 57 "../../gcc-8.1.1-20180626/gcc/common.md"
(GET_CODE (XEXP (op, 0)) == PRE_INC)) || (
#line 58 "../../gcc-8.1.1-20180626/gcc/common.md"
(GET_CODE (XEXP (op, 0)) == POST_INC)));
}
static inline bool
satisfies_constraint_p (rtx ARG_UNUSED (op))
{
  return 
#line 62 "../../gcc-8.1.1-20180626/gcc/common.md"
(address_operand (op, VOIDmode));
}
static inline bool
satisfies_constraint_i (rtx op)
{
  return (
#line 66 "../../gcc-8.1.1-20180626/gcc/common.md"
(CONSTANT_P (op))) && (
#line 67 "../../gcc-8.1.1-20180626/gcc/common.md"
(!flag_pic || LEGITIMATE_PIC_OPERAND_P (op)));
}
static inline bool
satisfies_constraint_s (rtx op)
{
  return (
#line 71 "../../gcc-8.1.1-20180626/gcc/common.md"
(CONSTANT_P (op))) && ((
#line 72 "../../gcc-8.1.1-20180626/gcc/common.md"
(!CONST_SCALAR_INT_P (op))) && (
#line 73 "../../gcc-8.1.1-20180626/gcc/common.md"
(!flag_pic || LEGITIMATE_PIC_OPERAND_P (op))));
}
static inline bool
satisfies_constraint_n (rtx op)
{
  return (
#line 77 "../../gcc-8.1.1-20180626/gcc/common.md"
(CONST_SCALAR_INT_P (op))) && (
#line 78 "../../gcc-8.1.1-20180626/gcc/common.md"
(!flag_pic || LEGITIMATE_PIC_OPERAND_P (op)));
}
static inline bool
satisfies_constraint_E (rtx op)
{
  return (
#line 82 "../../gcc-8.1.1-20180626/gcc/common.md"
(CONST_DOUBLE_AS_FLOAT_P (op))) || (
#line 83 "../../gcc-8.1.1-20180626/gcc/common.md"
(GET_CODE (op) == CONST_VECTOR
		    && GET_MODE_CLASS (GET_MODE (op)) == MODE_VECTOR_FLOAT));
}
static inline bool
satisfies_constraint_F (rtx op)
{
  return (
#line 89 "../../gcc-8.1.1-20180626/gcc/common.md"
(CONST_DOUBLE_AS_FLOAT_P (op))) || (
#line 90 "../../gcc-8.1.1-20180626/gcc/common.md"
(GET_CODE (op) == CONST_VECTOR
		    && GET_MODE_CLASS (GET_MODE (op)) == MODE_VECTOR_FLOAT));
}
static inline bool
satisfies_constraint_X (rtx ARG_UNUSED (op))
{
  return 
#line 95 "../../gcc-8.1.1-20180626/gcc/common.md"
(true);
}
static inline bool
satisfies_constraint_I (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 112 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(SIGNED_INT12 (ival)));
}
static inline bool
satisfies_constraint_K (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 118 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(UNSIGNED_INT3 (ival)));
}
static inline bool
satisfies_constraint_L (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 124 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(UNSIGNED_INT6 (ival)));
}
static inline bool
satisfies_constraint_CnL (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 130 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(UNSIGNED_INT6 (~ival)));
}
static inline bool
satisfies_constraint_CmL (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 136 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(UNSIGNED_INT6 (-ival)));
}
static inline bool
satisfies_constraint_C16 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 142 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(SIGNED_INT16 (ival)));
}
static inline bool
satisfies_constraint_M (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 148 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(UNSIGNED_INT5 (ival)));
}
static inline bool
satisfies_constraint_N (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 154 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(IS_ONE (ival)));
}
static inline bool
satisfies_constraint_O (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 160 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(UNSIGNED_INT7 (ival)));
}
static inline bool
satisfies_constraint_P (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 166 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(UNSIGNED_INT8 (ival)));
}
static inline bool
satisfies_constraint_C__0 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 172 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(ival == 0));
}
static inline bool
satisfies_constraint_Cn0 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 178 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(ival <= 0));
}
static inline bool
satisfies_constraint_Cca (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 184 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(ival == (HOST_WIDE_INT)(HOST_WIDE_INT_M1U << 31)
		    || (ival >= -0x1f8 && ival <= 0x1f8
			&& ((ival >= 0 ? ival : -ival)
			    <= 0x3f * (ival & -ival)))));
}
static inline bool
satisfies_constraint_CL2 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 194 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(!(ival & ~126)));
}
static inline bool
satisfies_constraint_CM4 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 200 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(!(ival & ~124)));
}
static inline bool
satisfies_constraint_Csp (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 206 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(!(ival & ~124) || !(-ival & ~124)));
}
static inline bool
satisfies_constraint_C2a (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 212 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(ival == (HOST_WIDE_INT) (HOST_WIDE_INT_M1U << 31)
		    || (ival >= -0x4000 && ival <= 0x4000
			&& ((ival >= 0 ? ival : -ival)
			    <= 0x7ff * (ival & -ival)))));
}
static inline bool
satisfies_constraint_C0p (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 221 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(IS_POWEROF2_P (ival)));
}
static inline bool
satisfies_constraint_C1p (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 227 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(ival && IS_POWEROF2_P (ival + 1)));
}
static inline bool
satisfies_constraint_C2p (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 233 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(TARGET_V2
		    && (ival < -1)
		    && IS_POWEROF2_P ((~ival) + 1)));
}
static inline bool
satisfies_constraint_C3p (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 241 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(((ival == 1) || (ival == 2))));
}
static inline bool
satisfies_constraint_Ccp (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 247 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(IS_POWEROF2_P (~ival)));
}
static inline bool
satisfies_constraint_Cux (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 253 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(ival == 0xff || ival == 0xffff));
}
static inline bool
satisfies_constraint_Chs (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && ((
#line 259 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(IS_POWEROF2_P (-ival))) && (
#line 260 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(TARGET_BARREL_SHIFTER)));
}
static inline bool
satisfies_constraint_Clo (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && ((
#line 266 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(TARGET_NPS_BITOPS)) && (
#line 267 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
((ival & ~0xffffU) == 0)));
}
static inline bool
satisfies_constraint_Chi (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && ((
#line 273 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(TARGET_NPS_BITOPS)) && (
#line 274 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(trunc_int_for_mode (ival >> 16, HImode) << 16 == ival)));
}
static inline bool
satisfies_constraint_Cbf (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && ((
#line 280 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(TARGET_NPS_BITOPS)) && (
#line 281 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(IS_POWEROF2_OR_0_P (ival + (ival & -ival)))));
}
static inline bool
satisfies_constraint_Cbn (rtx op)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 287 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(TARGET_NPS_BITOPS));
}
static inline bool
satisfies_constraint_C18 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 293 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(ival == 1 || ival == 2 || ival == 4 || ival == 8));
}
static inline bool
satisfies_constraint_Crr (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 299 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
((ival & ~0x8000001f) == 0 && !arc_ccfsm_cond_exec_p ()));
}
static inline bool
satisfies_constraint_Cbi (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && ((
#line 305 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(TARGET_NPS_BITOPS)) && (
#line 306 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(!ival
		    || ((ival & 0xffffffffUL) >> exact_log2 (ival & -ival)
			<= 0xff))));
}
static inline bool
satisfies_constraint_G (rtx op)
{
  return (GET_CODE (op) == CONST_DOUBLE) && (
#line 316 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(arc_double_limm_p (op)));
}
static inline bool
satisfies_constraint_H (rtx op)
{
  return (GET_CODE (op) == CONST_DOUBLE) && (
#line 322 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(1));
}
static inline bool
satisfies_constraint_T (rtx op)
{
  machine_mode mode = GET_MODE (op);
  return (GET_CODE (op) == MEM) && (
#line 329 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(compact_memory_operand_p (op, mode, false, false)));
}
static inline bool
satisfies_constraint_Uts (rtx op)
{
  machine_mode mode = GET_MODE (op);
  return (GET_CODE (op) == MEM) && (
#line 335 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(compact_memory_operand_p (op, mode, false, TARGET_CODE_DENSITY)));
}
static inline bool
satisfies_constraint_S (rtx op)
{
  return (GET_CODE (op) == MEM) && (
#line 341 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(compact_store_memory_operand (op, VOIDmode)));
}
static inline bool
satisfies_constraint_Uex (rtx op)
{
  machine_mode mode = GET_MODE (op);
  return (GET_CODE (op) == MEM) && ((
#line 347 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(!cmem_address (XEXP (op, 0), SImode))) && (!(long_immediate_loadstore_operand (op, mode))));
}
static inline bool
satisfies_constraint_Usd (rtx op)
{
  return (GET_CODE (op) == MEM) && (
#line 358 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(compact_sda_memory_operand (op, VOIDmode, true)));
}
static inline bool
satisfies_constraint_Usc (rtx op)
{
  return (GET_CODE (op) == MEM) && (
#line 366 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(!CONSTANT_P (XEXP (op,0))));
}
static inline bool
satisfies_constraint_Us_l (rtx op)
{
  return (GET_CODE (op) == MEM) && ((
#line 372 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(GET_CODE (XEXP (op, 0)) == PRE_DEC)) && ((
#line 373 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(REG_P (XEXP (XEXP (op, 0), 0)))) && (
#line 374 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(REGNO (XEXP (XEXP (op, 0), 0)) == SP_REG))));
}
static inline bool
satisfies_constraint_Us_g (rtx op)
{
  return (GET_CODE (op) == MEM) && ((
#line 380 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(GET_CODE (XEXP (op, 0)) == POST_INC)) && ((
#line 381 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(REG_P (XEXP (XEXP (op, 0), 0)))) && (
#line 382 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(REGNO (XEXP (XEXP (op, 0), 0)) == SP_REG))));
}
static inline bool
satisfies_constraint_Ucm (rtx op)
{
  return (GET_CODE (op) == MEM) && (
#line 388 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(TARGET_NPS_CMEM && cmem_address (XEXP (op, 0), VOIDmode)));
}
static inline bool
satisfies_constraint_Cbr (rtx op)
{
  return ((GET_CODE (op) == SYMBOL_REF) && (
#line 395 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(!arc_is_longcall_p (op)))) || (GET_CODE (op) == LABEL_REF);
}
static inline bool
satisfies_constraint_Cbp (rtx op)
{
  return ((GET_CODE (op) == SYMBOL_REF) && (
#line 401 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(arc_is_shortcall_p (op)))) || (GET_CODE (op) == LABEL_REF);
}
static inline bool
satisfies_constraint_Cji (rtx op)
{
  return (GET_CODE (op) == SYMBOL_REF) && ((
#line 407 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(TARGET_CODE_DENSITY)) && (
#line 408 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(arc_is_jli_call_p (op))));
}
static inline bool
satisfies_constraint_Csc (rtx op)
{
  return (GET_CODE (op) == SYMBOL_REF) && ((
#line 413 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(TARGET_CODE_DENSITY)) && ((
#line 414 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(TARGET_EM)) && (
#line 415 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(arc_is_secure_call_p (op)))));
}
static inline bool
satisfies_constraint_Cpc (rtx op)
{
  return 
#line 419 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(arc_legitimate_pic_addr_p (op));
}
static inline bool
satisfies_constraint_Clb (rtx op)
{
  return (GET_CODE (op) == LABEL_REF) && (
#line 424 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(arc_text_label (as_a <rtx_insn *> (XEXP (op, 0)))));
}
static inline bool
satisfies_constraint_Cal (rtx ARG_UNUSED (op))
{
  return 
#line 428 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(immediate_operand (op, VOIDmode) && !arc_legitimate_pic_addr_p (op));
}
static inline bool
satisfies_constraint_C32 (rtx ARG_UNUSED (op))
{
  return 
#line 432 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(immediate_operand (op, VOIDmode)
	       && !arc_legitimate_pic_addr_p (op)
	       && !satisfies_constraint_I (op));
}
static inline bool
satisfies_constraint_Rcq (rtx op)
{
  return (GET_CODE (op) == REG) && (
#line 452 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(TARGET_Rcq
		    && !arc_ccfsm_cond_exec_p ()
		    && IN_RANGE (REGNO (op) ^ 4, 4, 11)));
}
static inline bool
satisfies_constraint_Rcw (rtx op)
{
  return (GET_CODE (op) == REG) && (
#line 465 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(TARGET_Rcw
	 && REGNO (op) < FIRST_PSEUDO_REGISTER
	 && TEST_HARD_REG_BIT (reg_class_contents[WRITABLE_CORE_REGS],
			       REGNO (op))));
}
static inline bool
satisfies_constraint_Rcr (rtx op)
{
  return (GET_CODE (op) == REG) && (
#line 475 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(TARGET_Rcw
	 && REGNO (op) < FIRST_PSEUDO_REGISTER
	 && TEST_HARD_REG_BIT (reg_class_contents[GENERAL_REGS],
			       REGNO (op))));
}
static inline bool
satisfies_constraint_Rcb (rtx op)
{
  return (GET_CODE (op) == REG) && (
#line 484 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(REGNO (op) == 28));
}
static inline bool
satisfies_constraint_Rck (rtx op)
{
  return (GET_CODE (op) == REG) && (
#line 490 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(REGNO (op) == 31));
}
static inline bool
satisfies_constraint_Rs5 (rtx op)
{
  return (GET_CODE (op) == REG) && ((
#line 498 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(!arc_ccfsm_cond_exec_p ())) && ((
#line 499 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
((unsigned) REGNO (op) <= 3)) || (
#line 500 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(REGNO (op) == 12))));
}
static inline bool
satisfies_constraint_Rcc (rtx op)
{
  return (GET_CODE (op) == REG) && (
#line 505 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(cc_register (op, VOIDmode)));
}
static inline bool
satisfies_constraint_Q (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 512 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(IS_ZERO (ival)));
}
static inline bool
satisfies_constraint_Cm1 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && ((
#line 518 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
((ival >= -1) && (ival <=6))) && (
#line 519 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(TARGET_V2)));
}
static inline bool
satisfies_constraint_Cm2 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 525 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
((ival >= -256) && (ival <=255)));
}
static inline bool
satisfies_constraint_Cm3 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && ((
#line 531 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
((ival >= -32) && (ival <=31))) && (
#line 532 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(TARGET_V2)));
}
static inline bool
satisfies_constraint_C62 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 538 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(UNSIGNED_INT6 (ival - 1)));
}
static inline bool
satisfies_constraint_ATO (rtx op)
{
  machine_mode mode = GET_MODE (op);
  return mem_noofs_operand (op, mode);
}
static inline bool
satisfies_constraint_J12 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 549 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(UNSIGNED_INT12 (ival)));
}
static inline bool
satisfies_constraint_J16 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 555 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(UNSIGNED_INT16 (ival)));
}
static inline bool
satisfies_constraint_Ucd (rtx op)
{
  machine_mode mode = GET_MODE (op);
  return (GET_CODE (op) == MEM) && ((
#line 562 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(compact_memory_operand_p (op, mode, true, false))) && (
#line 563 "../../gcc-8.1.1-20180626/gcc/config/arc/constraints.md"
(TARGET_V2)));
}
#endif /* tm-constrs.h */
