/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"



/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.

   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it
   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.c) to fill in the CLOBBERs.


   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/


extern rtx_insn *gen_split_1 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_2 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_3 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_4 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_5 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_6 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_7 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_8 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_9 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_10 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_11 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_12 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_13 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_14 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_15 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_16 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_17 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_18 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_19 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_20 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_21 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_22 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_23 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_24 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_25 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_26 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_27 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_28 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_29 (rtx_insn *, rtx *);




static int
pattern0 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

static int
pattern1 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!reg_or_uint16_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

static int
pattern2 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != MEM
      || GET_MODE (x4) != E_BLKmode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != USE)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x6) != SET)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != PLUS
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != MINUS)
    return -1;
  x9 = XEXP (x8, 1);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
    return -1;
  x10 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x10) != SET)
    return -1;
  x11 = XEXP (x10, 1);
  if (GET_CODE (x11) != PLUS
      || GET_MODE (x11) != E_SImode)
    return -1;
  return 0;
}

static int
pattern3 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 17
      || GET_MODE (x2) != E_CCmode)
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x5 = XEXP (x3, 1);
  operands[1] = x5;
  if (!reg_or_int16_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

static int
pattern4 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!reg_or_int16_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

static int
pattern5 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !extend_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!extend_operand (operands[1], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!extend_operand (operands[1], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
pattern6 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode
          || !register_operand (operands[1], E_DFmode))
        return -1;
      return 0;

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern7 (rtx x1, machine_mode i1, unsigned int i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

static int
pattern8 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x4, 0);
  if (!scratch_operand (x8, E_SImode))
    return -1;
  switch (GET_CODE (x7))
    {
    case EQ:
      x9 = XEXP (x7, 0);
      operands[1] = x9;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x10 = XEXP (x7, 1);
      operands[2] = x10;
      if (!reg_or_eq_int16_operand (operands[2], E_SImode))
        return -1;
      operands[3] = x8;
      return 0;

    case NE:
      x10 = XEXP (x7, 1);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x9 = XEXP (x7, 0);
      operands[1] = x9;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      operands[2] = x8;
      return 1;

    default:
      return -1;
    }
}

static int
pattern9 (rtx x1, rtx_code i1, machine_mode i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i3
      || GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  return 0;
}

static int
pattern10 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode
      || !register_operand (operands[0], E_SImode))
    return -1;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  if (!int8_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

static int
pattern11 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  return 0;
}

static int
pattern12 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 17
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x8 = XEXP (x3, 1);
  operands[2] = x8;
  if (!reg_or_int16_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

static int
pattern13 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 17
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x8 = XEXP (x3, 1);
  operands[2] = x8;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

static int
pattern14 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern15 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  if (!register_operand (operands[2], E_DImode))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 17
      || GET_MODE (x6) != E_CCmode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x3) != E_DImode
      || !register_operand (operands[1], E_DImode))
    return -1;
  return 0;
}

static int
pattern16 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != NE
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 17
      || GET_MODE (x6) != E_CCmode)
    return -1;
  x7 = XEXP (x5, 1);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x8) != SET)
    return -1;
  x9 = XEXP (x8, 1);
  if (GET_CODE (x9) != UNSPEC
      || XVECLEN (x9, 0) != 1
      || XINT (x9, 1) != 3
      || GET_MODE (x9) != E_CCmode)
    return -1;
  x10 = XVECEXP (x9, 0, 0);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x11 = XEXP (x8, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 17
      || GET_MODE (x11) != E_CCmode
      || !register_operand (operands[0], E_SImode)
      || GET_MODE (x3) != E_SImode
      || !register_operand (operands[1], E_SImode))
    return -1;
  x12 = XEXP (x4, 0);
  operands[2] = x12;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

static int
pattern17 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !register_operand (operands[0], i1))
    return -1;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern18 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode
      || !register_operand (operands[0], E_SImode))
    return -1;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  if (!reg_or_int16_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

static int
pattern19 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x5 = XEXP (x2, 1);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[2] = x8;
  if (!m32r_block_immediate_operand (operands[2], E_SImode))
    return -1;
  x9 = XVECEXP (x1, 0, 2);
  x10 = XEXP (x9, 0);
  operands[3] = x10;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  x11 = XVECEXP (x1, 0, 3);
  x12 = XEXP (x11, 0);
  operands[4] = x12;
  if (!register_operand (operands[4], E_SImode))
    return -1;
  return 0;
}

static int
pattern20 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (!rtx_equal_p (x5, operands[2]))
    return -1;
  x6 = XEXP (x3, 1);
  if (!rtx_equal_p (x6, operands[0]))
    return -1;
  x7 = XVECEXP (x1, 0, 3);
  x8 = XEXP (x7, 1);
  x9 = XEXP (x8, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  x10 = XEXP (x8, 1);
  if (!rtx_equal_p (x10, operands[2]))
    return -1;
  return 0;
}

static int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != PC)
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) == REG
      && REGNO (x5) == 17)
    {
      x6 = XEXP (x4, 1);
      if (x6 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
        {
          x7 = XEXP (x3, 1);
          switch (GET_CODE (x7))
            {
            case LABEL_REF:
              x8 = XEXP (x3, 2);
              if (GET_CODE (x8) == PC)
                {
                  x9 = XEXP (x7, 0);
                  operands[0] = x9;
                  return 42; /* *branch_insn */
                }
              break;

            case PC:
              x8 = XEXP (x3, 2);
              if (GET_CODE (x8) == LABEL_REF)
                {
                  x10 = XEXP (x8, 0);
                  operands[0] = x10;
                  return 43; /* *rev_branch_insn */
                }
              break;

            default:
              break;
            }
        }
    }
  operands[2] = x5;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x6 = XEXP (x4, 1);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[3] = x6;
      if (!register_operand (operands[3], E_SImode))
        return -1;
      x7 = XEXP (x3, 1);
      switch (GET_CODE (x7))
        {
        case LABEL_REF:
          x8 = XEXP (x3, 2);
          if (GET_CODE (x8) != PC)
            return -1;
          x9 = XEXP (x7, 0);
          operands[0] = x9;
          return 44; /* *reg_branch_insn */

        case PC:
          x8 = XEXP (x3, 2);
          if (GET_CODE (x8) != LABEL_REF)
            return -1;
          x10 = XEXP (x8, 0);
          operands[0] = x10;
          return 45; /* *rev_reg_branch_insn */

        default:
          return -1;
        }

    case CONST_INT:
      if (XWINT (x6, 0) != 0L)
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != PC)
        return -1;
      x8 = XEXP (x3, 2);
      if (GET_CODE (x8) != LABEL_REF)
        return -1;
      x10 = XEXP (x8, 0);
      operands[0] = x10;
      return 47; /* *rev_zero_branch_insn */

    default:
      return -1;
    }
}

static int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !nonmemory_operand (operands[2], E_SImode))
        return -1;
      return 17; /* addsi3 */

    case E_DImode:
      if (pnum_clobbers == NULL
          || pattern14 (x3, E_DImode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 18; /* adddi3 */

    default:
      return -1;
    }
}

static int
recog_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pattern14 (x3, E_SImode) != 0)
        return -1;
      return 21; /* subsi3 */

    case E_DImode:
      if (pnum_clobbers == NULL
          || pattern14 (x3, E_DImode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 22; /* subdi3 */

    default:
      return -1;
    }
}

static int
recog_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case SIGN_EXTEND:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) != SIGN_EXTEND
          || GET_MODE (x5) != E_SImode)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_HImode))
        return -1;
      x7 = XEXP (x5, 0);
      operands[2] = x7;
      if (!register_operand (operands[2], E_HImode))
        return -1;
      return 24; /* mulhisi3 */

    case REG:
    case SUBREG:
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      return 25; /* mulsi3 */

    default:
      return -1;
    }
}

static int
recog_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case UNSPEC:
      if (XVECLEN (x2, 0) != 1)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      switch (XINT (x2, 1))
        {
        case 2:
          x4 = XVECEXP (x2, 0, 0);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          if (
#line 517 "../../gcc-8.1.1-20180626/gcc/config/m32r/m32r.md"
(TARGET_ADDR32))
            return 4; /* *load_sda_base_32 */
          return 5; /* *load_sda_base */

        case 4:
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!
#line 2244 "../../gcc-8.1.1-20180626/gcc/config/m32r/m32r.md"
(flag_pic))
            return -1;
          return 75; /* pic_load_addr */

        case 6:
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!
#line 2251 "../../gcc-8.1.1-20180626/gcc/config/m32r/m32r.md"
(flag_pic))
            return -1;
          return 76; /* gotoff_load_addr */

        default:
          return -1;
        }

    case LO_SUM:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x5 = XEXP (x2, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      if (!immediate_operand (operands[2], E_SImode))
        return -1;
      return 7; /* lo_sum_si */

    case DIV:
      if (pattern0 (x1) != 0)
        return -1;
      return 26; /* divsi3 */

    case UDIV:
      if (pattern0 (x1) != 0)
        return -1;
      return 27; /* udivsi3 */

    case MOD:
      if (pattern0 (x1) != 0)
        return -1;
      return 28; /* modsi3 */

    case UMOD:
      if (pattern0 (x1) != 0)
        return -1;
      return 29; /* umodsi3 */

    case IOR:
      if (pattern1 (x1) != 0)
        return -1;
      return 31; /* iorsi3 */

    case XOR:
      if (pattern1 (x1) != 0)
        return -1;
      return 32; /* xorsi3 */

    case NEG:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x5 = XEXP (x2, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 33; /* negsi2 */

    case NOT:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x5 = XEXP (x2, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 34; /* one_cmplsi2 */

    case ASHIFT:
      if (pattern1 (x1) != 0)
        return -1;
      return 35; /* ashlsi3 */

    case ASHIFTRT:
      if (pattern1 (x1) != 0)
        return -1;
      return 36; /* ashrsi3 */

    case LSHIFTRT:
      if (pattern1 (x1) != 0)
        return -1;
      return 37; /* lshrsi3 */

    case EQ:
      if (GET_MODE (x2) == E_CCmode)
        {
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) == REG
              && REGNO (x3) == 17
              && GET_MODE (x3) == E_CCmode)
            {
              x5 = XEXP (x2, 0);
              operands[0] = x5;
              if (register_operand (operands[0], E_SImode))
                {
                  x6 = XEXP (x2, 1);
                  operands[1] = x6;
                  if (reg_or_zero_operand (operands[1], E_SImode)
                      && 
#line 1184 "../../gcc-8.1.1-20180626/gcc/config/m32r/m32r.md"
(TARGET_M32RX || TARGET_M32R2))
                    return 38; /* cmp_eqsi_zero_insn */
                  if (pnum_clobbers != NULL
                      && reg_or_cmp_int16_operand (operands[1], E_SImode))
                    {
                      *pnum_clobbers = 1;
                      return 39; /* cmp_eqsi_insn */
                    }
                }
            }
        }
      if (pnum_clobbers == NULL
          || GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x5 = XEXP (x2, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      if (reg_or_zero_operand (operands[2], E_SImode)
          && 
#line 1514 "../../gcc-8.1.1-20180626/gcc/config/m32r/m32r.md"
(TARGET_M32RX || TARGET_M32R2))
        {
          *pnum_clobbers = 1;
          return 48; /* seq_insn_m32rx */
        }
      if (x6 == const_int_rtx[MAX_SAVED_CONST_INT + 0]
          && 
#line 1537 "../../gcc-8.1.1-20180626/gcc/config/m32r/m32r.md"
(TARGET_M32R))
        {
          *pnum_clobbers = 1;
          return 49; /* seq_zero_insn */
        }
      operands[2] = x6;
      if (!reg_or_eq_int16_operand (operands[2], E_SImode)
          || !
#line 1567 "../../gcc-8.1.1-20180626/gcc/config/m32r/m32r.md"
(TARGET_M32R))
        return -1;
      *pnum_clobbers = 2;
      return 50; /* seq_insn */

    case LT:
      if (GET_MODE (x2) == E_CCmode
          && pattern3 (x1) == 0)
        return 40; /* cmp_ltsi_insn */
      if (pnum_clobbers == NULL
          || pattern4 (x1) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 52; /* slt_insn */

    case LTU:
      if (GET_MODE (x2) == E_CCmode
          && pattern3 (x1) == 0)
        return 41; /* cmp_ltusi_insn */
      if (pnum_clobbers == NULL
          || pattern4 (x1) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 55; /* sltu_insn */

    case IF_THEN_ELSE:
      x5 = XEXP (x2, 0);
      switch (GET_CODE (x5))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
          operands[1] = x5;
          switch (GET_CODE (operands[1]))
            {
            case NE:
            case EQ:
              if (eqne_comparison_operator (operands[1], E_VOIDmode))
                {
                  res = recog_1 (x1, insn, pnum_clobbers);
                  if (res >= 0)
                    return res;
                }
              if (carry_compare_operand (operands[1], E_VOIDmode))
                {
                  x3 = XEXP (x1, 0);
                  operands[0] = x3;
                  if (register_operand (operands[0], E_SImode)
                      && GET_MODE (x2) == E_SImode)
                    {
                      x6 = XEXP (x2, 1);
                      operands[2] = x6;
                      if (conditional_move_operand (operands[2], E_SImode))
                        {
                          x7 = XEXP (x2, 2);
                          operands[3] = x7;
                          if (conditional_move_operand (operands[3], E_SImode)
                              && 
#line 2184 "../../gcc-8.1.1-20180626/gcc/config/m32r/m32r.md"
(zero_and_one (operands [2], operands[3])))
                            return 73; /* *movsicc_internal */
                        }
                    }
                }
              break;

            default:
              break;
            }
          if (!signed_comparison_operator (operands[1], E_VOIDmode))
            return -1;
          x8 = XEXP (x5, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x6 = XEXP (x2, 1);
          if (GET_CODE (x6) != LABEL_REF)
            return -1;
          x7 = XEXP (x2, 2);
          if (GET_CODE (x7) != PC)
            return -1;
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) != PC)
            return -1;
          x9 = XEXP (x5, 0);
          operands[2] = x9;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x10 = XEXP (x6, 0);
          operands[0] = x10;
          return 46; /* *zero_branch_insn */

        default:
          return -1;
        }

    case NE:
      if (pnum_clobbers != NULL
          && GET_MODE (x2) == E_SImode)
        {
          x6 = XEXP (x2, 1);
          if (x6 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              x3 = XEXP (x1, 0);
              operands[0] = x3;
              if (register_operand (operands[0], E_SImode))
                {
                  x5 = XEXP (x2, 0);
                  operands[1] = x5;
                  if (register_operand (operands[1], E_SImode))
                    {
                      *pnum_clobbers = 2;
                      return 51; /* sne_zero_insn */
                    }
                }
            }
        }
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 17
          || GET_MODE (x5) != E_CCmode)
        return -1;
      x6 = XEXP (x2, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      return 58; /* movcc_insn */

    case LE:
      if (pnum_clobbers == NULL
          || pattern0 (x1) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 53; /* sle_insn */

    case GE:
      if (pnum_clobbers == NULL
          || pattern4 (x1) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 54; /* sge_insn */

    case LEU:
      if (pnum_clobbers == NULL
          || pattern0 (x1) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 56; /* sleu_insn */

    case GEU:
      if (pnum_clobbers == NULL
          || pattern4 (x1) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 57; /* sgeu_insn */

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case PLUS:
    case MINUS:
    case MULT:
    case AND:
    case SIGN_EXTEND:
    case ZERO_EXTEND:
    case HIGH:
      switch (GET_CODE (x2))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
          operands[1] = x2;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (move_dest_operand (operands[0], E_QImode)
                  && move_src_operand (operands[1], E_QImode)
                  && 
#line 259 "../../gcc-8.1.1-20180626/gcc/config/m32r/m32r.md"
(register_operand (operands[0], QImode) || register_operand (operands[1], QImode)))
                return 1; /* *movqi_insn */
              break;

            case E_HImode:
              if (move_dest_operand (operands[0], E_HImode)
                  && move_src_operand (operands[1], E_HImode)
                  && 
#line 298 "../../gcc-8.1.1-20180626/gcc/config/m32r/m32r.md"
(register_operand (operands[0], HImode) || register_operand (operands[1], HImode)))
                return 2; /* *movhi_insn */
              break;

            case E_SImode:
              if (move_dest_operand (operands[0], E_SImode)
                  && move_src_operand (operands[1], E_SImode)
                  && 
#line 366 "../../gcc-8.1.1-20180626/gcc/config/m32r/m32r.md"
(register_operand (operands[0], SImode) || register_operand (operands[1], SImode)))
                return 3; /* *movsi_insn */
              break;

            case E_DImode:
              if (move_dest_operand (operands[0], E_DImode)
                  && move_double_src_operand (operands[1], E_DImode)
                  && 
#line 592 "../../gcc-8.1.1-20180626/gcc/config/m32r/m32r.md"
(register_operand (operands[0], DImode) || register_operand (operands[1], DImode)))
                return 8; /* *movdi_insn */
              break;

            case E_SFmode:
              if (move_dest_operand (operands[0], E_SFmode)
                  && move_src_operand (operands[1], E_SFmode)
                  && 
#line 633 "../../gcc-8.1.1-20180626/gcc/config/m32r/m32r.md"
(register_operand (operands[0], SFmode) || register_operand (operands[1], SFmode)))
                return 9; /* *movsf_insn */
              break;

            case E_DFmode:
              if (move_dest_operand (operands[0], E_DFmode)
                  && move_double_src_operand (operands[1], E_DFmode)
                  && 
#line 685 "../../gcc-8.1.1-20180626/gcc/config/m32r/m32r.md"
(register_operand (operands[0], DFmode) || register_operand (operands[1], DFmode)))
                return 10; /* *movdf_insn */
              break;

            default:
              break;
            }
          if (GET_CODE (x2) == LABEL_REF
              && GET_CODE (x3) == PC)
            {
              x5 = XEXP (x2, 0);
              operands[0] = x5;
              return 59; /* jump */
            }
          break;

        case HIGH:
          if (GET_MODE (x2) == E_SImode)
            {
              x3 = XEXP (x1, 0);
              operands[0] = x3;
              if (register_operand (operands[0], E_SImode))
                {
                  x5 = XEXP (x2, 0);
                  operands[1] = x5;
                  if (symbolic_operand (operands[1], E_VOIDmode))
                    return 6; /* set_hi_si */
                }
            }
          break;

        case ZERO_EXTEND:
          switch (pattern5 (x1))
            {
            case 0:
              return 11; /* zero_extendqihi2 */

            case 1:
              return 12; /* zero_extendqisi2 */

            case 2:
              return 13; /* zero_extendhisi2 */

            default:
              break;
            }
          break;

        case SIGN_EXTEND:
          switch (pattern5 (x1))
            {
            case 0:
              return 14; /* extendqihi2 */

            case 1:
              return 15; /* extendqisi2 */

            case 2:
              return 16; /* extendhisi2 */

            default:
              break;
            }
          break;

        case PLUS:
          res = recog_2 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case MINUS:
          res = recog_3 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case MULT:
          res = recog_4 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case AND:
          if (pattern1 (x1) == 0)
            return 30; /* andsi3 */
          break;

        default:
          break;
        }
      operands[0] = x2;
      if (!address_operand (operands[0], E_SImode))
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) != PC)
        return -1;
      return 60; /* indirect_jump */

    case CALL:
      if (pnum_clobbers == NULL)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_CODE (x5) != MEM
          || GET_MODE (x5) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_VOIDmode))
        return -1;
      x9 = XEXP (x5, 0);
      operands[1] = x9;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      switch (GET_CODE (operands[1]))
        {
        case REG:
        case SUBREG:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          *pnum_clobbers = 1;
          return 66; /* *call_value_via_reg */

        case CONST:
        case LABEL_REF:
        case SYMBOL_REF:
          if (!call_address_operand (operands[1], E_SImode))
            return -1;
          *pnum_clobbers = 1;
          return 67; /* *call_value_via_label */

        default:
          return -1;
        }

    case ABS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern6 (x2))
        {
        case 0:
          return 71; /* absdf2 */

        case 1:
          return 72; /* abssf2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return recog_5 (x1, insn, pnum_clobbers);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          x2 = XVECEXP (x1, 0, 0);
          switch (GET_CODE (x2))
            {
            case SET:
              x3 = XEXP (x2, 1);
              switch (GET_CODE (x3))
                {
                case EQ:
                  if (GET_MODE (x3) == E_CCmode
                      && pattern9 (x1, CLOBBER, E_CCmode, 17) == 0)
                    {
                      x4 = XEXP (x3, 0);
                      operands[0] = x4;
                      if (register_operand (operands[0], E_SImode))
                        {
                          x5 = XEXP (x3, 1);
                          operands[1] = x5;
                          if (reg_or_cmp_int16_operand (operands[1], E_SImode))
                            {
                              x6 = XVECEXP (x1, 0, 1);
                              x7 = XEXP (x6, 0);
                              operands[2] = x7;
                              if (scratch_operand (operands[2], E_SImode))
                                return 39; /* cmp_eqsi_insn */
                            }
                        }
                    }
                  if (GET_MODE (x3) != E_SImode
                      || pattern11 (x1) != 0
                      || !register_operand (operands[0], E_SImode))
                    return -1;
                  x4 = XEXP (x3, 0);
                  operands[1] = x4;
                  if (!register_operand (operands[1], E_SImode))
                    return -1;
                  x5 = XEXP (x3, 1);
                  operands[2] = x5;
                  if (reg_or_zero_operand (operands[2], E_SImode)
                      && 
#line 1514 "../../gcc-8.1.1-20180626/gcc/config/m32r/m32r.md"
(TARGET_M32RX || TARGET_M32R2))
                    return 48; /* seq_insn_m32rx */
                  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
                      || !
#line 1537 "../../gcc-8.1.1-20180626/gcc/config/m32r/m32r.md"
(TARGET_M32R))
                    return -1;
                  return 49; /* seq_zero_insn */

                case LT:
                  if (pattern12 (x1) != 0)
                    return -1;
                  return 52; /* slt_insn */

                case LE:
                  if (pattern13 (x1) != 0)
                    return -1;
                  return 53; /* sle_insn */

                case GE:
                  if (pattern12 (x1) != 0)
                    return -1;
                  return 54; /* sge_insn */

                case LTU:
                  if (pattern12 (x1) != 0)
                    return -1;
                  return 55; /* sltu_insn */

                case LEU:
                  if (pattern13 (x1) != 0)
                    return -1;
                  return 56; /* sleu_insn */

                case GEU:
                  if (pattern12 (x1) != 0)
                    return -1;
                  return 57; /* sgeu_insn */

                case CONST_INT:
                case CONST_WIDE_INT:
                case CONST_POLY_INT:
                case CONST_FIXED:
                case CONST_DOUBLE:
                case CONST_VECTOR:
                case CONST:
                case REG:
                case SUBREG:
                case MEM:
                case LABEL_REF:
                case SYMBOL_REF:
                case PLUS:
                case MINUS:
                case MULT:
                case AND:
                case SIGN_EXTEND:
                case ZERO_EXTEND:
                case HIGH:
                  switch (GET_CODE (x3))
                    {
                    case PLUS:
                      x8 = XEXP (x2, 0);
                      operands[0] = x8;
                      x4 = XEXP (x3, 0);
                      operands[1] = x4;
                      x5 = XEXP (x3, 1);
                      switch (GET_CODE (x5))
                        {
                        case REG:
                        case SUBREG:
                          if (pattern15 (x1) == 0)
                            return 18; /* adddi3 */
                          break;

                        case PLUS:
                          if (pattern16 (x1) == 0)
                            return 20; /* *add_carry */
                          break;

                        default:
                          break;
                        }
                      break;

                    case CONST_INT:
                      if (XWINT (x3, 0) == 0L
                          && pattern9 (x1, USE, E_CCmode, 17) == 0)
                        {
                          x6 = XVECEXP (x1, 0, 1);
                          x7 = XEXP (x6, 0);
                          operands[0] = x7;
                          if (register_operand (operands[0], E_SImode))
                            return 19; /* *clear_c */
                        }
                      break;

                    case MINUS:
                      x8 = XEXP (x2, 0);
                      operands[0] = x8;
                      x4 = XEXP (x3, 0);
                      operands[1] = x4;
                      x5 = XEXP (x3, 1);
                      switch (GET_CODE (x5))
                        {
                        case REG:
                        case SUBREG:
                          if (pattern15 (x1) == 0)
                            return 22; /* subdi3 */
                          break;

                        case MINUS:
                          if (pattern16 (x1) == 0)
                            return 23; /* *sub_carry */
                          break;

                        default:
                          break;
                        }
                      break;

                    default:
                      break;
                    }
                  operands[0] = x3;
                  if (!address_operand (operands[0], E_SImode))
                    return -1;
                  x8 = XEXP (x2, 0);
                  if (GET_CODE (x8) != PC)
                    return -1;
                  x6 = XVECEXP (x1, 0, 1);
                  if (GET_CODE (x6) != USE)
                    return -1;
                  x7 = XEXP (x6, 0);
                  if (GET_CODE (x7) != LABEL_REF)
                    return -1;
                  x9 = XEXP (x7, 0);
                  operands[1] = x9;
                  return 63; /* *tablejump_insn */

                case CALL:
                  x4 = XEXP (x3, 0);
                  if (GET_CODE (x4) != MEM
                      || GET_MODE (x4) != E_SImode)
                    return -1;
                  x6 = XVECEXP (x1, 0, 1);
                  if (pattern7 (x6, E_SImode, 14, CLOBBER) != 0)
                    return -1;
                  x8 = XEXP (x2, 0);
                  operands[0] = x8;
                  if (!register_operand (operands[0], E_VOIDmode))
                    return -1;
                  x10 = XEXP (x4, 0);
                  operands[1] = x10;
                  x5 = XEXP (x3, 1);
                  operands[2] = x5;
                  switch (GET_CODE (operands[1]))
                    {
                    case REG:
                    case SUBREG:
                      if (!register_operand (operands[1], E_SImode))
                        return -1;
                      return 66; /* *call_value_via_reg */

                    case CONST:
                    case LABEL_REF:
                    case SYMBOL_REF:
                      if (!call_address_operand (operands[1], E_SImode))
                        return -1;
                      return 67; /* *call_value_via_label */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case RETURN:
              x6 = XVECEXP (x1, 0, 1);
              if (pattern7 (x6, E_SImode, 14, USE) != 0)
                return -1;
              return 61; /* return_lr */

            case CALL:
              x8 = XEXP (x2, 0);
              if (GET_CODE (x8) != MEM
                  || GET_MODE (x8) != E_SImode)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (pattern7 (x6, E_SImode, 14, CLOBBER) != 0)
                return -1;
              x11 = XEXP (x8, 0);
              operands[0] = x11;
              x3 = XEXP (x2, 1);
              operands[1] = x3;
              switch (GET_CODE (operands[0]))
                {
                case REG:
                case SUBREG:
                  if (!register_operand (operands[0], E_SImode))
                    return -1;
                  return 64; /* *call_via_reg */

                case CONST:
                case LABEL_REF:
                case SYMBOL_REF:
                  if (!call_address_operand (operands[0], E_SImode))
                    return -1;
                  return 65; /* *call_via_label */

                default:
                  return -1;
                }

            case UNSPEC_VOLATILE:
              if (pnum_clobbers == NULL
                  || XVECLEN (x2, 0) != 1
                  || XINT (x2, 1) != 1)
                return -1;
              x12 = XVECEXP (x2, 0, 0);
              operands[0] = x12;
              if (!memory_operand (operands[0], E_VOIDmode))
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              operands[1] = x6;
              *pnum_clobbers = 1;
              return 70; /* flush_icache */

            default:
              return -1;
            }

        case 3:
          x2 = XVECEXP (x1, 0, 0);
          switch (GET_CODE (x2))
            {
            case SET:
              switch (pattern8 (x1))
                {
                case 0:
                  if (!
#line 1567 "../../gcc-8.1.1-20180626/gcc/config/m32r/m32r.md"
(TARGET_M32R))
                    return -1;
                  return 50; /* seq_insn */

                case 1:
                  return 51; /* sne_zero_insn */

                default:
                  return -1;
                }

            case UNSPEC_VOLATILE:
              if (XVECLEN (x2, 0) != 1
                  || XINT (x2, 1) != 1)
                return -1;
              x13 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x13) != CLOBBER)
                return -1;
              x14 = XEXP (x13, 0);
              if (GET_CODE (x14) != REG
                  || REGNO (x14) != 17
                  || GET_MODE (x14) != E_SImode)
                return -1;
              x12 = XVECEXP (x2, 0, 0);
              operands[0] = x12;
              if (!memory_operand (operands[0], E_VOIDmode))
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              operands[1] = x6;
              return 70; /* flush_icache */

            case CLOBBER:
              if (pattern9 (x1, SET, E_SImode, 14) != 0)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              x15 = XEXP (x6, 1);
              if (GET_CODE (x15) != UNSPEC
                  || XVECLEN (x15, 0) != 1
                  || XINT (x15, 1) != 5)
                return -1;
              x13 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x13) != USE)
                return -1;
              x7 = XEXP (x6, 0);
              operands[0] = x7;
              if (!register_operand (operands[0], E_VOIDmode))
                return -1;
              x16 = XVECEXP (x15, 0, 0);
              operands[1] = x16;
              x14 = XEXP (x13, 0);
              operands[2] = x14;
              if (!immediate_operand (operands[2], E_SImode)
                  || !
#line 2263 "../../gcc-8.1.1-20180626/gcc/config/m32r/m32r.md"
(flag_pic))
                return -1;
              return 77; /* get_pc */

            default:
              return -1;
            }

        case 6:
          if (pattern2 (x1) != 0)
            return -1;
          x17 = XVECEXP (x1, 0, 4);
          if (GET_CODE (x17) != CLOBBER)
            return -1;
          x18 = XVECEXP (x1, 0, 5);
          if (GET_CODE (x18) != CLOBBER
              || pattern19 (x1) != 0)
            return -1;
          x19 = XEXP (x17, 0);
          operands[5] = x19;
          if (!scratch_operand (operands[5], E_SImode))
            return -1;
          x20 = XEXP (x18, 0);
          operands[6] = x20;
          if (!scratch_operand (operands[6], E_SImode)
              || pattern20 (x1) != 0)
            return -1;
          return 74; /* movmemsi_internal */

        case 4:
          if (pnum_clobbers == NULL
              || pattern2 (x1) != 0
              || pattern19 (x1) != 0
              || pattern20 (x1) != 0)
            return -1;
          *pnum_clobbers = 2;
          return 74; /* movmemsi_internal */

        default:
          return -1;
        }

    case RETURN:
      return 62; /* return_rte */

    case CALL:
      if (pnum_clobbers == NULL)
        return -1;
      x21 = XEXP (x1, 0);
      if (GET_CODE (x21) != MEM
          || GET_MODE (x21) != E_SImode)
        return -1;
      x22 = XEXP (x21, 0);
      operands[0] = x22;
      x23 = XEXP (x1, 1);
      operands[1] = x23;
      switch (GET_CODE (operands[0]))
        {
        case REG:
        case SUBREG:
          if (!register_operand (operands[0], E_SImode))
            return -1;
          *pnum_clobbers = 1;
          return 64; /* *call_via_reg */

        case CONST:
        case LABEL_REF:
        case SYMBOL_REF:
          if (!call_address_operand (operands[0], E_SImode))
            return -1;
          *pnum_clobbers = 1;
          return 65; /* *call_via_label */

        default:
          return -1;
        }

    case CONST_INT:
      if (XWINT (x1, 0) != 0L)
        return -1;
      return 68; /* nop */

    case UNSPEC_VOLATILE:
      if (XVECLEN (x1, 0) != 1
          || XINT (x1, 1) != 0)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      return 69; /* blockage */

    default:
      return -1;
    }
}

rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      x2 = XEXP (x1, 0);
      operands[0] = x2;
      x3 = XEXP (x1, 1);
      switch (GET_CODE (x3))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || !two_insn_const_operand (operands[1], E_SImode))
                return NULL;
              return gen_split_1 (insn, operands);

            case E_DImode:
              if (!move_dest_operand (operands[0], E_DImode)
                  || !move_double_src_operand (operands[1], E_DImode)
                  || !
#line 600 "../../gcc-8.1.1-20180626/gcc/config/m32r/m32r.md"
(reload_completed))
                return NULL;
              return gen_split_3 (insn, operands);

            case E_SFmode:
              if (!register_operand (operands[0], E_SFmode)
                  || !const_double_operand (operands[1], E_SFmode)
                  || !
#line 650 "../../gcc-8.1.1-20180626/gcc/config/m32r/m32r.md"
(reload_completed))
                return NULL;
              return gen_split_4 (insn, operands);

            case E_DFmode:
              if (!move_dest_operand (operands[0], E_DFmode)
                  || !move_double_src_operand (operands[1], E_DFmode)
                  || !
#line 693 "../../gcc-8.1.1-20180626/gcc/config/m32r/m32r.md"
(reload_completed))
                return NULL;
              return gen_split_5 (insn, operands);

            default:
              return NULL;
            }

        case CONST:
        case LABEL_REF:
        case SYMBOL_REF:
          operands[1] = x3;
          if (!seth_add3_operand (operands[1], E_SImode)
              || !register_operand (operands[0], E_SImode)
              || !
#line 474 "../../gcc-8.1.1-20180626/gcc/config/m32r/m32r.md"
(TARGET_ADDR32))
            return NULL;
          return gen_split_2 (insn, operands);

        case SIGN_EXTEND:
          x4 = XEXP (x3, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (!register_operand (operands[0], E_HImode)
                  || GET_MODE (x3) != E_HImode
                  || !register_operand (operands[1], E_QImode)
                  || !
#line 747 "../../gcc-8.1.1-20180626/gcc/config/m32r/m32r.md"
(reload_completed))
                return NULL;
              return gen_split_6 (insn, operands);

            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode)
                return NULL;
              switch (GET_MODE (operands[1]))
                {
                case E_QImode:
                  if (!register_operand (operands[1], E_QImode)
                      || !
#line 773 "../../gcc-8.1.1-20180626/gcc/config/m32r/m32r.md"
(reload_completed))
                    return NULL;
                  return gen_split_7 (insn, operands);

                case E_HImode:
                  if (!register_operand (operands[1], E_HImode)
                      || !
#line 798 "../../gcc-8.1.1-20180626/gcc/config/m32r/m32r.md"
(reload_completed))
                    return NULL;
                  return gen_split_8 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case AND:
          if (pattern10 (x3) != 0
              || !
#line 1048 "../../gcc-8.1.1-20180626/gcc/config/m32r/m32r.md"
(optimize_size && m32r_not_same_reg (operands[0], operands[1])))
            return NULL;
          return gen_split_11 (insn, operands);

        case IOR:
          if (pattern10 (x3) != 0
              || !
#line 1079 "../../gcc-8.1.1-20180626/gcc/config/m32r/m32r.md"
(optimize_size && m32r_not_same_reg (operands[0], operands[1])))
            return NULL;
          return gen_split_12 (insn, operands);

        case XOR:
          if (pattern10 (x3) != 0
              || !
#line 1110 "../../gcc-8.1.1-20180626/gcc/config/m32r/m32r.md"
(optimize_size && m32r_not_same_reg (operands[0], operands[1])))
            return NULL;
          return gen_split_13 (insn, operands);

        case ABS:
          switch (pattern6 (x3))
            {
            case 0:
              if (!
#line 2121 "../../gcc-8.1.1-20180626/gcc/config/m32r/m32r.md"
(reload_completed))
                return NULL;
              return gen_split_28 (insn, operands);

            case 1:
              if (!
#line 2141 "../../gcc-8.1.1-20180626/gcc/config/m32r/m32r.md"
(reload_completed))
                return NULL;
              return gen_split_29 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          x5 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x5) != SET
              || pattern11 (x1) != 0)
            return NULL;
          x6 = XEXP (x5, 1);
          switch (GET_CODE (x6))
            {
            case PLUS:
              if (pattern17 (x6, E_DImode) != 0
                  || !
#line 855 "../../gcc-8.1.1-20180626/gcc/config/m32r/m32r.md"
(reload_completed))
                return NULL;
              return gen_split_9 (insn, operands);

            case MINUS:
              if (pattern17 (x6, E_DImode) != 0
                  || !
#line 925 "../../gcc-8.1.1-20180626/gcc/config/m32r/m32r.md"
(reload_completed))
                return NULL;
              return gen_split_10 (insn, operands);

            case EQ:
              if (GET_MODE (x6) != E_SImode
                  || !register_operand (operands[0], E_SImode))
                return NULL;
              x7 = XEXP (x6, 0);
              operands[1] = x7;
              if (!register_operand (operands[1], E_SImode))
                return NULL;
              x8 = XEXP (x6, 1);
              operands[2] = x8;
              if (reg_or_zero_operand (operands[2], E_SImode)
                  && 
#line 1524 "../../gcc-8.1.1-20180626/gcc/config/m32r/m32r.md"
(TARGET_M32RX || TARGET_M32R2))
                return gen_split_14 (insn, operands);
              if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
                  || !
#line 1547 "../../gcc-8.1.1-20180626/gcc/config/m32r/m32r.md"
(TARGET_M32R))
                return NULL;
              return gen_split_15 (insn, operands);

            case LT:
              if (pattern18 (x6) != 0)
                return NULL;
              return gen_split_18 (insn, operands);

            case LE:
              if (pattern17 (x6, E_SImode) != 0)
                return NULL;
              if (
#line 1679 "../../gcc-8.1.1-20180626/gcc/config/m32r/m32r.md"
(!optimize_size))
                return gen_split_19 (insn, operands);
              if (!
#line 1697 "../../gcc-8.1.1-20180626/gcc/config/m32r/m32r.md"
(optimize_size))
                return NULL;
              return gen_split_20 (insn, operands);

            case GE:
              if (pattern18 (x6) != 0)
                return NULL;
              if (
#line 1725 "../../gcc-8.1.1-20180626/gcc/config/m32r/m32r.md"
(!optimize_size))
                return gen_split_21 (insn, operands);
              if (!
#line 1743 "../../gcc-8.1.1-20180626/gcc/config/m32r/m32r.md"
(optimize_size))
                return NULL;
              return gen_split_22 (insn, operands);

            case LTU:
              if (pattern18 (x6) != 0)
                return NULL;
              return gen_split_23 (insn, operands);

            case LEU:
              if (pattern17 (x6, E_SImode) != 0)
                return NULL;
              if (
#line 1794 "../../gcc-8.1.1-20180626/gcc/config/m32r/m32r.md"
(!optimize_size))
                return gen_split_24 (insn, operands);
              if (!
#line 1812 "../../gcc-8.1.1-20180626/gcc/config/m32r/m32r.md"
(optimize_size))
                return NULL;
              return gen_split_25 (insn, operands);

            case GEU:
              if (pattern18 (x6) != 0)
                return NULL;
              if (
#line 1840 "../../gcc-8.1.1-20180626/gcc/config/m32r/m32r.md"
(!optimize_size))
                return gen_split_26 (insn, operands);
              if (!
#line 1858 "../../gcc-8.1.1-20180626/gcc/config/m32r/m32r.md"
(optimize_size))
                return NULL;
              return gen_split_27 (insn, operands);

            default:
              return NULL;
            }

        case 3:
          x5 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x5) != SET)
            return NULL;
          switch (pattern8 (x1))
            {
            case 0:
              if (!
#line 1578 "../../gcc-8.1.1-20180626/gcc/config/m32r/m32r.md"
(TARGET_M32R && reload_completed))
                return NULL;
              return gen_split_16 (insn, operands);

            case 1:
              if (!
#line 1631 "../../gcc-8.1.1-20180626/gcc/config/m32r/m32r.md"
(reload_completed))
                return NULL;
              return gen_split_17 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

rtx_insn *
peephole2_insns (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  return NULL;
}
