/* Generated automatically by the program `genopinit'
   from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "tree.h"
#include "rtl.h"
#include "alias.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "memmodel.h"
#include "tm_p.h"
#include "flags.h"
#include "insn-config.h"
#include "expmed.h"
#include "dojump.h"
#include "explow.h"
#include "emit-rtl.h"
#include "stmt.h"
#include "expr.h"
#include "insn-codes.h"
#include "optabs.h"

struct optab_pat {
  unsigned scode;
  enum insn_code icode;
};

static const struct optab_pat pats[NUM_OPTAB_PATTERNS] = {
  { 0x010406, CODE_FOR_extendqisi2 },
  { 0x010407, CODE_FOR_extendqidi2 },
  { 0x010506, CODE_FOR_extendhisi2 },
  { 0x010507, CODE_FOR_extendhidi2 },
  { 0x010607, CODE_FOR_extendsidi2 },
  { 0x020704, CODE_FOR_truncdiqi2 },
  { 0x020705, CODE_FOR_truncdihi2 },
  { 0x020706, CODE_FOR_truncdisi2 },
  { 0x030406, CODE_FOR_zero_extendqisi2 },
  { 0x030407, CODE_FOR_zero_extendqidi2 },
  { 0x030506, CODE_FOR_zero_extendhisi2 },
  { 0x030507, CODE_FOR_zero_extendhidi2 },
  { 0x030607, CODE_FOR_zero_extendsidi2 },
  { 0x060622, CODE_FOR_floatsisf2 },
  { 0x060623, CODE_FOR_floatsidf2 },
  { 0x070622, CODE_FOR_floatunssisf2 },
  { 0x070623, CODE_FOR_floatunssidf2 },
  { 0x120607, CODE_FOR_mulsidi3 },
  { 0x130607, CODE_FOR_umulsidi3 },
  { 0x140607, CODE_FOR_usmulsidi3 },
  { 0x150607, CODE_FOR_maddsidi4 },
  { 0x160607, CODE_FOR_umaddsidi4 },
  { 0x2d0006, CODE_FOR_addsi3 },
  { 0x2d0007, CODE_FOR_adddi3 },
  { 0x2d0022, CODE_FOR_addsf3 },
  { 0x2d0023, CODE_FOR_adddf3 },
  { 0x2d0037, CODE_FOR_addv8qi3 },
  { 0x2d0038, CODE_FOR_addv4hi3 },
  { 0x2d0039, CODE_FOR_addv2si3 },
  { 0x310006, CODE_FOR_subsi3 },
  { 0x310007, CODE_FOR_subdi3 },
  { 0x310022, CODE_FOR_subsf3 },
  { 0x310023, CODE_FOR_subdf3 },
  { 0x310037, CODE_FOR_subv8qi3 },
  { 0x310038, CODE_FOR_subv4hi3 },
  { 0x310039, CODE_FOR_subv2si3 },
  { 0x350006, CODE_FOR_mulsi3 },
  { 0x350007, CODE_FOR_muldi3 },
  { 0x350022, CODE_FOR_mulsf3 },
  { 0x350023, CODE_FOR_muldf3 },
  { 0x350037, CODE_FOR_mulv8qi3 },
  { 0x350038, CODE_FOR_mulv4hi3 },
  { 0x390006, CODE_FOR_divsi3 },
  { 0x3c0006, CODE_FOR_udivsi3 },
  { 0x430006, CODE_FOR_andsi3 },
  { 0x430007, CODE_FOR_anddi3 },
  { 0x430037, CODE_FOR_andv8qi3 },
  { 0x430038, CODE_FOR_andv4hi3 },
  { 0x430039, CODE_FOR_andv2si3 },
  { 0x440006, CODE_FOR_iorsi3 },
  { 0x440007, CODE_FOR_iordi3 },
  { 0x440037, CODE_FOR_iorv8qi3 },
  { 0x440038, CODE_FOR_iorv4hi3 },
  { 0x440039, CODE_FOR_iorv2si3 },
  { 0x450006, CODE_FOR_xorsi3 },
  { 0x450007, CODE_FOR_xordi3 },
  { 0x450037, CODE_FOR_xorv8qi3 },
  { 0x450038, CODE_FOR_xorv4hi3 },
  { 0x450039, CODE_FOR_xorv2si3 },
  { 0x460006, CODE_FOR_ashlsi3 },
  { 0x460007, CODE_FOR_ashldi3 },
  { 0x460037, CODE_FOR_ashlv8qi3 },
  { 0x460038, CODE_FOR_ashlv4hi3 },
  { 0x460039, CODE_FOR_ashlv2si3 },
  { 0x490006, CODE_FOR_ashrsi3 },
  { 0x490007, CODE_FOR_ashrdi3 },
  { 0x490037, CODE_FOR_ashrv8qi3 },
  { 0x490038, CODE_FOR_ashrv4hi3 },
  { 0x490039, CODE_FOR_ashrv2si3 },
  { 0x4a0006, CODE_FOR_lshrsi3 },
  { 0x4a0007, CODE_FOR_lshrdi3 },
  { 0x4a0037, CODE_FOR_lshrv8qi3 },
  { 0x4a0038, CODE_FOR_lshrv4hi3 },
  { 0x4a0039, CODE_FOR_lshrv2si3 },
  { 0x4b0007, CODE_FOR_rotldi3 },
  { 0x520038, CODE_FOR_sminv4hi3 },
  { 0x530038, CODE_FOR_smaxv4hi3 },
  { 0x540037, CODE_FOR_uminv8qi3 },
  { 0x550037, CODE_FOR_umaxv8qi3 },
  { 0x560006, CODE_FOR_negsi2 },
  { 0x560007, CODE_FOR_negdi2 },
  { 0x5c0006, CODE_FOR_one_cmplsi2 },
  { 0x5c0007, CODE_FOR_one_cmpldi2 },
  { 0x5c0037, CODE_FOR_one_cmplv8qi2 },
  { 0x5c0038, CODE_FOR_one_cmplv4hi2 },
  { 0x5c0039, CODE_FOR_one_cmplv2si2 },
  { 0x5d0006, CODE_FOR_bswapsi2 },
  { 0x5d0007, CODE_FOR_bswapdi2 },
  { 0x5f0006, CODE_FOR_clzsi2 },
  { 0x5f0007, CODE_FOR_clzdi2 },
  { 0x600006, CODE_FOR_ctzsi2 },
  { 0x600007, CODE_FOR_ctzdi2 },
  { 0x620006, CODE_FOR_popcountsi2 },
  { 0x620007, CODE_FOR_popcountdi2 },
  { 0x630006, CODE_FOR_paritysi2 },
  { 0x630007, CODE_FOR_paritydi2 },
  { 0x7d0004, CODE_FOR_movqi },
  { 0x7d0005, CODE_FOR_movhi },
  { 0x7d0006, CODE_FOR_movsi },
  { 0x7d0007, CODE_FOR_movdi },
  { 0x7d0022, CODE_FOR_movsf },
  { 0x7d0023, CODE_FOR_movdf },
  { 0x7d0037, CODE_FOR_movv8qi },
  { 0x7d0038, CODE_FOR_movv4hi },
  { 0x7d0039, CODE_FOR_movv2si },
  { 0x7e0004, CODE_FOR_movstrictqi },
  { 0x7e0005, CODE_FOR_movstricthi },
  { 0x7e0006, CODE_FOR_movstrictsi },
  { 0x7f0037, CODE_FOR_movmisalignv8qi },
  { 0x7f0038, CODE_FOR_movmisalignv4hi },
  { 0x7f0039, CODE_FOR_movmisalignv2si },
  { 0x8a0006, CODE_FOR_cbranchsi4 },
  { 0x8a0007, CODE_FOR_cbranchdi4 },
  { 0x8a0022, CODE_FOR_cbranchsf4 },
  { 0x8a0023, CODE_FOR_cbranchdf4 },
  { 0x8e0006, CODE_FOR_movsicc },
  { 0x8e0007, CODE_FOR_movdicc },
  { 0x990006, CODE_FOR_cstoresi4 },
  { 0x990007, CODE_FOR_cstoredi4 },
  { 0x990022, CODE_FOR_cstoresf4 },
  { 0x990023, CODE_FOR_cstoredf4 },
  { 0xa30006, CODE_FOR_smulsi3_highpart },
  { 0xa30007, CODE_FOR_smuldi3_highpart },
  { 0xa40006, CODE_FOR_umulsi3_highpart },
  { 0xa40007, CODE_FOR_umuldi3_highpart },
  { 0xe60039, CODE_FOR_vec_pack_ssat_v2si },
  { 0xe70038, CODE_FOR_vec_pack_trunc_v4hi },
  { 0xe90038, CODE_FOR_vec_pack_usat_v4hi },
  { 0xf80035, CODE_FOR_vec_widen_smult_lo_v4qi },
  { 0xfe0037, CODE_FOR_vec_widen_umult_lo_v8qi },
  { 0x1100006, CODE_FOR_atomic_compare_and_swapsi },
  { 0x1100007, CODE_FOR_atomic_compare_and_swapdi },
  { 0x1110006, CODE_FOR_atomic_exchangesi },
  { 0x1110007, CODE_FOR_atomic_exchangedi },
  { 0x1120006, CODE_FOR_atomic_fetch_addsi },
  { 0x1120007, CODE_FOR_atomic_fetch_adddi },
  { 0x1130006, CODE_FOR_atomic_fetch_andsi },
  { 0x1130007, CODE_FOR_atomic_fetch_anddi },
  { 0x1150006, CODE_FOR_atomic_fetch_orsi },
  { 0x1150007, CODE_FOR_atomic_fetch_ordi },
  { 0x1160006, CODE_FOR_atomic_fetch_subsi },
  { 0x1160007, CODE_FOR_atomic_fetch_subdi },
};

void
init_all_optabs (struct target_optabs *optabs)
{
  bool *ena = optabs->pat_enable;
  ena[0] = HAVE_extendqisi2;
  ena[1] = HAVE_extendqidi2;
  ena[2] = HAVE_extendhisi2;
  ena[3] = HAVE_extendhidi2;
  ena[4] = HAVE_extendsidi2;
  ena[5] = HAVE_truncdiqi2;
  ena[6] = HAVE_truncdihi2;
  ena[7] = HAVE_truncdisi2;
  ena[8] = HAVE_zero_extendqisi2;
  ena[9] = HAVE_zero_extendqidi2;
  ena[10] = HAVE_zero_extendhisi2;
  ena[11] = HAVE_zero_extendhidi2;
  ena[12] = HAVE_zero_extendsidi2;
  ena[13] = HAVE_floatsisf2;
  ena[14] = HAVE_floatsidf2;
  ena[15] = HAVE_floatunssisf2;
  ena[16] = HAVE_floatunssidf2;
  ena[17] = HAVE_mulsidi3;
  ena[18] = HAVE_umulsidi3;
  ena[19] = HAVE_usmulsidi3;
  ena[20] = HAVE_maddsidi4;
  ena[21] = HAVE_umaddsidi4;
  ena[22] = HAVE_addsi3;
  ena[23] = HAVE_adddi3;
  ena[24] = HAVE_addsf3;
  ena[25] = HAVE_adddf3;
  ena[26] = HAVE_addv8qi3;
  ena[27] = HAVE_addv4hi3;
  ena[28] = HAVE_addv2si3;
  ena[29] = HAVE_subsi3;
  ena[30] = HAVE_subdi3;
  ena[31] = HAVE_subsf3;
  ena[32] = HAVE_subdf3;
  ena[33] = HAVE_subv8qi3;
  ena[34] = HAVE_subv4hi3;
  ena[35] = HAVE_subv2si3;
  ena[36] = HAVE_mulsi3;
  ena[37] = HAVE_muldi3;
  ena[38] = HAVE_mulsf3;
  ena[39] = HAVE_muldf3;
  ena[40] = HAVE_mulv8qi3;
  ena[41] = HAVE_mulv4hi3;
  ena[42] = HAVE_divsi3;
  ena[43] = HAVE_udivsi3;
  ena[44] = HAVE_andsi3;
  ena[45] = HAVE_anddi3;
  ena[46] = HAVE_andv8qi3;
  ena[47] = HAVE_andv4hi3;
  ena[48] = HAVE_andv2si3;
  ena[49] = HAVE_iorsi3;
  ena[50] = HAVE_iordi3;
  ena[51] = HAVE_iorv8qi3;
  ena[52] = HAVE_iorv4hi3;
  ena[53] = HAVE_iorv2si3;
  ena[54] = HAVE_xorsi3;
  ena[55] = HAVE_xordi3;
  ena[56] = HAVE_xorv8qi3;
  ena[57] = HAVE_xorv4hi3;
  ena[58] = HAVE_xorv2si3;
  ena[59] = HAVE_ashlsi3;
  ena[60] = HAVE_ashldi3;
  ena[61] = HAVE_ashlv8qi3;
  ena[62] = HAVE_ashlv4hi3;
  ena[63] = HAVE_ashlv2si3;
  ena[64] = HAVE_ashrsi3;
  ena[65] = HAVE_ashrdi3;
  ena[66] = HAVE_ashrv8qi3;
  ena[67] = HAVE_ashrv4hi3;
  ena[68] = HAVE_ashrv2si3;
  ena[69] = HAVE_lshrsi3;
  ena[70] = HAVE_lshrdi3;
  ena[71] = HAVE_lshrv8qi3;
  ena[72] = HAVE_lshrv4hi3;
  ena[73] = HAVE_lshrv2si3;
  ena[74] = HAVE_rotldi3;
  ena[75] = HAVE_sminv4hi3;
  ena[76] = HAVE_smaxv4hi3;
  ena[77] = HAVE_uminv8qi3;
  ena[78] = HAVE_umaxv8qi3;
  ena[79] = HAVE_negsi2;
  ena[80] = HAVE_negdi2;
  ena[81] = HAVE_one_cmplsi2;
  ena[82] = HAVE_one_cmpldi2;
  ena[83] = HAVE_one_cmplv8qi2;
  ena[84] = HAVE_one_cmplv4hi2;
  ena[85] = HAVE_one_cmplv2si2;
  ena[86] = HAVE_bswapsi2;
  ena[87] = HAVE_bswapdi2;
  ena[88] = HAVE_clzsi2;
  ena[89] = HAVE_clzdi2;
  ena[90] = HAVE_ctzsi2;
  ena[91] = HAVE_ctzdi2;
  ena[92] = HAVE_popcountsi2;
  ena[93] = HAVE_popcountdi2;
  ena[94] = HAVE_paritysi2;
  ena[95] = HAVE_paritydi2;
  ena[96] = HAVE_movqi;
  ena[97] = HAVE_movhi;
  ena[98] = HAVE_movsi;
  ena[99] = HAVE_movdi;
  ena[100] = HAVE_movsf;
  ena[101] = HAVE_movdf;
  ena[102] = HAVE_movv8qi;
  ena[103] = HAVE_movv4hi;
  ena[104] = HAVE_movv2si;
  ena[105] = HAVE_movstrictqi;
  ena[106] = HAVE_movstricthi;
  ena[107] = HAVE_movstrictsi;
  ena[108] = HAVE_movmisalignv8qi;
  ena[109] = HAVE_movmisalignv4hi;
  ena[110] = HAVE_movmisalignv2si;
  ena[111] = HAVE_cbranchsi4;
  ena[112] = HAVE_cbranchdi4;
  ena[113] = HAVE_cbranchsf4;
  ena[114] = HAVE_cbranchdf4;
  ena[115] = HAVE_movsicc;
  ena[116] = HAVE_movdicc;
  ena[117] = HAVE_cstoresi4;
  ena[118] = HAVE_cstoredi4;
  ena[119] = HAVE_cstoresf4;
  ena[120] = HAVE_cstoredf4;
  ena[121] = HAVE_smulsi3_highpart;
  ena[122] = HAVE_smuldi3_highpart;
  ena[123] = HAVE_umulsi3_highpart;
  ena[124] = HAVE_umuldi3_highpart;
  ena[125] = HAVE_vec_pack_ssat_v2si;
  ena[126] = HAVE_vec_pack_trunc_v4hi;
  ena[127] = HAVE_vec_pack_usat_v4hi;
  ena[128] = HAVE_vec_widen_smult_lo_v4qi;
  ena[129] = HAVE_vec_widen_umult_lo_v8qi;
  ena[130] = HAVE_atomic_compare_and_swapsi;
  ena[131] = HAVE_atomic_compare_and_swapdi;
  ena[132] = HAVE_atomic_exchangesi;
  ena[133] = HAVE_atomic_exchangedi;
  ena[134] = HAVE_atomic_fetch_addsi;
  ena[135] = HAVE_atomic_fetch_adddi;
  ena[136] = HAVE_atomic_fetch_andsi;
  ena[137] = HAVE_atomic_fetch_anddi;
  ena[138] = HAVE_atomic_fetch_orsi;
  ena[139] = HAVE_atomic_fetch_ordi;
  ena[140] = HAVE_atomic_fetch_subsi;
  ena[141] = HAVE_atomic_fetch_subdi;
}

static int
lookup_handler (unsigned scode)
{
  int l = 0, h = ARRAY_SIZE (pats), m;
  while (h > l)
    {
      m = (h + l) / 2;
      if (scode == pats[m].scode)
        return m;
      else if (scode < pats[m].scode)
        h = m;
      else
        l = m + 1;
    }
  return -1;
}

enum insn_code
raw_optab_handler (unsigned scode)
{
  int i = lookup_handler (scode);
  return (i >= 0 && this_fn_optabs->pat_enable[i]
          ? pats[i].icode : CODE_FOR_nothing);
}

bool
swap_optab_enable (optab op, machine_mode m, bool set)
{
  unsigned scode = (op << 16) | m;
  int i = lookup_handler (scode);
  if (i >= 0)
    {
      bool ret = this_fn_optabs->pat_enable[i];
      this_fn_optabs->pat_enable[i] = set;
      return ret;
    }
  else
    {
      gcc_assert (!set);
      return false;
    }
}

const struct convert_optab_libcall_d convlib_def[NUM_CONVLIB_OPTABS] = {
  { "extend", gen_extend_conv_libfunc },
  { "trunc", gen_trunc_conv_libfunc },
  { NULL, NULL },
  { "fix", gen_fp_to_int_conv_libfunc },
  { "fixuns", gen_fp_to_int_conv_libfunc },
  { "float", gen_int_to_fp_conv_libfunc },
  { NULL, gen_ufloat_conv_libfunc },
  { "lrint", gen_int_to_fp_nondecimal_conv_libfunc },
  { "lround", gen_int_to_fp_nondecimal_conv_libfunc },
  { "lfloor", gen_int_to_fp_nondecimal_conv_libfunc },
  { "lceil", gen_int_to_fp_nondecimal_conv_libfunc },
  { "fract", gen_fract_conv_libfunc },
  { "fractuns", gen_fractuns_conv_libfunc },
  { "satfract", gen_satfract_conv_libfunc },
  { "satfractuns", gen_satfractuns_conv_libfunc },
};

const struct optab_libcall_d normlib_def[NUM_NORMLIB_OPTABS] = {
  { '3', "add", gen_int_fp_fixed_libfunc },
  { '3', "add", gen_intv_fp_libfunc },
  { '3', "ssadd", gen_signed_fixed_libfunc },
  { '3', "usadd", gen_unsigned_fixed_libfunc },
  { '3', "sub", gen_int_fp_fixed_libfunc },
  { '3', "sub", gen_intv_fp_libfunc },
  { '3', "sssub", gen_signed_fixed_libfunc },
  { '3', "ussub", gen_unsigned_fixed_libfunc },
  { '3', "mul", gen_int_fp_fixed_libfunc },
  { '3', "mul", gen_intv_fp_libfunc },
  { '3', "ssmul", gen_signed_fixed_libfunc },
  { '3', "usmul", gen_unsigned_fixed_libfunc },
  { '3', "div", gen_int_fp_signed_fixed_libfunc },
  { '3', "divv", gen_int_libfunc },
  { '3', "ssdiv", gen_signed_fixed_libfunc },
  { '3', "udiv", gen_int_unsigned_fixed_libfunc },
  { '3', "usdiv", gen_unsigned_fixed_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '3', "mod", gen_int_libfunc },
  { '3', "umod", gen_int_libfunc },
  { '2', "ftrunc", gen_fp_libfunc },
  { '3', "and", gen_int_libfunc },
  { '3', "ior", gen_int_libfunc },
  { '3', "xor", gen_int_libfunc },
  { '3', "ashl", gen_int_fixed_libfunc },
  { '3', "ssashl", gen_signed_fixed_libfunc },
  { '3', "usashl", gen_unsigned_fixed_libfunc },
  { '3', "ashr", gen_int_signed_fixed_libfunc },
  { '3', "lshr", gen_int_unsigned_fixed_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '3', "min", gen_int_fp_libfunc },
  { '3', "max", gen_int_fp_libfunc },
  { '3', "umin", gen_int_libfunc },
  { '3', "umax", gen_int_libfunc },
  { '2', "neg", gen_int_fp_fixed_libfunc },
  { '2', "neg", gen_intv_fp_libfunc },
  { '2', "ssneg", gen_signed_fixed_libfunc },
  { '2', "usneg", gen_unsigned_fixed_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '2', "one_cmpl", gen_int_libfunc },
  { '\0', NULL, NULL },
  { '2', "ffs", gen_int_libfunc },
  { '2', "clz", gen_int_libfunc },
  { '2', "ctz", gen_int_libfunc },
  { '2', "clrsb", gen_int_libfunc },
  { '2', "popcount", gen_int_libfunc },
  { '2', "parity", gen_int_libfunc },
  { '2', "cmp", gen_int_fp_fixed_libfunc },
  { '2', "ucmp", gen_int_libfunc },
  { '2', "eq", gen_fp_libfunc },
  { '2', "ne", gen_fp_libfunc },
  { '2', "gt", gen_fp_libfunc },
  { '2', "ge", gen_fp_libfunc },
  { '2', "lt", gen_fp_libfunc },
  { '2', "le", gen_fp_libfunc },
  { '2', "unord", gen_fp_libfunc },
  { '2', "powi", gen_fp_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
};

enum rtx_code const optab_to_code_[NUM_OPTABS] = {
  UNKNOWN,
  SIGN_EXTEND,
  TRUNCATE,
  ZERO_EXTEND,
  FIX,
  UNSIGNED_FIX,
  FLOAT,
  UNSIGNED_FLOAT,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  FRACT_CONVERT,
  UNSIGNED_FRACT_CONVERT,
  SAT_FRACT,
  UNSIGNED_SAT_FRACT,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  PLUS,
  PLUS,
  SS_PLUS,
  US_PLUS,
  MINUS,
  MINUS,
  SS_MINUS,
  US_MINUS,
  MULT,
  MULT,
  SS_MULT,
  US_MULT,
  DIV,
  DIV,
  SS_DIV,
  UDIV,
  US_DIV,
  UNKNOWN,
  UNKNOWN,
  MOD,
  UMOD,
  UNKNOWN,
  AND,
  IOR,
  XOR,
  ASHIFT,
  SS_ASHIFT,
  US_ASHIFT,
  ASHIFTRT,
  LSHIFTRT,
  ROTATE,
  ROTATERT,
  ASHIFT,
  ASHIFTRT,
  LSHIFTRT,
  ROTATE,
  ROTATERT,
  SMIN,
  SMAX,
  UMIN,
  UMAX,
  NEG,
  NEG,
  SS_NEG,
  US_NEG,
  ABS,
  ABS,
  NOT,
  BSWAP,
  FFS,
  CLZ,
  CTZ,
  CLRSB,
  POPCOUNT,
  PARITY,
  UNKNOWN,
  UNKNOWN,
  EQ,
  NE,
  GT,
  GE,
  LT,
  LE,
  UNORDERED,
  UNKNOWN,
  SQRT,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  SET,
  STRICT_LOW_PART,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  COMPARE,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  FMA,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  VEC_DUPLICATE,
  VEC_SERIES,
  UNKNOWN,
};

const optab code_to_optab_[NUM_RTX_CODE] = {
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  mov_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  movstrict_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  cbranch_optab,
  add_optab,
  sub_optab,
  neg_optab,
  smul_optab,
  ssmul_optab,
  usmul_optab,
  sdiv_optab,
  ssdiv_optab,
  usdiv_optab,
  smod_optab,
  udiv_optab,
  umod_optab,
  and_optab,
  ior_optab,
  xor_optab,
  one_cmpl_optab,
  ashl_optab,
  rotl_optab,
  ashr_optab,
  lshr_optab,
  rotr_optab,
  smin_optab,
  smax_optab,
  umin_optab,
  umax_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  ne_optab,
  eq_optab,
  ge_optab,
  gt_optab,
  le_optab,
  lt_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unord_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  abs_optab,
  sqrt_optab,
  bswap_optab,
  ffs_optab,
  clrsb_optab,
  clz_optab,
  ctz_optab,
  popcount_optab,
  parity_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  vec_duplicate_optab,
  vec_series_optab,
  ssadd_optab,
  usadd_optab,
  sssub_optab,
  ssneg_optab,
  usneg_optab,
  unknown_optab,
  ssashl_optab,
  usashl_optab,
  ussub_optab,
  unknown_optab,
  unknown_optab,
  fma_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
};

